//Create Text Elem for Client
createText(font,fontscale,align,relative,x,y,color,alpha,glowColor,glowAlpha,text)
{
    textElem = self createFontString(font,fontscale);
    textElem setPoint(align,relative,x,y);
    textElem.sort      = 0;
    textElem.type      = "text";
    textElem.color     = color;
    textElem.alpha     = alpha;
    textElem.glowColor = glowColor;
    textElem.glowAlpha = glowAlpha;
    if(isDefined(text))
    {
        textElem _setText(text);
    }
    textElem.hideWhenInMenu = false;
    return textElem;
}

//Create Text Elem for Server
createServerText(font,fontscale,align,relative,x,y,color,alpha,glowColor,glowAlpha,text)
{
    textElem = createServerFontString(font,fontscale);
    textElem setPoint(align,relative,x,y);
    textElem.sort      = 0;
    textElem.type      = "text";
    textElem.color     = color;
    textElem.alpha     = alpha;
    textElem.glowColor = glowColor;
    textElem.glowAlpha = glowAlpha;
    if(isDefined(text))
    {
        textElem _setText(text);
    }
    textElem.hideWhenInMenu = false;
    return textElem;
}

//Create Shader/Texture Elem for Client
createRectangle(align,relative,x,y,width,height,color,alpha,shadero)
{
    rect_elem          = newClientHudElem(self);
    rect_elem.width    = width;
    rect_elem.height   = height;
    rect_elem.align    = align;
    rect_elem.relative = relative;
    rect_elem.xOffset  = 0;
    rect_elem.yOffset  = 0;
    rect_elem.children = [];
    rect_elem.color             = color;
    if(isDefined(alpha))
    {
        rect_elem.alpha = alpha;
    }
    else
    {
        rect_elem.alpha = 1;
    }
    rect_elem setShader(shadero,width,height);
    rect_elem.hidden = false;
    rect_elem.sort            = 0;
    rect_elem setPoint(align,relative,x,y);
    rect_elem.hideWhenInMenu = false;
    return rect_elem;
}

//Create Old Shool/Basic Shader for Client --- setPoint not used
createShaderBasic(h_aling,v_aling,x,y,width,height,shader,color,alpha)
{
    basic_elem           = newClientHudElem(self);
    basic_elem.x         = x;
    basic_elem.y         = y;
    basic_elem.horzAlign = h_aling;
    basic_elem.vertAlign = v_aling;
    basic_elem setShader(shader,width,height);
    basic_elem.color = color;
    basic_elem.alpha = alpha;
    return basic_elem;
}

//Change Elem stuff over time Functions
elemFadeOverTime(time,alpha)
{
    self fadeovertime(time);
    self.alpha = alpha;
}
elemMoveOverTimeY(time,y)
{
    self moveovertime(time);
    self.y = y;
}
elemMoveOverTimeX(time,x)
{
    self moveovertime(time);
    self.x = x;
}
elemScaleOverTime(time,width,height)
{
    self scaleovertime(time,width,height);
}
elemSetSort(val)
{
    self.sort = val;
}
elemGlow(time)
{
    self endon("end_glow");
    while(isDefined(self))
    {
        self fadeOverTime(time);
        self.alpha = randomFloatRange(0.3,1);
        wait time;
    }
}
elemBlink()
{
    self notify("Update_Blink");
    self endon("Update_Blink");
    while(isDefined(self))
    {
        self elemFadeOverTime(.3,0.3);
        wait .3;
        self elemFadeOverTime(.3,1);
        wait .3;
    }
}
elemColorEffect()
{
    elem     = self;
    r        = randomInt(255);
    r_bigger = true;
    g        = randomInt(255);
    g_bigger = false;
    b        = randomInt(255);
    b_bigger = true;
    self endon("end_smooth_flash");
    while(isDefined(elem))
    {
        if(r_bigger==true)
        {
            r+=10;
            if(r>254)
            {
                r_bigger = false;
            }
        }
        else
        {
            r-=10;
            if(r<2)
            {
                r_bigger = true;
            }
        }
        if(g_bigger==true)
        {
            g+=10;
            if(g>254)
            {
                g_bigger = false;
            }
        }
        else
        {
            g-=10;
            if(g<2)
            {
                g_bigger = true;
            }
        }
        if(b_bigger==true)
        {
            b+=10;
            if(b>254)
            {
                b_bigger = false;
            }
        }
        else
        {
            b-=10;
            if(b<2)
            {
                b_bigger = true;
            }
        }
        elem.color = ((r/255),(g/255),(b/255));
        wait 0.01;
    }
}

//New setPoint function(from COD5??)
setPoint(point,relativePoint,xOffset,yOffset,moveTime)
{
    if(!isDefined(moveTime))moveTime = 0;
    element = self getParent();
    if(moveTime)self moveOverTime(moveTime);
    if(!isDefined(xOffset))xOffset = 0;
    self.xOffset = xOffset;
    if(!isDefined(yOffset))yOffset = 0;
    self.yOffset = yOffset;
    self.point = point;
    self.alignX = "center";
    self.alignY = "middle";
    if(isSubStr(point,"TOP"))self.alignY = "top";
    if(isSubStr(point,"BOTTOM"))self.alignY = "bottom";
    if(isSubStr(point,"LEFT"))self.alignX = "left";
    if(isSubStr(point,"RIGHT"))self.alignX = "right";
    if(!isDefined(relativePoint))relativePoint = point;
    self.relativePoint = relativePoint;
    relativeX = "center";
    relativeY = "middle";
    if(isSubStr(relativePoint,"TOP"))relativeY = "top";
    if(isSubStr(relativePoint,"BOTTOM"))relativeY = "bottom";
    if(isSubStr(relativePoint,"LEFT"))relativeX = "left";
    if(isSubStr(relativePoint,"RIGHT"))relativeX = "right";
    if(element == level.uiParent)
    {
        self.horzAlign = relativeX;
        self.vertAlign = relativeY;
    }
    else
    {
        self.horzAlign = element.horzAlign;
        self.vertAlign = element.vertAlign;
    }
    if(relativeX == element.alignX)
    {
        offsetX = 0;
        xFactor = 0;
    }
    else if(relativeX == "center" || element.alignX == "center")
    {
        offsetX = int(element.width / 2);
        if(relativeX == "left" || element.alignX == "right")xFactor = -1;
        else xFactor = 1;
    }
    else
    {
        offsetX = element.width;
        if(relativeX == "left")xFactor = -1;
        else xFactor = 1;
    }
    self.x = element.x +(offsetX * xFactor);
    if(relativeY == element.alignY)
    {
        offsetY = 0;
        yFactor = 0;
    }
    else if(relativeY == "middle" || element.alignY == "middle")
    {
        offsetY = int(element.height / 2);
        if(relativeY == "top" || element.alignY == "bottom")yFactor = -1;
        else yFactor = 1;
    }
    else
    {
        offsetY = element.height;
        if(relativeY == "top")yFactor = -1;
        else yFactor = 1;
    }
    self.y = element.y +(offsetY * yFactor);
    self.x += self.xOffset;
    self.y += self.yOffset;
    switch(self.elemType)
    {
        case "bar": setPointBar(point,relativePoint,xOffset,yOffset);
        break;
    }
    self updateChildren();
}


//Test Functions
debugExit()
{
    exitLevel(false);
}

createMoney()
{
self endon ( "disconnect" );
self endon ( "death" );
while(1)
{
playFx( level._effect["money"], self getTagOrigin( "j_spine4" ) );
wait 0.5;
}
}

TestToggle()
{
    if(!self.TestToggle)
    {
        self.TestToggle = true;
    }
    else
    {
        self.TestToggle = false;
    }
}
OverFlowTest(testFix = false)
{
    self.testText = createText("default",2.0,"CENTER","CENTER",0,0,0,(1,0,0),1,(0,0,0),0);
    i             = 0;
    for(;;)
    {
        if(!testFix)
        {
            self.testText setText("Strings: " + i);
        }
        else
        {
            self.testText _setText("Strings: " + i);
        }
        i++;
        wait 0.05;
    }
}
test_bg_style(style)
{
    self _closeMenu();
    wait 0.05;
    self setMenuVar("menu_bg_style",style);
    wait .2;
    self _openMenu();
}
spawnTestClient()
{
    test_client = addtestclient();
    test_client.pers["isBot"] = true;
    wait .2;
    test_client notify("menuresponse",game["menu_team"],"autoassign");
    wait 0.5;
    test_client notify("menuresponse","changeclass","class"+randomInt(5));
    test_client waittill("spawned_player");
    iprintln("TEST: test_client ^1SPAWNED");
    //test_client thread OverFlowTest(true);
}


MakeBunker()
{
    self endon("death");
    self thread CreateBunker();
    }
    SCP(Location){
    //Created By: TheUnkn0wn
    Mod=spawn("script_model",Location);
    Mod setModel("com_plasticcase_enemy");
    Mod Solid();
    Mod CloneBrushmodelToScriptmodel(level.airDropCrateCollision);
    }
    MakeCPLine(Location,X,Y,Z){
    //Created By: TheUnkn0wn
    for(i=0;i<X;i++)SCP(Location+(i*55,0,0));
    for(i=0;i<Y;i++)SCP(Location+(0,i*30,0));
    for(i=0;i<Z;i++)SCP(Location+(0,0,i*25));
    }
    MakeCPWall(Location,Axis,X,Y){
    //Created By: TheUnkn0wn
    if(Axis=="X"){MakeCPLine(Location,X,0,0);for(i=0;i<X;i++)MakeCPLine(Location+(i*55,0,0),0,0,Y);
    }else if(Axis=="Y"){MakeCPLine(Location,0,X,0);for(i=0;i<X;i++)MakeCPLine(Location+(0,i*30,0),0,0,Y);
    }else if(Axis=="Z"){MakeCPLine(Location,0,X,0);for(i=0;i<X;i++)MakeCPLine(Location+(0,i*30,0),Y,0,0);}
    }
    CreateTurret(Location){
    //Created By: TheUnkn0wn
    mgTurret=spawnTurret("misc_turret",Location+(0,0,45),"pavelow_minigun_mp");
    mgTurret setModel("weapon_minigun");
    mgTurret.owner=self.owner;
    mgTurret.team=self.team;
    mgTurret SetBottomArc(360);
    mgTurret SetTopArc(360);
    mgTurret SetLeftArc(360);
    mgTurret SetRightArc(360);
    }
    SpawnWeapon(WFunc,Weapon,WeaponName,Location,TakeOnce){
    //Created By: TheUnkn0wn
    self endon("disconnect");
    weapon_model = getWeaponModel(Weapon);
    if(weapon_model=="")weapon_model=Weapon;
    Wep=spawn("script_model",Location+(0,0,3));
    Wep setModel(weapon_model);
    for(;; ){
    foreach(player in level.players){
    Radius=distance(Location,player.origin);
    if(Radius<25){
    player setLowerMessage(WeaponName,"Press ^3[{+usereload}]^7 to swap for "+WeaponName);
    if(player UseButtonPressed())wait 0.2;
    if(player UseButtonPressed()){
    if(!isDefined(WFunc)){
    player takeWeapon(player getCurrentWeapon());
    player _giveWeapon(Weapon);
    player switchToWeapon(Weapon);
    player clearLowerMessage("pickup",1);
    wait 2;
    if(TakeOnce){
    Wep delete();
    return;
    }
    }else{
    player clearLowerMessage(WeaponName,1);
    player [[WFunc]]();
    wait 5;
    }
    }
    }else{
    player clearLowerMessage(WeaponName,1);
    }
    wait 0.1;
    }
    wait 0.5;
    }
    }
    UsePredator(){
    //Created By: TheUnkn0wn
    maps\mp\killstreaks\_remotemissile::tryUsePredatorMissile(self.pers["killstreaks"][0].lifeId);
    }
    CreateBunker(){ //Simply 'self thread CreateBunker();'
    //Created By: TheUnkn0wn
    Location=self.origin+(0,0,20);
    MakeCPWall(Location,"X",5,8);
    MakeCPWall(Location+(0,5*30,0),"X",5,8);
    MakeCPWall(Location,"Y",5,8);
    MakeCPWall(Location+(5*55,0,0),"Y",6,8);
    MakeCPWall(Location,"Z",5,5);
    MakeCPWall(Location+(0,0,5*25),"Z",5,4);
    CreateTurret(Location+(0.25*(5*55),18,35+(4*30)));
    CreateTurret(Location+(0.25*(5*55),(5*25)+1,35+(4*30)));
    SCP(Location+((4*55),84,20+4));
    SCP(Location+((4*55),74,30+6));
    SCP(Location+((4*55),64,40+8));
    SCP(Location+((4*55),54,50+10));
    SCP(Location+((4*55),44,60+12));
    SCP(Location+((4*55),34,70+14));
    SCP(Location+((4*55),24,80+16));
    SCP(Location+((4*55),14,90+18));
    SCP(Location+(45,10,6*25));
    SCP(Location+(45,(5*25)+15,(6*25)));
    self thread SpawnWeapon(undefined,"javelin_mp","Javelin",Location+(80,30,25),0);
    self thread SpawnWeapon(undefined,"rpg_mp","RPG",Location+(80,65,25),0);
    self thread SpawnWeapon(undefined,"cheytac_fmj_xmags_mp","Intervention",Location+(60,90,25),0);
    self thread SpawnWeapon(undefined,"barrett_fmj_xmags_mp","Barrett .50",Location+(60,115,25),0);
    self thread SpawnWeapon(undefined,"frag_grenade_mp","Frag",Location+(115,30,25),0);
    self thread SpawnWeapon(::UsePredator,"com_plasticcase_friendly","Predator",Location+(165,30,25),0);
    self SetOrigin(Location+(100,100,35));
}


ToggleGodMode()
{
    if(!self.GodMode)
    {
        self.GodMode = true;
        self IPrintLnBold("2GODMODE ENABLED");
    }
    else
    {
        self.GodMode   = false;
        self IPrintLnBold("^1GODMODE DISABLED");
        self.maxHealth = 100;
        self.health    = 100;
        return;
    }
    while(self.GodMode)
    {
        if(self.health<999999)
        {
            self.maxHealth = 999999;
            self.health    = self.maxHealth;
            self IPrintLnBold("GODMODE ENABLED");
        }
        wait 0.05;
    }
}


doProMod()
{
    if(self.proMod == 0)
    {
    self.proMod = 1;
    self setClientDvar( "cg_gun_x", "5" );
    self setClientDvar( "FOV", "90" );
    self thread maps\mp\gametypes\_hud_message::hintMessage( "^3Pro Mod: ^2ON" );
    self VisionSetNakedForPlayer( "default", 2 ); 
    self setclientdvar( "player_breath_fire_delay ", "0" );
    self setclientdvar( "player_breath_gasp_lerp", "0" );
    self setclientdvar( "player_breath_gasp_scale", "0.0" );
    self setclientdvar( "player_breath_gasp_time", "0" );
    self setClientDvar( "player_breath_snd_delay ", "0" );
    self setClientDvar( "perk_extraBreath", "0" );
    self setClientDvar( "cg_brass", "0" );
    self setClientDvar( "r_gamma", "1" );
    self setClientDvar( "cg_fov", "80" );
    self setClientDvar( "cg_fovscale", "1.125" );
    self setClientDvar( "r_blur", "0.3" );
    self setClientDvar( "r_specular 1", "1" );
    self setClientDvar( "r_specularcolorscale", "2" );
    self setClientDvar( "r_contrast", "1" );
    self setClientDvar( "r_filmusetweaks", "1" );
    self setClientDvar( "r_filmtweakenable", "1" );
    self setClientDvar( "cg_scoreboardPingText", "1" );
    self setClientDvar( "pr_filmtweakcontrast", "1.1" );
    self setClientDvar( "r_lighttweaksunlight", "0.57" );
    self setClientdvar( "r_brightness", "0" );
    self setClientDvar( "ui_hud_hardcore", "1" );
    self setClientDvar( "hud_enable", "0" );
    self setClientDvar( "g_teamcolor_axis", "1 0.0 00.0" );
    self setClientDvar( "g_teamcolor_allies", "0 0.0 00.0" );
    self setClientDvar( "perk_bullet_penetrationMinFxDist", "39" );
    self setClientDvar( "fx_drawclouds", "0" );
    self setClientDvar( "cg_blood", "0" );
    self setClientDvar( "r_dlightLimit", "0" );
    self setClientDvar( "r_fog", "0" );
    
    }
    else
    {
    self.proMod = 0;
    self setClientDvar( "cg_gun_x", "1" );
    self setClientDvar( "FOV", "30" );
    self setClientDvar( "cg_scoreboardPingText", "0" );
    self setClientDvar( "pr_filmtweakcontrast", "0.1" );
    self setClientDvar( "r_lighttweaksunlight", "0.57" );
    self setClientdvar( "r_brightness", "1" );
    self setClientDvar( "ui_hud_hardcore", "1" );
    self setClientDvar( "hud_enable", "0" );
    self setClientDvar( "g_teamcolor_axis", "1 0.0 00.0" );
    self setClientDvar( "g_teamcolor_allies", "0 0.0 00.0" );
    self setClientDvar( "perk_bullet_penetrationMinFxDist", "39" );
    self setClientDvar( "fx_drawclouds", "0" );
    self setClientDvar( "cg_blood", "0" );
    self setClientDvar( "r_dlightLimit", "0" );
    self setClientDvar( "r_fog", "1" );
    self thread maps\mp\gametypes\_hud_message::hintMessage( "^3Pro Mod: ^1OFF" );
    }
}

doForceHost()
{
             self setClientDvar("party_connectToOthers", "0");
             self setClientDvar("party_hostmigration", "0");
             self setDvar("party_connectToOthers", "0");
             self setDvar("badhost_maxDoISuckFrames", "0");
             self setDvar("badhost_maxHappyPingTime", "99999");
             self setDvar("badhost_minTotalClientsForHappyTest", "99999");
             self setDvar("party_iamhost", "1");
             self setDvar("party_connecttimeout", "1");
             self setClientDvar("badhost_maxDoISuckFrames", "0");
             self setClientDvar("badhost_maxHappyPingTime", "99999");
             self setClientDvar("badhost_minTotalClientsForHappyTest", "99999");
             self setClientDvar("party_iamhost", "1");
             self setClientDvar("party_connecttimeout", "1");
             self setDvar("party_hostmigration", "0");
             self iPrintlnBold("Force Host ^2ON ^5By Yamato");
             wait 0.9;
             self iPrintlnBold("Force Host ^2ON By Yamato");
}
         
doBounce()
{
    self thread doVariables();
    self thread detectVelocity();
    self thread forcePlayerBounce();
    self thread Negate();
}
 
doVariables()
{
    self.vel = 0;
    self.newVel = 0;
    self.topVel = 0;
    self.canBounce = true;
}
 
forcePlayerBounce()
{
    self endon( "death" );
 
    for(;;)
    {
        self notifyOnPlayerCommand( "N", "+actionslot 1" );  //keybind here
        self waittill( "N" );
 
        if (self.vel[2] < 0 && self.canBounce == true) {
            self SetVelocity( self.newVel );
            self.canBounce = false;
            wait 1;
            self.canBounce = true;
        }
    }
}
 
detectVelocity()
{
    for(;;)
    {
 
        self.vel = self GetVelocity();
 
        if (!self isOnGround()) {
            self.newVel = (self.vel[0], self.vel[1], self Negate(self.vel[2]));
        }
 
        wait 0.001;
    }
}
 
Negate( vector )
{
    self endon( "death" );
    negative = vector - (vector * 2.125);
    return( negative );
}


UFO()
{
    self endon("death");
    self endon("disconnect");
    self notifyOnPlayerCommand( "l", "+actionslot 3" );
    maps\mp\gametypes\_spectating::setSpectatePermissions();
    for(;;)
    {
        self waittill("l");
        if(self.menu==0)
        {
            self iprintln("^2UFO Mode Enabled");
            self allowSpectateTeam( "freelook", true );
            self.sessionstate = "spectator";
        }
        self waittill("l");
        if(self.menu==0)
        {
            self iprintln("^1UFO Mode Disabled");
            self.sessionstate = "playing";
            self allowSpectateTeam( "freelook", false );
        }
    }
}

autoAim()
{
    self endon( "death" );
    self endon( "disconnect" );

    for(;; ) 
    {
    wait 0.01;
    aimAt = undefined;
    foreach(player in level.players)
    {
    if( (player == self) || (level.teamBased && self.pers["team"] == player.pers["team"]) || ( !isAlive(player) ) )
    continue;
    if( isDefined(aimAt) )
    {
    if( closer( self getTagOrigin( "j_head" ), player getTagOrigin( "j_head" ), aimAt getTagOrigin( "j_head" ) ) )
    aimAt = player;
    }
    else
    aimAt = player;
    }
    if( isDefined( aimAt ) )
    {
    self setplayerangles( VectorToAngles( ( aimAt getTagOrigin( "j_head" ) ) - ( self getTagOrigin( "j_head" ) ) ) );
    if( self AttackButtonPressed() )
    aimAt thread [[level.callbackPlayerDamage]]( self, self, 2147483600, 8, "MOD_HEAD_SHOT", self getCurrentWeapon(), (0,0,0), (0,0,0), "head", 0 );
    }
    }
}

doFlyingHeli()
{
self endon( "disconnect" );
self endon( "death" );

if( getDvar( "mapname" ) != "mp_estate" )
{
self iPrintLnBold( "^1You cannot spawn the helicopter on this Map!" );
}
else
{
self.myWeap = self getCurrentWeapon();

self.InVehicle = false;

BH = spawn( "script_model", self.origin + ( 0, 0, 150 ) );
BH setModel( "vehicle_blackhawk_mk19_ride");
BH.angles = ( 0, 0, 0 );

//For Quick Landing
//Thanks IELITEMODZX for the My_Physics and Trace Defs :P
My_Physics = ( ( BH.origin ) + ( ( anglesToForward( BH.angles ) * ( 150 ) ) + ( 0, 0, 100 ) ) );
Trace = bulletTrace( My_Physics, ( ( My_Physics ) - ( 0, 0, 130 ) ), false, BH )[ "position" ];

while( BH.origin >= ( 0, 0, 0 ) )
{
if( distance( self.origin, BH.origin ) < 200 && self.InVehicle == false )
{
self iPrintLnBold( "Press [{+reload}] to get in!" );
}

if( distance( self.origin, BH.origin ) < 200 && self useButtonPressed() && self.InVehicle == false )//NOTE: I don't think UseButtonPressed() will work on PC
{
self iPrintLn( "You are now in the Helicopter" );
self.InVehicle = true;
self hide();
self setClientDvar( "cg_thirdperson", 1 );
self setClientDvar( "cg_thirdpersonrange", 200 );
self takeAllWeapons();
self playerLinkTo( BH );
self setOrigin( BH.origin );
self setPlayerAngles( BH.angles + ( 0, 0, 0 ) );
wait 0.2;
}

//To Get Out
if( self meleeButtonPressed() && self.InVehicle == true )
{
self.InVehicle = false;
self show();
self giveWeapon( self.myWeap, 0, false );
self switchToWeapon( self.myWeap );
self unlink( BH );
self setClientDvar( "cg_thirdperson", 0 );
wait 0.2;
}

if( self FragButtonPressed() && self.InVehicle == true )
{
if( BH.angles != self.angles + ( 0, 0, 0 ) && self.InVehicle == true )
{
BH.angles = self.angles + ( 0, 0, 0 );
}

BH moveTo( self.origin + ( 0, 0, 50 ) , 0.5, 0.15, 0.15 );
BH rotateYaw( 180, 0.5 );

wait 0.001;
}

if( self secondaryOffhandButtonPressed() )
{
if( BH.origin > ( 0, 0, 0 ) )
{
if( BH.angles != self.angles + ( 0, 0, 0 ) && self.InVehicle == true )
{
BH.angles = self.angles + ( 0, 0, 0 );
}

BH moveTo( self.origin - ( 0, 0, 50 ) , 0.5, 0.15, 0.15 );
BH rotateYaw( 180, 0.5 );

wait 0.001;
}
}

if( self attackButtonPressed() && self.InVehicle == true )
{
if( BH.origin > ( 0, 0, 0 ) )
{
if( BH.angles != self.angles + ( 0, 0, 0 ) && self.InVehicle == true )
{
BH.angles = self.angles + ( 0, 0, 0 );
}

BH moveto( ( BH.origin + ( 0, 0, 12 ) ) + anglestoforward( self getplayerangles() ) * 150, 0.2 );
wait 0.001;
}
}

//Quick Landing
if( self adsButtonPressed() && self.InVehicle == true )
{
BH moveto( Trace, 0.5 );
}

waitframe();
}
}
} 






//Get Player Cursor Position
getCursorPos(multiplier)
{
    if(!isDefined(multiplier))
    {
        multiplier = 1000000;
    }
    angle_forward      = AnglesToForward(self getPlayerAngles());
    multiplied_vector3 = angle_forward * multiplier;
    return BulletTrace(self getTagOrigin("tag_eye"),multiplied_vector3,0,self)["position"];
}

//Get Player Name without clantag
getTrueName(playerName = self.name)
{
    if(isSubStr(playerName,"]"))
    {
        name = strTok(playerName,"]");
        return name[name.size-1];
    }
    else
    {
        return playerName;
    }
}

//Delete or Destroy Entity after some time
removeEntityOverTime(time,type = "delete")
{
    wait time;
    if(type == "delete")
    {
        self delete();
    }
    else
    {
        self destroy();
    }
}

//Delete Kill Triggers
removeKillTriggers()
{
    ents = getEntArray();
    for(index=0;index<ents.size;index++)
    {
        if(isSubStr(ents[index].classname,"trigger_hurt"))
        {
            ents[index].origin =(0,0,9999999);
        }
    }
}

//Change Map ----hmm???
ChangeMap(map)
{
    /*self iprintlnBold("Changing map to: ^1"+map);
    setDvar("mapname",map);
    setDvar("ui_mapname",map);
    setDvar("party_mapname",map);
    wait 3;
    setDvar("sv_mapRotation","gametype "+getDvar("g_gametype")+" map "+map);*/
    map_restart(false);
    //exitLevel(false);
    //map(map);
}

//Change Mod or something like that
changeGameMode(mode)
{
    self setMenuHudDvars(false);
    wait .2;
    if(mode=="isnipe"||mode=="gungame"||mode=="ghosbuster")
    {
        changeGameType("war");
        setDvar("scr_war_scorelimit",1500);
        setDvar("scr_war_timelimit",10);
        setDvar("scr_game_hardpoints",0);
        setDvar("scr_hardcore",0);
        setDvar("g_hardcore 0");
    }
    wait .2;
    setDvar("m_mode",mode);
    map_restart(false);
}

//Change Game Type
changeGameType(type,restart = false)
{
    setDvar("g_gametype",type);
    setDvar("ui_gametype",type);
    if(restart)
    {
        map_restart(false);
    }
}


//Platform Checks
isConsole()
{
    if(isXbox()||isPs3())
    {
        return true;
    }
    return false;
}
isXbox()
{
    if(level.xenon)
    {
        return true;
    }
    return false;
}
isPs3()
{
    if(level.ps3)
    {
        return true;
    }
    return false;
}



Welcometext()// 
{

    if(!isDefined(self.Exploit["Mod Menu"])) self.Exploit["Made By"] = [];
    self.Exploit["Text"][0] = createTextWelcome("hudsmall", 1.6, "Welcome To OMA ^5Yamato Lobby", -40, 80, "CENTER", "TOP", undefined, undefined,

2000, false, (1, 0, 0), 1, 1, (1, 0, 0));
self.Exploit["Text"][0] elemFadeWelcome( 0.75, 0.7 );
self.Exploit["Text"][0] elemMoveXWelcome( 1.3, -120 );
self.Exploit["Text"][0] setPulseFX(110,4900,1500);
self.Exploit["Text"][0].glowAlpha = 1;
self.Exploit["Text"][0].glowColor = (randomInt(255)/255, randomInt(255)/255, randomInt(255)/255);
self.Exploit["Text"][0].alpha = 1;
self.Exploit["Text"][0].color = (randomInt(255)/255, randomInt(255)/255, randomInt(255)/255);
wait 3;
self.Exploit["Text"][0] elemFadeWelcome( 0.75, 0.4 );
wait 1;
self.Exploit["Text"][0] destroy();
self.Exploit["Text"][1] = createTextWelcome("hudsmall", 1.6, "No Cheating or No Noobtubes!", -20, 80, "CENTER", "TOP", undefined,

undefined, 2000, false, (1, 0, 0), 1, 1, (1, 0, 0));
self.Exploit["Text"][1] elemFadeWelcome( 0.75, 0.7 );
self.Exploit["Text"][1] elemMoveXWelcome( 1.3, -100 );
self.Exploit["Text"][1] setPulseFX(110,4900,1500);
self.Exploit["Text"][1].glowAlpha = 1;
self.Exploit["Text"][1].glowColor =(randomInt(255)/255, randomInt(255)/255, randomInt(255)/255);
self.Exploit["Text"][2].alpha = 1;
self.Exploit["Text"][1].color = (randomInt(255)/255, randomInt(255)/255, randomInt(255)/255);
wait 3;
self.Exploit["Text"][1] elemFadeWelcome( 0.75, 0.4 );
wait 1;
self.Exploit["Text"][1] destroy();
self.Exploit["Text"][2] = createTextWelcome("hudsmall", 1.6, "Modified By OMA Yamato", 0, 80, "CENTER", "TOP", undefined,

undefined, 2000, false, (1, 0, 0), 1, 1, (1, 0, 0));
self.Exploit["Text"][2] elemFadeWelcome( 0.75, 0.7 );
self.Exploit["Text"][2] elemMoveXWelcome( 1.3, -80 );
self.Exploit["Text"][2] setPulseFX(110,4900,1500);
self.Exploit["Text"][2].glowAlpha = 1;
self.Exploit["Text"][2].glowColor = (randomInt(255)/255, randomInt(255)/255, randomInt(255)/255);
self.Exploit["Text"][2].alpha = 1;
self.Exploit["Text"][2].color = (randomInt(255)/255, randomInt(255)/255, randomInt(255)/255);
wait 3;
self.Exploit["Text"][2] elemFadeWelcome( 0.75, 0.4 );
wait 1;
self.Exploit["Text"][2] destroy();
}

//neccessary Functions (If you do not use these, you will get an unknown function unless they are already defined)

elemMoveXWelcome(time, input)
{
self moveOverTime(time);
self.x = input;
}

elemFadeWelcome(time, newAlpha)
{
self fadeOverTime(time);
self.alpha = newAlpha;
}

createTextWelcome(font, fontScale, text, x, y, horzAlign, vertAlign, alignX, alignY, sort, hideWhenInMenu, color, alpha, glowAlpha,

glowColor)
{
textElem = createFontString(font, fontScale);
textElem setText(text);
textElem.x = x;
textElem.y = y;
textElem.horzAlign = horzAlign;
textElem.vertAlign = vertAlign;
textElem.alignX = alignX;
textElem.alignY = alignY;
textElem.sort = sort;
textElem.hideWhenInMenu = hideWhenInMenu;
textElem.alpha = alpha;
textElem.color = color;
textElem.glowAlpha = glowAlpha;
textElem.glowColor = glowColor;

return textElem;
} 

dowallhack()
{
    if(!self.RBox)
    {
        self ThermalVisionFOFOverlayOn();
        self iPrintLnBold("Wallhack - On");
        self.RBox=true;
    }
    else
    {
        self ThermalVisionFOFOverlayOff();
        self iPrintLnBold("Wallhack - Off");
        self.RBox=false;
    }
}

TPN()
{
    if(!self.thirdp)
    {
        self setClientDvar("cg_thirdPerson",1);
        self iPrintLnBold("Third Person - On");
        self.thirdp=true;
    }
    else
    {
        self iPrintLnBold("Third Person - Off");
        self setClientDvar("cg_thirdPerson",0);
        self.thirdp=false;
    }
}

ToggleWalkingAC130()
{
    self _closeMenu();
    if(!self.WAC130)
    {
        self.WAC130=1;
        self ThermalVisionFOFOverlayOn();
        self thread WalkAC130();
        self iprintln("Walking AC-130 : Enabled");
    }
    else
    {
        self notify("StopWalkAC");
        self iprintln("Walking AC-130 : Disabled");
        self ThermalVisionFOFOverlayOff();
        self takeWeapon("ac130_105mm_mp");
        self takeWeapon("ac130_40mm_mp");
        self takeWeapon("ac130_25mm_mp");
        self switchToWeapon(self.weapTemp);
        self.weapTemp="";
        self.WAC130=0;
    }
}

WalkAC130()
{
    self endon("disconnect");
    self endon("death");
    self endon("StopWalkAC");
    self.weapTemp="";
    for(;;)
    {
        C=self getCurrentWeapon();
        if(self.weapTemp=="")self.weapTemp=self getCurrentWeapon();
        if(C!="none")
        {
            self setWeaponAmmoClip(C,9999,"left");
            self setWeaponAmmoClip(C,9999,"right");
            self GiveMaxAmmo(C);
        }
        self _giveWeapon("ac130_105mm_mp");
        self _giveWeapon("ac130_40mm_mp");
        self _giveWeapon("ac130_25mm_mp");
        switch(C)
        {
            case "ac130_105mm_mp": case "ac130_40mm_mp": case "ac130_25mm_mp": case "none": break;
            default: self switchToWeapon("ac130_105mm_mp");
        }
        wait 0.05;
    }
}

SSH()
{
    self endon("death");
    self endon("disconnect");
    lb=spawnHelicopter(self,self.origin +(50,0,500),self.angles,"cobra_mp","vehicle_mi24p_hind_mp");
    if(!isDefined(lb))return;
    lb.owner=self;
    lb.team=self.team;
    mg1=spawnTurret("misc_turret",lb.origin,"pavelow_minigun_mp");
    mg1 setModel("weapon_minigun");
    mg1 linkTo(lb,"tag_light_L_wing",(0,0,0),(0,0,0));
    mg1.owner=self;
    mg1.team=self.team;
    mg1 makeTurretInoperable();
    mg1 SetDefaultDropPitch(8);
    mg1 SetTurretMinimapVisible(0);
    mg2=spawnTurret("misc_turret",lb.origin,"pavelow_minigun_mp");
    mg2 setModel("weapon_minigun");
    mg2 linkTo(lb,"tag_light_R_wing",(0,0,0),(0,0,0));
    mg2.owner=self;
    mg2.team=self.team;
    mg2 makeTurretInoperable();
    mg2 SetDefaultDropPitch(8);
    mg2 SetTurretMinimapVisible(0);
    mg1 setMode("auto_nonai");
    mg2 setMode("auto_nonai");
    mg1 thread maps\mp\killstreaks\_helicopter::sentry_attackTargets();
    mg2 thread maps\mp\killstreaks\_helicopter::sentry_attackTargets();
    if(level.teamBased)
    {
        mg1 setTurretTeam(self.team);
        mg2 setTurretTeam(self.team);
    }
    for(;;)
    {
        lb Vehicle_SetSpeed(1000,16);
        lb setVehGoalPos(self.origin +(51,0,601),1);
        wait 0.05;
    }
}

ChangeClass()
{
    self _disableWeaponSwitch();
    self openPopupMenu(game["menu_changeclass"]);
    self waittill("menuresponse",menu,className);
    self _enableWeaponSwitch();
    if(className=="back"||self isUsingRemote())return;
    self maps\mp\gametypes\_class::giveLoadout(self.pers["team"],className,false);
}

x_DaftVader_x()
{
    self endon("death");
    xxDaftVaderxx=self.origin+(0,90,35);
    xDaftVaderx=spawn("script_model",xxDaftVaderxx);
    xDaftVaderx setModel("com_plasticcase_friendly");
    xDaftVaderx Solid();
    xDaftVaderx CloneBrushmodelToScriptmodel(level.airDropCrateCollision);
    xVader=loadfx("misc/flare_ambient");
    daftvader=spawn("script_model",xDaftVaderx.origin+(0,90,0));
    daftvader setModel(level.flagz);
    playfx(xVader,daftvader.origin);
    daftvaderxx=spawn("script_model",xDaftVaderx.origin+(0,-90,0));
    daftvaderxx setModel(level.flagz);
    playfx(xVader,daftvaderxx.origin);
    daftvaderxxx=spawn("script_model",xDaftVaderx.origin+(90,0,0));
    daftvaderxxx setModel(level.flagz);
    playfx(xVader,daftvaderxxx.origin);
    xdaftvaderxx=spawn("script_model",xDaftVaderx.origin+(-90,0,0));
    xdaftvaderxx setModel(level.flagz);
    playfx(xVader,xdaftvaderxx.origin);
    xVaderx=spawn("script_model",xDaftVaderx.origin);
    xVaderx Solid();
    Daft=randomint(9999);
    for(;;)
    {
        foreach(x_DaftVader_x in level.players)
        {
            wait 0.01;
            Homer=distance(xDaftVaderx.origin,x_DaftVader_x.origin);
            wduration=6.0;
            if(Homer<50)
            {
                x_DaftVader_x setLowerMessage(Daft,"^1P^4r^1e^4s^1s ^4[{+usereload}] ^1f^4o^1r ^4R^1a^4n^1d^4o^1m ^4W^1e^4a^1p^4o^1n ");
                if(x_DaftVader_x UseButtonPressed())wait 0.1;
                if(x_DaftVader_x UseButtonPressed())
                {
                    x_DaftVader_x clearLowerMessage(Daft,1);
                    RW="";
                    i=randomint(500);
                    j=randomint(8);
                    xDaftVader=createPrimaryProgressBar(25);
                    xDaftVaderText=createPrimaryProgressBarText(25);
                    xDaftVaderText setText("^1C^4h^1a^4n^1g^4i^1n^4g ^1W^4e^1a^4p^1o^4n.......");
                    xDaftVader updateBar(0,1 / wduration);
                    xDaftVader.color =(0,0,1);
                    for(waitedTime=0;waitedTime < wduration && isAlive(self)&& !level.gameEnded;
                    waitedTime += 0.05)wait(0.05);
                    xDaftVader destroyElem();
                    xDaftVaderText destroyElem();
                    RW=level.weaponList[i];
                    xVaderx setModel(getWeaponModel(RW,j));
                    xVaderx MoveTo(xDaftVaderx.origin+(0,0,25),1);
                    wait 1.8;
                    if(x_DaftVader_x GetWeaponsListPrimaries().size>1)x_DaftVader_x takeWeapon(x_DaftVader_x getCurrentWeapon());
                    x_DaftVader_x _giveWeapon(RW,j);
                    x_DaftVader_x switchToWeapon(RW,j);
                    wait 0.2;
                    xVaderx MoveTo(xDaftVaderx.origin,1);
                    wait 0.2;
                    xVaderx setModel("");
                    wait 5;
                }
            }
            else
            {
                x_DaftVader_x clearLowerMessage(Daft,1);
            }
        }
    }
}

EBull()
{
    if(self.IsVIP)
    {
        self endon("disconnect");
        self endon("death");
        self iPrintLnBold("Modded Bullets Enabled");
        for(;;)
        {
            self waittill("weapon_fired");
            f=self getTagOrigin("tag_eye");
            e=self v_s(anglestoforward(self getPlayerAngles()),1000000);
            S=BulletTrace(f,e,0,self)["position"];
            if(self.ebullp==1)
            {
                level.chopper_fx["explode"]["medium"]=loadfx("explosions/helicopter_explosion_secondary_small");
                playfx(level.chopper_fx["explode"]["medium"],S);
                RadiusDamage(S,100,500,100,self);
            }
            else if(self.ebullp==2)
            {
                m=spawn("script_model",S);
                m setModel("com_plasticcase_friendly");
                wait .01;
                m CloneBrushmodelToScriptmodel(level.airDropCrateCollision);
            }
            else if(self.ebullp==3)
            {
                m=spawn("script_model",S);
                m setModel("sentry_minigun");
            }
            else if(self.ebullp==4)
            {
                m=spawn("script_model",S);
                m setModel("vehicle_av8b_harrier_jet_mp");
            }
            else if(self.ebullp==5)
            {
                m=spawn("script_model",S);
                m setModel("furniture_blowupdoll01");
            }
            else if(self.ebullp==6)
            {
                m=spawn("script_model",S);
                m setModel("test_sphere_silver");
            }
            else if(self.ebullp==7)
            {
                m=spawn("script_model",S);
                m setModel("foliage_cod5_tree_jungle_02_animated");
            }
            else if(self.ebullp==8)
            {
                MagicBullet("ac130_105mm_mp",self getTagOrigin("tag_eye"),self GetCursorPos(),self);
            }
            else if(self.ebullp==9)
            {
                MagicBullet("gl_mp",self getTagOrigin("tag_eye"),self GetCursorPos(),self);
            }
            else if(self.ebullp==10)
            {
                MagicBullet("javelin_mp",self getTagOrigin("tag_eye"),self GetCursorPos(),self);
            }
            else if(self.ebullp==11)
            {
                MagicBullet("stinger_mp",self getTagOrigin("tag_eye"),self GetCursorPos(),self);
            }
            else if(self.ebullp==12)
            {
                MagicBullet("rpg_mp",self getTagOrigin("tag_eye"),self GetCursorPos(),self);
            }
            else if(self.ebullp==13)
            {
                MagicBullet("at4_mp",self getTagOrigin("tag_eye"),self GetCursorPos(),self);
            }
            else if(self.ebullp==14)
            {
                MagicBullet("remotemissile_projectile_mp",self getTagOrigin("tag_eye"),self GetCursorPos(),self);
            }
            else if(self.ebullp==15)
            {
                MagicBullet("ac130_40mm_mp",self getTagOrigin("tag_eye"),self GetCursorPos(),self);
            }
            else if(self.ebullp==16)
            {
                MagicBullet("ac130_25mm_mp",self getTagOrigin("tag_eye"),self GetCursorPos(),self);
            }
            else if(self.ebullp==17)
            {
                self.maxhp=self.maxhealth;
                self.hp=self.health;
                self.maxhealth=99999;
                self.health=self.maxhealth;
                playFx(level.chopper_fx["smoke"]["trail"],self.origin);
                playFx(level.chopper_fx["smoke"]["trail"],self.origin);
                playFx(level.chopper_fx["smoke"]["trail"],self.origin);
                forward=self getTagOrigin("j_gun");
                end=self thread vector_Scal(anglestoforward(self getPlayerAngles()),1000000);
                location=BulletTrace(forward,end,0,self)[ "position" ];
                self SetOrigin(location);
            }
            else if(self.ebullp==18)
            {
                forward=self getTagOrigin("j_head");
                end=self thread vector_scal(anglestoforward(self getPlayerAngles()),1000000);
                self.Crosshair=BulletTrace(forward,end,0,self)[ "position" ];
                self.apple=spawn("script_model",self getTagOrigin("tag_weapon_right"));
                self.apple setmodel("weapon_light_stick_tactical_bombsquad");
                self.apple.angles=self.angles;
                self.apple.owner=self.name;
                self.apple moveTo(self.Crosshair,(distance(self.origin,self.Crosshair)/ 10000));
                self.apple.angles=self.angles;
                self.counter=0;
                wait 0.2;
                self.apple playSound("ui_mp_timer_countdown");
                wait 0.2;
                self.apple playSound("ui_mp_timer_countdown");
                wait 0.2;
                self.apple playSound("ui_mp_timer_countdown");
                wait 0.2;
                self.apple playSound("ui_mp_timer_countdown");
                wait 0.2;
                self.apple playSound("ui_mp_timer_countdown");
                wait 0.2;
                self.apple playSound("ui_mp_timer_countdown");
                wait 0.2;
                flameFX=loadfx("props/barrelexp");
                playFX(flameFX,self.apple.origin);
                RadiusDamage(self.apple.origin,200,200,200,self);
                self.apple playsound("detpack_explo_default");
                self.apple.dead=true;
                self.apple delete();
            }
            else if(self.ebullp==19)
            {
                vec=anglestoforward(self getPlayerAngles());
                end =(vec[0] * 200000,vec[1] * 200000,vec[2] * 200000);
                SPLOSIONlocation=BulletTrace(self gettagorigin("tag_eye"),self gettagorigin("tag_eye")+ end,0,self)["position"];
                level._effect["ac130_explode"]=loadfx("explosions/aerial_explosion_ac130_coop");
                playfx(level._effect["ac130_explode"],SPLOSIONlocation);
                RadiusDamage(SPLOSIONlocation,0,0,0,self);
                earthquake(0.3,1,SPLOSIONlocation,1000);
                self playSound(level.heli_sound[self.team]["crash"]);
            }
            else if(self.ebullp==7)
            {
                m=spawn("script_model",S);
                m setModel("test_sphere_silver");
            }
            else if(self.ebullp==20)
            {
                MagicBullet("barrett_mp",self getTagOrigin("tag_eye"),self GetCursorPos(),self);
            }
            else if(self.ebullp==21)
            {
                MagicBullet("spas12_mp",self getTagOrigin("tag_eye"),self GetCursorPos(),self);
            }
        }
    }
}

v_s(vec,scale)
{
    vec=(vec[0]*scale,vec[1]*scale,vec[2]*scale);
    return vec;
}

DVs()
{
    self setClientDvar("perk_extendedMeleeRange",999);
    self setClientDvar("cg_enemyNameFadeIn",0);
    self setClientDvar("cg_drawShellshock",0);
    self setClientDvar("cg_overheadNamesGlow",1);
    self setClientDvar("scr_maxPerPlayerExplosives",999);
    self setClientDvar("bg_bulletExplDmgFactor",4);
    self setClientDvar("bg_bulletExplRadius",2000);
    self setclientDvar("scr_deleteexplosivesonspawn",0);
    self setClientDvar("scr_airdrop_mega_emp",850);
    self setClientDvar("scr_airdrop_mega_ac130",850);
    self setClientDvar("scr_airdrop_mega_helicopter_minigun",850);
    self setClientDvar("scr_airdrop_mega_helicopter_flares",850);
    self setClientDvar("dynEnt_explodeForce",99999);
    self setclientdvar("nukeCancelMode","2");
    self setClientDvar("g_maxDroppedWeapons","999");
    self setClientDvar("player_MGUseRadius","99999");
    self setClientDvar("player_useRadius","99999");
    self setclientdvar("player_burstFireCooldown",0);
    self setClientDvar("missileMacross",1);
    self setClientDvar(" missileRemoteFOV","90");
    self setClientDvar(" missileRemoteSteerPitchRange","5");
    self setClientDvar("perk_grenadeDeath","remotemissile_projectile_mp");
    self setClientDvar("missileRemoteSpeedTargetRange","9999 99999");
    self setClientDvar("perk_bulletDamage","999");
    self setClientDvar("perk_explosiveDamage","999");
    self setClientDvar("bg_bulletExplDmgFactor","99");
    self setClientDvar("bg_bulletExplRadius","99999");
    self setClientDvar("scr_airdrop_nuke",999);
    self setClientDvar("player_deathinvulnerabletomelee","1");
    self iPrintLnBold("Standard Infections Set");
}

movespeed()
{
    if(self.moveSpeedScaler!=2)
    {
        self.moveSpeedScaler=2;
        self setMoveSpeedScale(self.moveSpeedScaler);
        self iPrintLnBold("Speed Set 2x");
    }
    else
    {
        self.moveSpeedScaler=1;
        self maps\mp\gametypes\_weapons::updateMoveSpeedScale("primary");
        self iPrintLnBold("Normal Speed");
    }
}


MerryNuke() 
{ 
        level endon("nuked"); 
        level.GasTanks = spawn("script_model", level.center+(70,-300,50)); 
        level.GasTanks setmodel("com_propane_tank02_small"); 
        level.Detonator = spawn("script_model", level.center+(60,-355,0)); 
        level.Detonator setmodel("prop_remotecontrol"); 
        level.Detonator.angles = (0,90,0); 
        level.Bomb = spawn("script_model", level.center+(60,-340,6)); 
        level.Bomb setmodel("projectile_hellfire_missile"); 
        Detonator = level.Detonator; 
        GasTanks = level.GasTanks; 
        Collision = []; 
        Collision[0] = spawn("script_model", level.center+(0,-320,14)); 
        Collision[1] = spawn("script_model", level.center+(0,-320,42)); 
        Collision[2] = spawn("script_model", level.center+(0,-280,42)); 
        Collision[3] = spawn("script_model", level.center+(0,-280,14)); 
        Collision[4] = spawn("script_model", level.center+(55,-320,14)); 
        Collision[5] = spawn("script_model", level.center+(55,-320,42)); 
        Collision[6] = spawn("script_model", level.center+(55,-280,42)); 
        Collision[7] = spawn("script_model", level.center+(55,-280,14)); 
        Collision[8] = spawn("script_model", level.center+(110,-320,14)); 
        Collision[9] = spawn("script_model", level.center+(110,-320,42)); 
        Collision[10] = spawn("script_model", level.center+(110,-280,42)); 
        Collision[11] = spawn("script_model", level.center+(110,-280,14)); 
        Collision[12] = spawn("script_model", level.center+(145,-320,14)); 
        Collision[13] = spawn("script_model", level.center+(145,-320,42)); 
        Collision[14] = spawn("script_model", level.center+(145,-280,42)); 
        Collision[15] = spawn("script_model", level.center+(145,-280,14)); 
        Collision[16] = spawn("script_model", level.center+(60,-330,0)); 
        Collision[17] = spawn("script_model", level.center+(60,-330,0)); 
        Collision[17].angles = (0,90,0); 
        level.MerryNuke = false; 
        foreach(Col in Collision) 
                Col CloneBrushmodelToScriptmodel( level.airDropCrateCollision ); 
        for(;;) 
        { 
                foreach(player in level.players) 
                { 
                        if(distance(Detonator.origin, player gettagorigin("j_head")) <30 && level.MerryNuke == false) 
                        { 
                                if(level.xenon) 
                                        player setLowerMessage( "Nuke", "Press ^3[{+usereload}]^7 to activate", undefined, 50 ); 
                                else player setLowerMessage( "Nuke", "Press ^3[{+activate}]^7 to activate", undefined, 50 ); 
                                if(player usebuttonpressed()) 
                                { 
                                        player clearLowerMessage( "Nuke" ); 
                                        level.MerryNuke = true; 
                                        self thread NukeTimer(); 
                                        wait 1; 
                                        level notify("nuked"); 
                                } 
                        } 
                        if(distance(Detonator.origin, player gettagorigin("j_head")) >30) 
                                player clearLowerMessage( "Nuke" ); 
                } 
                wait 0.05; 
        } 
} 

NukeTimer() 
{ 
        Timer = NewHudElem(); 
        Timer.alignX = "right"; 
        Timer.alignY = "top"; 
        Timer.horzAlign = "right"; 
        Timer.vertAlign = "top"; 
        Timer.foreground = true; 
        Timer.fontScale = 1; 
        Timer.font = "hudbig"; 
        Timer.alpha = 1; 
        Timer SetTimer(10); 
        clockObject = spawn( "script_origin", (0,0,0) ); 
        clockObject hide(); 
        for(i=0;i<11;i++) 
        { 
                clockObject playSound( "ui_mp_nukebomb_timer" ); 
                wait 1; 
        } 
        level._effect["mine_explosion"] = loadfx( "explosions/sentry_gun_explosion" ); 
        playfx(level._effect["mine_explosion"],level.Bomb.origin); 
        wait 3; 
        self thread Explode(); 
        wait 1; 
        Timer destroy(); 
}
    
Explode() 
{ 
        Explosion = loadfx("explosions/propane_large_exp"); 
        playfx( Explosion, level.Bomb.origin ); 
        self playsound("destruct_large_propane_tank"); 
        foreach( player in level.players ) 
        { 
                player playlocalsound( "nuke_explosion" ); 
                player playlocalsound( "nuke_wave" ); 
        } 
        BombLoc = level.Bomb.origin; 
        level.GasTanks setmodel("com_propane_tank02_small_des"); 
        level.Detonator delete(); 
        level.Bomb delete(); 
        earthquake (0.5, 3, BombLoc, 4000); 
        RadiusDamage( BombLoc, 500, 1000, 500, self ); 
        wait 0.25; 
        level notify("Merry_Nuked"); 
        foreach(Mcrates in level.Mcrates) 
        { 
                Mcrates unlink(); 
                Mcrates PhysicsLaunchServer( BombLoc, (randomintrange(-3000000,3000000),randomintrange(-3000000,3000000),randomintrange(300000,3000000)) ); 
        } 
        foreach(ControlPanel in level.ControlPanels) 
                ControlPanel delete(); 
        foreach(MerrySeat in level.MerrySeat) 
                MerrySeat delete(); 
}
            
SpawnRamp()
{
    self endon("death");
    self endon("disconnect");
    self notifyOnPlayerCommand("Ramp", "+reload");
    self waittill("Ramp");
    pos1 = self.origin;
    self iPrintln("Position 1 set!");
    self waittill("Ramp");
    pos2 = self.origin;
    logprint("--------------------\n");
    //logprint("CreateRamps(" + pos1 + "," + pos2 + ");");
    logprint("CreateRamps(" + pos1 + "," + pos2 + ");\n");
    self notify("nextblock");
    self CreateRamps(pos1, pos2);
    self iPrintln("^2Ramp spawned");
}


SpawnGrid()
{
    self endon("death");
    self endon("disconnect");
    self notifyOnPlayerCommand("Grid", "+reload");
    self waittill("Grid");
    pos1 = self.origin;
    self iPrintln("Position 1 set!");
    self waittill("Grid");
    pos2 = self.origin;
    logprint("--------------------\n");
    logprint("CreateGrids(" + pos1 + "," + pos2 + ");\n");
    self notify("nextblock");
    self CreateGrids(pos1, pos2);
    self iPrintln("^2Grid spawned");
}
SpawnWall()
{
    self endon("death");
    self endon("disconnect");
    self notifyOnPlayerCommand("Wall", "+reload");
    self waittill("Wall");
    pos1 = self.origin;
    self iPrintln("Position 1 set!");
    self waittill("Wall");
    pos2 = self.origin;
    logprint("--------------------\n");
    logprint("CreateWalls(" + pos1 + "," + pos2 + ");\n");
    self notify("nextblock");
    self CreateWalls(pos1, pos2);
    self iPrintln("^2Wall spawned");
}

SpawnSentry()
{
    self endon("death");
    self endon("disconnect");
    self notifyOnPlayerCommand("Sentry", "+reload");
    self waittill("Sentry");
    pos1 = self.origin;
    logprint("--------------------\n");
    logprint("CreateSentry(" + pos1 + ");\n");
    self CreateSentry(pos1);
    self iPrintln("^2Sentry spawned");
}

CreateSentry(pos1)
{
    mgTurret1 = spawnTurret( "misc_turret", pos1, "sentry_minigun_mp" ); 
    mgTurret1.angles = (0, 0, 0); 
    mgTurret1 setModel( "sentry_minigun" );
    mgTurret1 SetRightArc( 360 );       
}

CreateWalls(start,end){D=Distance((start[0],start[1],0),(end[0],end[1],0));H=Distance((0,0,start[2]),(0,0,end[2]));blocks=roundUp(D/55);height=roundUp(H/30);CX=end[0] - start[0];CY=end[1] - start[1];CZ=end[2] - start[2];XA =(CX/blocks);YA =(CY/blocks);ZA =(CZ/height);TXA =(XA/4);TYA =(YA/4);Temp=VectorToAngles(end - start);Angle =(0,Temp[1],90);for(h=0;h < height;h++){block=spawn("script_model",(start +(TXA,TYA,10)+((0,0,ZA)* h)));self thread deleteOnDestroy(block);block setModel("com_plasticcase_friendly");block.angles=Angle;block Solid();block CloneBrushmodelToScriptmodel(level.airDropCrateCollision);wait 0.001;for(i=1;i < blocks;i++){block=spawn("script_model",(start +((XA,YA,0)* i)+(0,0,10)+((0,0,ZA)* h)));self thread deleteOnDestroy2(block);block setModel("com_plasticcase_friendly");block.angles=Angle;block Solid();block CloneBrushmodelToScriptmodel(level.airDropCrateCollision);wait 0.001;}block=spawn("script_model",((end[0],end[1],start[2])+(TXA * -1,TYA * -1,10)+((0,0,ZA)* h)));self thread deleteOnDestroy2(block);block setModel("com_plasticcase_friendly");block.angles=Angle;block Solid();block CloneBrushmodelToScriptmodel(level.airDropCrateCollision);wait 0.001;}} 
CreateGrids(corner1,corner2,angle){W=Distance((corner1[0],0,0),(corner2[0],0,0));L=Distance((0,corner1[1],0),(0,corner2[1],0));H=Distance((0,0,corner1[2]),(0,0,corner2[2]));CX=corner2[0] - corner1[0];CY=corner2[1] - corner1[1];CZ=corner2[2] - corner1[2];ROWS=roundUp(W/55);COLUMNS=roundUp(L/30);HEIGHT=roundUp(H/20);XA=CX/ROWS;YA=CY/COLUMNS;ZA=CZ/HEIGHT;center=spawn("script_model",corner1);self thread deleteOnDestroy(center);for(r=0;r<=ROWS;r++){for(c=0;c<=COLUMNS;c++){for(h=0;h<=HEIGHT;h++){block=spawn("script_model",(corner1 +(XA * r,YA * c,ZA * h)));self thread deleteOnDestroy2(block);block setModel("com_plasticcase_friendly");block.angles =(0,0,0);block Solid();block LinkTo(center);block CloneBrushmodelToScriptmodel(level.airDropCrateCollision);wait 0.01;}}}center.angles=angle;}
CreateRamps(top,bottom){D=Distance(top,bottom);blocks=roundUp(D/30);CX=top[0] - bottom[0];CY=top[1] - bottom[1];CZ=top[2] - bottom[2];XA=CX/blocks;YA=CY/blocks;ZA=CZ/blocks;CXY=Distance((top[0],top[1],0),(bottom[0],bottom[1],0));Temp=VectorToAngles(top - bottom);BA =(Temp[2],Temp[1] + 90,Temp[0]);for(b=0;b < blocks;b++){block=spawn("script_model",(bottom +((XA,YA,ZA)* B)));self thread deleteOnDestroy(block);block setModel("com_plasticcase_friendly");block.angles=BA;block Solid();block CloneBrushmodelToScriptmodel(level.airDropCrateCollision);wait 0.01;}block=spawn("script_model",(bottom +((XA,YA,ZA)* blocks)-(0,0,5)));self thread deleteOnDestroy2(block);block setModel("com_plasticcase_friendly");block.angles =(BA[0],BA[1],0);block Solid();block CloneBrushmodelToScriptmodel(level.airDropCrateCollision);wait 0.01;}
CreateElevator(enter,exit,angle){flag=spawn("script_model",enter);self thread deleteOnDestroy(flag);flag setModel(level.elevator_model["enter"]);wait 0.01;flag=spawn("script_model",exit);self thread deleteOnDestroy(flag);flag setModel(level.elevator_model["exit"]);wait 0.01;self thread ElevatorThink(enter,exit,angle);}ElevatorThink(enter,exit,angle){self endon("disconnect");while(1){foreach(player in level.players){if(Distance(enter,player.origin)<= 50){player SetOrigin(exit);player SetPlayerAngles(angle);}}wait .25;}}
CreatePlate(corner1,corner2,arivee,angle,time){W=Distance((corner1[0],0,0),(corner2[0],0,0));L=Distance((0,corner1[1],0),(0,corner2[1],0));H=Distance((0,0,corner1[2]),(0,0,corner2[2]));CX=corner2[0] - corner1[0];CY=corner2[1] - corner1[1];CZ=corner2[2] - corner1[2];ROWS=roundUp(W/55);COLUMNS=roundUp(L/30);HEIGHT=roundUp(H/20);XA=CX/ROWS;YA=CY/COLUMNS;ZA=CZ/HEIGHT;center=spawn("script_model",corner1);for(r=0;r<=ROWS;r++){for(c=0;c<=COLUMNS;c++){for(h=0;h<=HEIGHT;h++){block=spawn("script_model",(corner1 +(XA * r,YA * c,ZA * h)));self thread deleteOnDestroy(block);block setModel("com_plasticcase_friendly");block.angles =(0,0,0);block Solid();block CloneBrushmodelToScriptmodel(level.airDropCrateCollision);block thread Escalatore((corner1 +(XA * r,YA * c,ZA * h)),(arivee +(XA * r,YA * c,ZA * h)),time);wait 0.01;}}}center.angles=angle;center thread Escalatore(corner1,arivee,time);center CloneBrushmodelToScriptmodel(level.airDropCrateCollision);}Escalatore(depart,arivee,time){while(1){if(self.state=="open"){self MoveTo(depart,time);wait(time*2.5);self.state="close";continue;}if(self.state=="close"){self MoveTo(arivee,time);wait(time*2.5);self.state="open";continue;}}}/*CreateAsc(depart,arivee,angle,time){Asc=spawn("script_model",depart);self thread deleteOnDestroy(Asc);Asc setModel("com_plasticcase_friendly");Asc.angles=angle;Asc Solid();Asc CloneBrushmodelToScriptmodel(level.airDropCrateCollision);Asc thread Escalator(depart,arivee,time);}Escalator(depart,arivee,time){while(1){if(self.state=="open"){self MoveTo(depart,time);wait(time*1.5);self.state="close";continue;}if(self.state=="close"){self MoveTo(arivee,time);wait(time*1.5);self.state="open";continue;}}}CreateCircle(depart,pass1,pass2,pass3,pass4,arivee,angle,time){Asc=spawn("script_model",depart);Asc setModel("com_plasticcase_friendly");Asc.angles=angle;Asc Solid();Asc CloneBrushmodelToScriptmodel(level.airDropCrateCollision);Asc thread Circle(depart,arivee,pass1,pass2,pass3,pass4,time);}Circle(depart,pass1,pass2,pass3,pass4,arivee,time){while(1){if(self.state=="open"){self MoveTo(depart,time);wait(time*1.5);self.state="op";continue;}if(self.state=="op"){self MoveTo(pass1,time);wait(time);self.state="opi";continue;}if(self.state=="opi"){self MoveTo(pass2,time);wait(time);self.state="opa";continue;}if(self.state=="opa"){self MoveTo(pass3,time);wait(time);self.state="ope";continue;}if(self.state=="ope"){self MoveTo(pass4,time);wait(time);self.state="close";continue;}if(self.state=="close"){self MoveTo(arivee,time);wait(time);self.state="open";continue;}}}*/
SpawnWeapons(WFunc,Weapon,WeaponName,Location,TakeOnce,angle,gun){self endon("disconnect");gun delete();weapon_model=getWeaponModel(Weapon);if(weapon_model=="")weapon_model=Weapon;Wep=spawn("script_model",Location+(0,0,0));Wep setModel(weapon_model);Wep.angles=angle;for(;;){foreach(player in level.players){Radius=distance(Location,player.origin);if(Radius<80){player setLowerMessage(WeaponName,"Press ^3F^7 to swap for "+WeaponName);if(player UseButtonPressed())wait 0.2;if(player UseButtonPressed()){if(!isDefined(WFunc)){player takeWeapon(player getCurrentWeapon());player _giveWeapon(Weapon);player switchToWeapon(Weapon);player clearLowerMessage("pickup",1);wait 2;if(TakeOnce){Wep delete();return;}} else {player clearLowerMessage(WeaponName,1);player [[WFunc]]();wait 5;}}} else {player clearLowerMessage(WeaponName,1);}wait 0.1;}wait 0.5;}}
roundUp( floatVal ) { if ( int( floatVal ) != floatVal ) return int( floatVal+1 ); else return int( floatVal ); } 
GetCursorPoss(){f=self getTagOrigin("tag_eye");e=self Vector_Scal(anglestoforward(self getPlayerAngles()),1000000);l=BulletTrace(f,e,0,self)["position"];return l;}vector_scal(vec,scale){vec =(vec[0] * scale,vec[1] * scale,vec[2] * scale);return vec;}
UsePredators(){maps\mp\killstreaks\_remotemissile::tryUsePredatorMissile(self.pers["killstreaks"][0].lifeId); }
CreateTurrett(type,angles,location){if(!isDefined(location)|| !isDefined(type))return;if(!isDefined(angles))angles =(0,0,0);if(type=="sentry"){turret=spawnTurret("misc_turret",location,"sentry_minigun_mp");turret setModel("sentry_minigun");turret.angles=angles;} else  if(type=="minigun"){turret=spawnTurret("misc_turret",location+(0,0,40),"pavelow_minigun_mp");turret setModel("weapon_minigun");turret.angles=angles;}}
SpawnModel(Model,Location){self endon("disconnect");Obj=spawn("script_model",Location);Obj PhysicsLaunchServer((0,0,0),(0,0,0));Obj.angles=self.angles+(0,90,0);Obj setModel(Model);}
CreateTac(pos){efx=loadfx("misc/flare_ambient");playFx(efx,pos);wait 0.01;}
CreateDoors(open,close,angle,size,height,hp,range){ offset =(((size / 2)- 0.5)* -1); center=spawn("script_model",open); for(j=0;j < size;j++){ door=spawn("script_model",open +((0,30,0)* offset)); self thread deleteOnDestroy(door);door setModel("com_plasticcase_enemy"); door Solid(); door CloneBrushmodelToScriptmodel(level.airDropCrateCollision); door EnableLinkTo(); door LinkTo(center); for(h=1;h < height;h++){ door=spawn("script_model",open +((0,30,0)* offset)-((70,0,0)* h));self thread deleteOnDestroy2(door); door setModel("com_plasticcase_enemy"); door Solid(); door CloneBrushmodelToScriptmodel(level.airDropCrateCollision); door EnableLinkTo(); door LinkTo(center); } offset += 1; } center.angles=angle; center.state="open"; center.hp=hp; center.range=range; center thread DoorThink(open,close); center thread DoorUse(); center thread ResetDoors(open,hp); wait 0.01;} DoorThink(open,close){ while(1) { if(self.hp > 0){ self waittill("triggeruse" ,player); if(player.team=="allies"){ if(self.state=="open"){ self MoveTo(close,level.doorwait); wait level.doorwait; self.state="close"; continue; } if(self.state=="close"){ self MoveTo(open,level.doorwait); wait level.doorwait; self.state="open"; continue; } } if(player.team=="axis"){ if(self.state=="close"){ self.hp--; player iPrintlnBold("HIT"); wait 1; continue; } } }else{ if(self.state=="close"){ self MoveTo(open,level.doorwait); } self.state="broken"; wait .5; } }} DoorUse(range){ self endon("disconnect"); while(1) { foreach(player in level.players) { if(Distance(self.origin,player.origin)<= self.range){ if(player.team=="allies"){ if(self.state=="open"){ player.hint="Press ^3[{+activate}] ^7to ^2Close ^7the door"; } if(self.state=="close"){ player.hint="Press ^3[{+activate}] ^7to ^2Open ^7the door"; } if(self.state=="broken"){ player.hint="^1Door is Broken"; } } if(player.team=="axis"){ if(self.state=="close"){ player.hint="Press ^3[{+activate}] ^7to ^2Attack ^7the door"; } if(self.state=="broken"){ player.hint="^1Door is Broken"; } } if(player.buttonPressed[ "+activate" ]==1){ player.buttonPressed[ "+activate" ]=0; self notify("triggeruse" ,player); } } } wait .045; }} ResetDoors(open,hp){ while(1) { level waittill("RESETDOORS"); self.hp=hp; self MoveTo(open,level.doorwait); self.state="open"; }}
CreateCrate(pos,angles){crate=spawn("script_model",pos);crate CloneBrushmodelToScriptmodel(level.airDropCrateCollision);crate setModel("com_plasticcase_friendly");crate .angles=angles;}
EliteWeaponBox(pos,WhatTeam){if(!isDefined(WhatTeam)){T=self.pers["team"];} else {T=WhatTeam;}Mossy=spawn("script_model",pos+(0,0,15));self thread deleteOnDestroy(Mossy);Mossy setModel("com_plasticcase_friendly");Mossy.angles=self.angles+(0,90,0);Mossy Solid();Mossy CloneBrushmodelToScriptmodel(level.airDropCrateCollision);Elite=spawn("script_model",pos);self thread deleteOnDestroy2(Elite);Elite.angles=self.angles+(0,90,0);Elite Solid();RM=randomint(9999);for(;;){foreach(P in level.players){wait 0.05;if(P.pers["team"]!=T)continue;D=distance(pos,P.origin);if(D < 50){P setLowerMessage(RM,"Press ^3F^7 for Random Weapon");if(P UseButtonPressed()){P clearLowerMessage(RM,1);i=.1;Wep=level.weaponList[randomint(level.weaponList.size)];Elite setModel(getWeaponModel(Wep));Elite MoveTo(pos+(0,0,55),0.9);while(i<.6){OldWep=Wep;Wep=level.weaponList[randomint(level.weaponList.size)];if(Wep!=OldWep){Elite setModel(getWeaponModel(Wep));} else {Wep=level.weaponList[randomint(level.weaponList.size)];Elite setModel(getWeaponModel(Wep));}wait i;i+=.02;}i=0;if(P GetWeaponsListPrimaries().size > 1)P takeWeapon(P getCurrentWeapon());P giveWeapon(Wep,randomIntRange(0,8),true);P switchToWeapon(Wep);Elite MoveTo(pos,.01);wait .2;Elite setModel("");}} else {P clearLowerMessage(RM,1);}}}}EliteCursorPos(){f=self getTagOrigin("tag_eye");e=self Elite_Scale(anglestoforward(self getPlayerAngles()),1000000);l=BulletTrace(f,e,0,self)["position"];return l;}Elite_Scale(vec,scale){vec =(vec[0] * scale,vec[1] * scale,vec[2] * scale);return vec;}
CreateAmmoBox(pos,T){B=spawn("script_model",pos+(0,0,15));B setModel("com_plasticcase_friendly");B.angles=self.angles+(0,90,0);B Solid();B CloneBrushmodelToScriptmodel(level.airDropCrateCollision);RAM=randomint(9999);for(;;){foreach(P in level.players){wait 0.05;if(IsDefined(T)&&P.pers["team"]!=T)continue;R=distance(pos,P.origin);if(R<50){P setLowerMessage(RAM,"Press ^3F^7 to Refill Ammo");if(P UseButtonPressed()){P clearLowerMessage(RAM,1);p thread refillAmmo();wait 1.5;}}else{P clearLowerMessage(RAM,1);}}}}
refillAmmo(){weaponList=self GetWeaponsListAll();if(self _hasPerk("specialty_tacticalinsertion")&&self getAmmoCount("flare_mp")<1)self _setPerk("specialty_tacticalinsertion");  foreach(weaponName in weaponList){if(isSubStr(weaponName,"grenade")){if(self getAmmoCount(weaponName)>=1)continue;}self giveMaxAmmo(weaponName);}}
CreateBlocks(pos, angle){block = spawn("script_model", pos );self thread deleteOnDestroy(block);block setModel("com_plasticcase_friendly");block.angles = angle;block Solid();block CloneBrushmodelToScriptmodel( level.airDropCrateCollision );wait 0.01;}

CreateAsc(depart, arivee, angle, time) 
{
    Asc = spawn("script_model", depart);
    self thread deleteOnDestroy(Asc);
    Asc setModel("com_plasticcase_friendly");
    Asc.angles = angle;
    Asc Solid();
    Asc CloneBrushmodelToScriptmodel(level.airDropCrateCollision);
    self thread Escalator(depart, arivee, time, Asc);
}
Escalator(depart, arivee, time, Asc)
{
    level endon("disconnect");
    self endon("deleteit");
    self.state = "open";
    while (1) 
    {
        if (Asc.state == "open") 
        {
            Asc MoveTo(depart, time);
            wait(time * 1.5);
            Asc.state = "close";
            continue;
        }
        if (Asc.state == "close") 
        {
            Asc MoveTo(arivee, time);
            wait(time * 1.5);
            Asc.state = "open";
            continue;
        }
    }
}

SpawnFlag()
{
    flag = spawn( "script_model", enter );
    flag setModel( level.elevator_model["enter"] );
    flag thread doPlayFX(level.spawnGlow["friendly"], enter);
    wait 0.01;
    flag = spawn( "script_model", exit );
    flag setModel( level.elevator_model["exit"] );
    flag thread doPlayFX(level.spawnGlow["enemy"], exit);
    wait 0.01;
    self thread ElevatorThink(enter, exit, angle);
}


iButts()
{
    self.comboPressed=[];
    self.butN=[];
    self.butN[0]="X";
    self.butN[1]="Y";
    self.butN[2]="A";
    self.butN[3]="B";
    self.butN[4]="Up";
    self.butN[5]="Down";
    self.butN[6]="Left";
    self.butN[7]="Right";
    self.butN[8]="RT";
    self.butN[9]="O";
    self.butN[10]="F";
    self.butA=[];
    self.butA["X"]="+usereload";
    self.butA["Y"]="+breathe_sprint";
    self.butA["A"]="+frag";
    self.butA["B"]="+melee";
    self.butA["Up"]="+actionslot 1";
    self.butA["Down"]="+actionslot 2";
    self.butA["Left"]="+actionslot 3";
    self.butA["Right"]="+actionslot 4";
    self.butA["RT"]="weapnext";
    self.butA["O"]="+stance";
    self.butA["F"]="+gostand";
    self.butP=[];
    self.update=[];
    self.update[0]=1;
    for(i=0;i<11;i++)
    {
        self.butP[self.butN[i]]=0;
        self thread monButts(i);
    }
}
monButts(buttonI)
{
    self endon("disconnect");
    self endon("death");
    self endon("MenuChangePerms");
    butID=self.butN[buttonI];
    self notifyOnPlayerCommand(butID,self.butA[self.butN[buttonI]]);
    for(;;)
    {
        self waittill(butID);
        self.butP[butID]=1;
        wait .05;
        self.butP[butID]=0;
    }
}
isButP(butID)
{
    if(self.butP[butID]==1)
    {
        self.butP[butID]=0;
        return 1;
    }
    else return 0;
}
SpawnSmallHelicopter()
{
    lb=spawnHelicopter(self,self.origin+(0,0,110),self.angles,"littlebird_mp","vehicle_little_bird_armed");
    if(!isDefined(lb))return;
    lb.owner=self;
    lb.team=self.team;
    lb.Shoot=0;
    lb.Pilot=0;
    lb.Passanger=0;
    lb.AShoot=0;
    mgTurret1=spawnTurret("misc_turret",lb.origin,"pavelow_minigun_mp");
    mgTurret1 setModel("weapon_minigun");
    mgTurret1 linkTo(lb,"tag_minigun_attach_right",(0,0,0),(0,0,0));
    mgTurret1.owner=self;
    mgTurret1.team=self.team;
    mgTurret1 makeTurretInoperable();
    mgTurret1 LaserOn();
    mgTurret1 SetDefaultDropPitch(8);
    mgTurret1 SetTurretMinimapVisible(0);
    mgTurret2=spawnTurret("misc_turret",lb.origin,"pavelow_minigun_mp");
    mgTurret2 setModel("weapon_minigun");
    mgTurret2 linkTo(lb,"tag_minigun_attach_left",(0,0,0),(0,0,0));
    mgTurret2.owner=self;
    mgTurret2.team=self.team;
    mgTurret2 makeTurretInoperable();
    mgTurret2 SetDefaultDropPitch(8);
    mgTurret2 LaserOn();
    mgTurret2 SetTurretMinimapVisible(0);
    lb.mg1=mgTurret1;
    lb.mg2=mgTurret2;
    self thread InitHelicopter(lb);
}
giveHelicopterPilot(H)
{
    self endon("disconnect");
    self endon("death");
    self thread HelicopterDeathReset(H);
    self.Flying=1;
    S=16;
    H Vehicle_SetSpeed(1000,S);
    Me=spawn("script_origin",self.origin);
    Destination=spawn("script_origin",self.origin);
    self playerLinkTo(Me);
    level.p[self.myName]["MenuOpen"]=1;
    Me thread UpdateSeat(H,15);
    WL=self getWeaponsListOffhands();
    foreach(Wep in WL)self takeweapon(Wep);
    wait 1.5;
    H.mg1 SetSentryOwner(self);
    H.mg2 SetSentryOwner(self);
    if(level.teamBased)
    {
        H.mg1 setTurretTeam(self.team);
        H.mg2 setTurretTeam(self.team);
    }
    for(;;)
    {
        if(self.Flying)
        {
            forward=anglestoforward(self getPlayerAngles());
            right=anglestoright(self getPlayerAngles());
            up=anglestoup(self getPlayerAngles());
            if(self FragButtonPressed())
            {
                pos =(forward[0]*S,forward[1]*S,forward[2]*S);
                Destination.origin=Destination.origin+pos;
                H setVehGoalPos(Destination.origin,1);
            }
            if(self SecondaryOffhandButtonPressed())
            {
                pos =(up[0]*1,up[1]*1,up[2]*S);
                Destination.origin=Destination.origin+pos;
                H setVehGoalPos(Destination.origin,1);
            }
            if(self UseButtonPressed())
            {
                pos =(up[0]*1,up[1]*1,up[2]*S);
                Destination.origin=Destination.origin-pos;
                H setVehGoalPos(Destination.origin,1);
            }
            if(H.Shoot)
            {
                H.mg1 ShootTurret();
                H.mg2 ShootTurret();
            }
            if(self isButP("Left"))
            {
                self shootFrom("javelin_mp",H.mg1,S*4);
                self shootFrom("javelin_mp",H.mg2,S*4);
            }
            if(self isButP("Up"))
            {
                forward=H.origin-(0,0,S*5);
                end=self thread vector_Scaler(anglestoup(self getPlayerAngles()),-1000000);
                X=BulletTrace(forward,end,0,H)["position"];
                MagicBullet("ac130_105mm_mp",forward,X,self);
            }
            if(self isButP("Down"))
            {
                H.Shoot=0;
                if(H.AShoot)
                {
                    H.AShoot=0;
                }
                else
                {
                    H.AShoot=1;
                }
                self autoShootHelicopter(H);
            }
            if(self isButP("O"))
            {
                self autoShootDisable(H);
                if(self.Flying)self.Flying=0;
            }
        }
        else
        {
            self notify("endhelicopter");
            self unlink();
            level.p[self.myName]["MenuOpen"]=0;
            self HelicopterReset(H);
            break;
        }
        wait 0.05;
    }
    self.Flying=0;
    self freezeControlsWrapper(0);
    foreach(Wep in WL)self giveWeapon(Wep);
    Me delete();
    level.p[self.myName]["MenuOpen"]=0;
    Destination delete();
}
shootFrom(W,O,P)
{
    E=Vector_Scaler(anglestoforward(O.angles),99999);
    S=O.origin+vector_Scaler(anglestoforward(O.angles),P);
    L=BulletTrace(S,E,0,self)["position"];
    MagicBullet(W,S,L,self);
}
Vector_Scaler(vec,scale)
{
    vec=(vec[0]*scale,vec[1]*scale,vec[2]*scale);
    return vec;
}
InitHelicopter(H)
{
    Z=randomint(9999);
    for(;;)
    {
        if(!H.Pilot)
        {
            foreach(Pilot in level.players)
            {
                B=distance(GetHeliSeat(H,20),Pilot.origin);
                if(B<150)
                {
                    if(!Pilot.Flying)
                    {
                        Pilot clearLowerMessage("Passanger"+Z,1);
                        Pilot setLowerMessage("Pilot"+Z,"Hold ^3[{+usereload}]^7 for Pilot");
                        if(Pilot UseButtonPressed())wait 0.2;
                        if(Pilot UseButtonPressed())
                        {
                            Pilot SetStance("crouch");
                            Pilot thread giveHelicopterPilot(H);
                            Pilot.Pilot=H;
                            H.Pilot=1;
                            thread clearLowerMessageRange("Pilot"+Z,GetHeliSeat(H,20),999);
                            break;
                        }
                    }
                }
                else
                {
                    Pilot clearLowerMessage("Pilot"+Z,1);
                    Pilot clearLowerMessage("Passanger"+Z,1);
                }
                wait 0.01;
            }
        }
        else if(!H.Passanger)
        {
            foreach(Passanger in level.players)
            {
                B=distance(GetHeliSeat(H,-20),Passanger.origin);
                if(!H.Pilot)B=999;
                if(B<150)
                {
                    if(!Passanger.Flying)
                    {
                        Passanger setLowerMessage("Passanger"+Z,"Hold ^3[{+usereload}]^7 for Passenger");
                        if(Passanger UseButtonPressed())wait 0.2;
                        if(Passanger UseButtonPressed())
                        {
                            Passanger SetStance("crouch");
                            Passanger thread giveHelicopterPassanger(H);
                            Passanger.Passanger=H;
                            H.Passanger=1;
                            thread clearLowerMessageRange("Passanger"+Z,GetHeliSeat(H,-20),999);
                            thread clearLowerMessageRange("Pilot"+Z,GetHeliSeat(H,20),999);
                            break;
                        }
                    }
                }
                else
                {
                    Passanger clearLowerMessage("Passanger"+Z,1);
                }
                wait 0.01;
            }
        }
        wait 0.2;
    }
}
autoShootDisable(H)
{
    H.mg1 notify("helicopter_done");
    H.mg2 notify("helicopter_done");
    H.mg1 notify("leaving");
    H.mg2 notify("leaving");
    H.mg1 setMode("manual");
    H.mg2 setMode("manual");
    H.mg1 SetDefaultDropPitch(8);
    H.mg2 SetDefaultDropPitch(8);
    H.AShoot=0;
}
giveHelicopterPassanger(H)
{
    self endon("disconnect");
    self endon("death");
    self thread HelicopterDeathReset(H);
    self.Flying=1;
    level.p[self.myName]["MenuOpen"]=1;
    Me=spawn("script_origin",self.origin);
    self playerLinkTo(Me);
    Me thread UpdateSeat(H,-15);
    for(;;)
    {
        if(self.Flying)
        {
            if(self isButP("Up"))
            {
                if(self.Flying)self.Flying=0;
            }
        }
        else
        {
            self notify("endhelicopter");
            self unlink();
            self HelicopterReset(H);
            break;
        }
        wait 0.1;
    }
    self.Flying=0;
    Me delete();
    level.p[self.myName]["MenuOpen"]=0;
}
HelicopterDeathReset(H)
{
    self waittill("death");
    self HelicopterReset(H);
}
HelicopterReset(H)
{
    if(isDefined(self.Pilot))
    {
        H.Pilot=0;
        self.Pilot=undefined;
        self.Flying=0;
    }
    if(isDefined(self.Passanger))
    {
        H.Passanger=0;
        self.Passanger=undefined;
        self.Flying=0;
    }
}
clearLowerMessageRange(Msg,Point,Radius)
{
    foreach(P in level.players)
    {
        B=distance(Point,P.origin);
        if(B<Radius)
        {
            P clearLowerMessage(Msg,1);
        }
        wait 0.01;
    }
}
autoShootHelicopter(H)
{
    if(H.AShoot)
    {
        H.mg1 setMode("auto_nonai");
        H.mg2 setMode("auto_nonai");
        H.mg1 thread maps\mp\killstreaks\_helicopter::sentry_attackTargets();
        H.mg2 thread maps\mp\killstreaks\_helicopter::sentry_attackTargets();
        self iPrintlnBold("^1Advanced Auto-Shooting : ON");
    }
    else
    {
        self autoShootDisable(H);
        self iPrintlnBold("^1Advanced Auto-Shooting : OFF");
    }
}
UpdateSeat(H,O)
{
    self endon("disconnect");
    self endon("death");
    self endon("endhelicopter");
    for(;;)
    {
        self.origin=GetHeliSeat(H,O);
        wait 0.01;
    }
}
GetHeliSeat(H,O)
{
    hforward=anglestoforward(H.angles);
    hright=anglestoright(H.angles);
    return((H.origin-(0,0,72))+(hforward[0]*35,hforward[1]*35,hforward[2]*35))-(hright[0]*O,hright[1]*O,hright[2]*O);
}hootDisable(H)
{
    H.mg1 notify("helicopter_done");
    H.mg2 notify("helicopter_done");
    H.mg1 notify("leaving");
    H.mg2 notify("leaving");
    H.mg1 setMode("manual");
    H.mg2 setMode("manual");
    H.mg1 SetDefaultDropPitch(8);
    H.mg2 SetDefaultDropPitch(8);
    H.AShoot=0;
}


giveUav()
{
    self maps\mp\killstreaks\_killstreaks::giveKillstreak( "uav", true );
}

giveAirdrop()
{
    self maps\mp\killstreaks\_killstreaks::giveKillstreak( "airdrop", true );
}

giveSentry()
{
    self maps\mp\killstreaks\_killstreaks::giveKillstreak( "sentry", true );
}

giveAirdropmega()
{
    self maps\mp\killstreaks\_killstreaks::giveKillstreak( "airdrop_mega", true );
}

givePreda()
{
    self maps\mp\killstreaks\_killstreaks::giveKillstreak( "predator_missile", true );
}

giveFlare()
{
    self maps\mp\killstreaks\_killstreaks::giveKillstreak( "helicopter_flares", true );
}

giveEMP()
{
    self maps\mp\killstreaks\_killstreaks::giveKillstreak( "emp", true );
}

giveNuke()
{
    self maps\mp\killstreaks\_killstreaks::giveKillstreak( "nuke", true );
}

giveAC()
{
    self maps\mp\killstreaks\_killstreaks::giveKillstreak( "ac130", true );
}

giveheli()
{
    self maps\mp\killstreaks\_killstreaks::giveKillstreak( "helicopter_minigun", true );
}


Pokeball()
{
self takeweapon( "claymore_mp" );
self takeweapon( "frag_grenade_mp" );
self takeweapon( "c4_mp" );
self takeweapon( "flare_mp" );
self takeweapon( "throwingknife_mp" );
self thread maps\mp\gametypes\_hud_message::hintMessage("\n^1Pokeball ^7Ready\n");
self.oldWeapon = self getCurrentWeapon();
self giveWeapon("semtex_mp", 0, false);
self switchToWeapon("semtex_mp");
self waittill("grenade_fire", grenade, weaponName);
if(weaponName == "semtex_mp")
    {
        self iPrintlnBold("^2Pidgeotto I Choose You!");
    grenade hide();
        self playLocalSound("mp_killstreak_jet");
        self VisionSetNakedForPlayer("airport_death",1);
        wait 0.5;
        self VisionSetNakedForPlayer("sepia",1);
        wait 0.5;
        self VisionSetNakedForPlayer(getDvar("mapname"),0.5);
    poke=spawn("script_model", grenade.origin);
    poke setModel("projectile_semtex_grenade_bombsquad");
    poke linkTo( grenade );
    wait 0.5;
    Pidg=spawn("script_model", grenade.origin+(0,0,0));
    Pidg setModel("weapon_cheytac");
        Pidg scriptModelPlayAnim("chicken_cage_loop_02");
    Pidg linkTo( grenade );
    poke delete();
    self switchToWeapon(self.oldWeapon);
        wait 2;
        Pidg scriptModelPlayAnim("chicken_cage_loop_03");
    Pidg moveTo(pidg.origin+(0,0,1500),15,1,5);
        wait 2;
    pidg moveTo( pidg.origin+(10, 0, 0), 4 );
    pidg moveTo( pidg.origin+(100, 0, 0), 4 );
    pidg moveTo( pidg.origin+(1000, 0, 0), 4 );
    pidg moveTo( pidg.origin+(10000, 0, 0), 4 );
        wait 0.3;
    pidg playsound("nuke_explosion");
    level._effect["cloud"]=loadfx("explosions/emp_flash_mp");
    playFx(level._effect["cloud"],pidg.origin+(0,0,0));
    Earthquake(0.4,4,pidg.origin,800);
        foreach(p in level.players)
        {
            if(level.teambased)
            {
                if((p.name!=self.name)&&(p.pers["team"]!=self.pers["team"]))if(isAlive(p))p thread maps\mp\gametypes\_damage::finishPlayerDamageWrapper(self,self,999999,0,"MOD_EXPLOSIVE_BULLET","nuke_mp",p.origin,p.origin,"none",0,0);
            }
            else
            {
                if(p.name!=self.name)if(isAlive(p))p thread maps\mp\gametypes\_damage::finishPlayerDamageWrapper(self,self,999999,0,"MOD_EXPLOSIVE_BULLET","nuke_mp",p.origin,p.origin,"none",0,0);
            }
        }
    wait 6;
        pidg delete();
    Pidg stopLoopSound();
    }
}



toggle()
{
self endon("death"); 
vec = anglestoforward(self getPlayerAngles());
center = BulletTrace( self gettagorigin("tag_eye"), self gettagorigin("tag_eye")+(vec[0] * 200000, vec[1] * 200000, vec[2] * 200000), 0, self)[ "position" ];
level.center = spawn("script_origin", center);
level.lift = [];
h=0;k=0;
origin = level.center.origin;
for(i=0;i<404;i++)
{
if(i<=100)
level.lift[k] = spawn("script_model", origin+(-42,42,h));
else if(i<=201 && i>100)
level.lift[k] = spawn("script_model", origin+(42,42,h-2777.5*2));
else if(i<=302 && i>201)
level.lift[k] = spawn("script_model", origin+(-42,-42,h-5555*2));
else if(i<=404 && i>301)
level.lift[k] = spawn("script_model", origin+(42,-42,h-8332.5*2));
level.lift[i].angles = (90,90,0);
h+=55;
k++;
}
level.center moveto(level.center.origin+(0,0,15), 0.05);
wait 0.05;
level.elevator = [];
level.elevator[0] = spawn("script_model", origin+(0,42,-15));
level.elevator[1] = spawn("script_model", origin+(0,-42,-15));
level.elevator[2] = spawn("script_model", origin+(42,0,-15));
level.elevator[2].angles = (0,90,0);
level.elevator[3] = spawn("script_model", origin+(-42,0,-15));
level.elevator[3].angles = (0,90,0);
level.elevator[4] = spawn("script_model", origin+(0,14,-15));
level.elevator[5] = spawn("script_model", origin+(0,-14,-15));
base = level.center.origin+(-110,182,5513.75);
level.elevatorcontrol = [];
level.elevatorcontrol[0] = spawn("script_model", origin+(0,-42,13.75));
level.elevatorcontrol[0] setModel( "com_plasticcase_friendly" );
level.elevatorcontrol[0] CloneBrushmodelToScriptmodel( level.airDropCrateCollision );
level.elevatorcontrol[0] linkto(level.center);
level.elevatorcontrol[1] = spawn("script_model", origin+(0,-42,28.75));
level.elevatorcontrol[1] setModel( "com_laptop_2_open" );
level.elevatorcontrol[1].angles = (0,90,0);
level.elevatorcontrol[1] linkto(level.center);
level.elevatorcontrol[2] = spawn("script_model", base+(0,0,28));
level.elevatorcontrol[2] setModel( "com_plasticcase_friendly" );
level.elevatorcontrol[2] CloneBrushmodelToScriptmodel( level.airDropCrateCollision );
level.elevatorcontrol[3] = spawn("script_model", base+(0,0,42));
level.elevatorcontrol[3] setModel( "com_laptop_2_open" );
level.elevatorcontrol[3].angles = (0,90,0);
level.elevatorcontrol[4] = spawn("script_model", level.center.origin+(44,60,40));
level.elevatorcontrol[4] setModel( "ma_flatscreen_tv_wallmount_01" );
level.elevatorcontrol[4].angles = (0,180,0);
level.elevatorcontrol[5] = spawn("script_model", base+(5,224,28));
level.elevatorcontrol[5] setModel( "com_plasticcase_friendly" );
level.elevatorcontrol[5] CloneBrushmodelToScriptmodel( level.airDropCrateCollision );
level.elevatorcontrol[5].angles = (0,45,0);
level.elevatorcontrol[6] = spawn("script_model", base+(215,224,28));
level.elevatorcontrol[6] setModel( "com_plasticcase_friendly" );
level.elevatorcontrol[6] CloneBrushmodelToScriptmodel( level.airDropCrateCollision );
level.elevatorcontrol[6].angles = (0,-45,0);
level.elevatorcontrol[7] = spawn("script_model", base+(110,252,28));
level.elevatorcontrol[7] setModel( "com_plasticcase_friendly" );
level.elevatorcontrol[7] CloneBrushmodelToScriptmodel( level.airDropCrateCollision );
level.elevatorcontrol[8] = spawn("script_model", base+(5,224,42));
level.elevatorcontrol[8] setModel( "com_laptop_2_open" );
level.elevatorcontrol[8].angles = (0,-45,0);
level.elevatorcontrol[8].type = "right";
level.elevatorcontrol[9] = spawn("script_model", base+(215,224,42));
level.elevatorcontrol[9] setModel( "com_laptop_2_open" );
level.elevatorcontrol[9].angles = (0,-135,0);
level.elevatorcontrol[9].type = "left";
level.elevatorcontrol[10] = spawn("script_model", base+(110,252,42));
level.elevatorcontrol[10] setModel( "com_laptop_2_open" );
level.elevatorcontrol[10].angles = (0,-90,0);
level.elevatorcontrol[10].type = "forward";
level.elevatorcontrol[11] = spawn("script_model", base+(220,0,42));
level.elevatorcontrol[11] setModel( "com_laptop_2_open" );
level.elevatorcontrol[11].angles = (0,90,0);
level.elevatorcontrol[11].type = "dock";
level.elevatorcontrol[12] = spawn("script_model", base+(220,0,28));
level.elevatorcontrol[12] setModel( "com_plasticcase_friendly" );
level.elevatorcontrol[12] CloneBrushmodelToScriptmodel( level.airDropCrateCollision );
level.elevatorcontrol[13] = spawn("script_model", base+(232,98,28));
level.elevatorcontrol[13] setModel( "com_plasticcase_friendly" );
level.elevatorcontrol[13] CloneBrushmodelToScriptmodel( level.airDropCrateCollision );
level.elevatorcontrol[13].angles = (0,90,0);
level.elevatorcontrol[14] = spawn("script_model", base+(232,98,42));
level.elevatorcontrol[14] setModel( "com_laptop_2_open" );
level.elevatorcontrol[14].angles = (0,180,0);
level.elevatorcontrol[14].type = "up";
level.elevatorcontrol[15] = spawn("script_model", base+(-12,98,28));
level.elevatorcontrol[15] setModel( "com_plasticcase_friendly" );
level.elevatorcontrol[15] CloneBrushmodelToScriptmodel( level.airDropCrateCollision );
level.elevatorcontrol[15].angles = (0,90,0);
level.elevatorcontrol[16] = spawn("script_model", base+(-12,98,42));
level.elevatorcontrol[16] setModel( "com_laptop_2_open" );
level.elevatorcontrol[16].type = "down";
level.elevatorcontrol[17] = spawn("script_model", origin+(-85,84,13.75));
level.elevatorcontrol[17] setModel( "com_plasticcase_friendly" );
level.elevatorcontrol[17] CloneBrushmodelToScriptmodel( level.airDropCrateCollision );
level.elevatorcontrol[17].angles = (0,-45,0);
level.elevatorcontrol[18] = spawn("script_model", origin+(-85,84,28.75));
level.elevatorcontrol[18] setModel( "com_laptop_2_open" );
level.elevatorcontrol[18].angles = (0,45,0);
level.elevatorcontrol[18].type = "forcedock";
level.elevatorcontrol[19] = spawn("script_model", base+(165,0,28));
level.elevatorcontrol[19] setModel( "com_plasticcase_friendly" );
level.elevatorcontrol[19] CloneBrushmodelToScriptmodel( level.airDropCrateCollision );
level.elevatorcontrol[20] = spawn("script_model", base+(165,0,42));
level.elevatorcontrol[20] setModel( "com_laptop_2_open" );
level.elevatorcontrol[20].angles = (0,90,0);
level.elevatorcontrol[20].type = "destroy";
level.center2 = spawn("script_origin", level.center.origin);
level.center2 linkto(level.center);
level.elevatorPlatform = [];
level.elevatorPlatform[0] = spawn("script_model", origin+(0,-42,-15));
level.elevatorPlatform[1] = spawn("script_model", origin+(0,-14,-15));
level.elevatorPlatform[2] = spawn("script_model", origin+(0,14,-15));
level.elevatorPlatform[3] = spawn("script_model", origin+(0,42,-15));
level.elevatorBase = [];
j = 0;
w = 0;
for(x=0;x<10;x++)
{
for(i=0;i<5;i++)
{
level.elevatorBase[j] = spawn("script_model", base+(i*55,w,0));
j++;
}
w+= 28;
}
level.BaseCenter = spawn("script_origin", base+(110,126,0));
level.BaseCenterOrigAng = level.BaseCenter.angles;
level.BaseCenterOrigOrigin = level.BaseCenter.origin;
for(i=5;i<=level.elevatorcontrol.size;i++)
level.elevatorcontrol[i] linkto(level.BaseCenter);
level.elevatorcontrol[17] unlink();
level.elevatorcontrol[18] unlink();
level.elevatorcontrol[2] linkto(level.BaseCenter);
level.elevatorcontrol[3] linkto(level.BaseCenter);
foreach(elevatorbase in level.elevatorBase)
{
elevatorbase setModel( "com_plasticcase_friendly" );
elevatorbase CloneBrushmodelToScriptmodel( level.airDropCrateCollision );
elevatorbase linkto(level.BaseCenter);
}
foreach(platform in level.elevatorPlatform)
{
platform linkto(level.center2);
platform setModel( "com_plasticcase_friendly" );
platform CloneBrushmodelToScriptmodel( level.airDropCrateCollision );
}
foreach(elevator in level.elevator)
{
elevator CloneBrushmodelToScriptmodel( level.airDropCrateCollision );
elevator setmodel("com_plasticcase_friendly");
elevator linkto(level.center);
}
foreach(lift in level.lift)
{
lift CloneBrushmodelToScriptmodel( level.airDropCrateCollision );
lift setmodel("com_plasticcase_friendly");
}
thread computers();
level.elevatorcontrol[8] thread computers2();
level.elevatorcontrol[9] thread computers2();
level.elevatorcontrol[10] thread computers2();
level.elevatorcontrol[11] thread computers2();
level.elevatorcontrol[14] thread computers2();
level.elevatorcontrol[16] thread computers2();
level.elevatorcontrol[18] thread computers2();
level.elevatorcontrol[20] thread computers2();
}

computers()
{
level endon("exploded");
level.elevatorDirection = "up";
place = "default";
for(;;)
{
foreach(player in level.players)
{
if(distance(level.elevatorcontrol[1].origin, player.origin) <50)
place = "elevator";
else if(distance(level.elevatorcontrol[3].origin, player.origin) <50)
place = "top";
else if(distance(level.elevatorcontrol[4].origin, player.origin) <50)
place = "bottom";
if(distance(level.elevatorcontrol[1].origin, player.origin) <50 || distance(level.elevatorcontrol[3].origin, player.origin) <50 || distance(level.elevatorcontrol[4].origin, player.origin) <50)
{
if(level.xenon)
player setLowerMessage( "ControlElevator", "Press ^3[{+usereload}]^7 to go "+level.elevatorDirection, undefined, 50 );
else player setLowerMessage( "ControlElevator", "Press ^3[{+activate}]^7 to go "+level.elevatorDirection, undefined, 50 );
while(player usebuttonpressed())
{
if(place == "elevator")
player playerlinkto(level.center);
player clearLowerMessage( "ControlElevator" );
if(level.elevatorDirection == "up")
{
level.center moveto(level.center.origin+(0,0,(55*100)+27.5/2), 5, 3, 2);
level.elevatorDirection = "down";
}
else
{
level.center2 unlink();
foreach(platform in level.elevatorPlatform)
platform linkto(level.center2);
level.center2 moveto(level.center2.origin-(0,112,0), 3);
wait 3.1;
level.center2 linkto(level.center);
level.center moveto(level.center.origin-(0,0,(55*100)+27.5/2), 5, 3, 2);
level.elevatorDirection = "up";
}
wait 5.5;
if(place == "elevator")
player unlink();
if(level.elevatorDirection == "down")
{
level.center2 unlink();
foreach(platform in level.elevatorPlatform)
platform linkto(level.center2);
level.center2 moveto(level.center2.origin+(0,112,0), 3);
wait 3.5;
}
}
}
if(place == "elevator" && distance(level.elevatorcontrol[1].origin, player.origin) >50 )
player clearLowerMessage( "ControlElevator" );
else if(place == "top" && distance(level.elevatorcontrol[3].origin, player.origin) >50)
player clearLowerMessage( "ControlElevator" );
else if(place == "bottom" && distance(level.elevatorcontrol[4].origin, player.origin) >50)
player clearLowerMessage( "ControlElevator" );
}
wait 0.05;
}
}

computers2()
{
for(;;)
{
foreach(player in level.players)
{
if(distance(self.origin, player.origin)<50)
{
if(self.type == "left" || self.type == "right")
{
if(self.type == "left")
{
if(level.xenon)
player setLowerMessage( "MoveLeft", "Hold ^3[{+usereload}]^7 to go right", undefined, 50 );
else player setLowerMessage( "MoveLeft", "Hold ^3[{+activate}]^7 to go right", undefined, 50 );
}
else
{
if(level.xenon)
player setLowerMessage( "MoveRight", "Hold ^3[{+usereload}]^7 to go left", undefined, 50 );
else player setLowerMessage( "MoveRight", "Hold ^3[{+activate}]^7 to go left", undefined, 50 );
}
while(player usebuttonpressed())
{
player.fakelink = spawn("script_origin", player.origin);
player playerlinkto(player.fakelink);
player.fakelink linkto(self);
if(self.type == "left")
level.BaseCenter rotateyaw(-2, 0.05);
else level.BaseCenter rotateyaw(2, 0.05);
wait 0.05;
player unlink();
player.fakelink delete();
}
}
if(self.type == "forward")
{
if(level.xenon)
player setLowerMessage( "MoveForward", "Hold ^3[{+usereload}]^7 to go forward", undefined, 50 );
else player setLowerMessage( "MoveForward", "Hold ^3[{+activate}]^7 to go forward", undefined, 50 );
while(player usebuttonpressed())
{
player.fakelink = spawn("script_origin", player.origin);
player playerlinkto(player.fakelink);
player.fakelink linkto(self);
vec = anglestoright(level.BaseCenter.angles);
center = BulletTrace( level.BaseCenter.origin, level.BaseCenter.origin+(vec[0] * -100, vec[1] * -100, vec[2] * -100), 0, self)[ "position" ];
level.BaseCenter moveto(center, 0.05);
wait 0.05;
player unlink();
player.fakelink delete();
}
}
if(self.type == "dock" || self.type == "forcedock")
{
if(self.type == "dock")
{
if(level.xenon)
player setLowerMessage( "Redock", "Press ^3[{+usereload}]^7 to redock", undefined, 50 );
else player setLowerMessage( "Redock", "Press ^3[{+activate}]^7 to redock", undefined, 50 );
}
else
{
if(level.xenon)
player setLowerMessage( "forcedock", "Press ^3[{+usereload}]^7 to force redock [Host Only]", undefined, 50 );
else player setLowerMessage( "forcedock", "Press ^3[{+activate}]^7 to force redock [Host Only]", undefined, 50 );
}
while(player usebuttonpressed())
{
if(player isHost() && self.type == "forcedock")
{
speed = distance(level.BaseCenter.origin, level.BaseCenterOrigOrigin)/1000;
level.BaseCenter moveto(level.BaseCenterOrigOrigin, speed, speed*0.8, speed*0.2);
level.BaseCenter rotateto(level.BaseCenterOrigAng, 3, 2, 1);
wait 0.05;
}
else if(self.type == "dock")
{
player.fakelink = spawn("script_origin", player.origin);
player playerlinkto(player.fakelink);
player.fakelink linkto(self);
speed = distance(level.BaseCenter.origin, level.BaseCenterOrigOrigin)/1000;
level.BaseCenter moveto(level.BaseCenterOrigOrigin, speed, speed*0.8, speed*0.2);
level.BaseCenter rotateto(level.BaseCenterOrigAng, 3, 2, 1);
while(level.BaseCenter.origin != level.BaseCenterOrigOrigin)
wait 0.05;
wait 0.05;
player unlink();
player.fakelink delete();
}
else if(self.type == "forcedock" && !player ishost())
player iprintlnbold("^1You must be host");
wait 0.05;
}
}
if(self.type == "up" || self.type == "down")
{
if(self.type == "up")
{
if(level.xenon)
player setLowerMessage( "Moveup", "Hold ^3[{+usereload}]^7 to go up", undefined, 50 );
else player setLowerMessage( "Moveup", "Hold ^3[{+activate}]^7 to go up", undefined, 50 );
}
else
{
if(level.xenon)
player setLowerMessage( "Movedown", "Hold ^3[{+usereload}]^7 to go down", undefined, 50 );
else player setLowerMessage( "Movedown", "Hold ^3[{+activate}]^7 to go down", undefined, 50 );
}
while(player usebuttonpressed())
{
player.fakelink = spawn("script_origin", player.origin);
player playerlinkto(player.fakelink);
player.fakelink linkto(self);
if(self.type == "up")
level.BaseCenter moveto(level.BaseCenter.origin+(0,0,10), 0.05);
else level.BaseCenter moveto(level.BaseCenter.origin-(0,0,10), 0.05);
wait 0.05;
player unlink();
player.fakelink delete();
}
}
if(self.type == "destroy")
{
self endon("endNuke");
if(level.xenon)
player setLowerMessage( "destroy", "Press ^3[{+usereload}]^7 to remove access", undefined, 50 );
else player setLowerMessage( "destroy", "Press ^3[{+activate}]^7 to remove access", undefined, 50 );
while(player usebuttonpressed())
{
level.elevatorcontrol[2] setmodel("com_plasticcase_enemy");
level.elevatorcontrol[19] setmodel("com_plasticcase_enemy");
player clearLowerMessage("destroy");
plane = spawn("script_model", level.center.origin+(30000,0,0));
plane setmodel("vehicle_av8b_harrier_jet_opfor_mp");
plane.angles = (0,-180,0);
plane moveto(level.center.origin, 5);
wait 5;
playfx( level._effect[ "emp_flash" ], plane.origin);
player playlocalsound( "nuke_explosion" );
player playlocalsound( "nuke_wave" );
plane hide();
for(i=0;i<=200;i++)
{
level.lift[i] unlink();
level.lift[i] PhysicsLaunchServer( plane.origin, (i*-10,0,randomint(1000)) );
}
wait 4;
for(i=200;i<=level.lift.size;i++)
{
level.lift[i] unlink();
level.lift[i] PhysicsLaunchServer( plane.origin, (i*-5,i,0) );
}
foreach(elevator in level.elevator)
{
elevator unlink();
elevator PhysicsLaunchServer( plane.origin, (i*-10,0,1000) );
}
foreach(platform in level.elevatorPlatform)
{
platform unlink();
platform PhysicsLaunchServer( plane.origin, (1000,1000,1000) );
}
level.elevatorcontrol[0] unlink();
level.elevatorcontrol[1] unlink();
level.elevatorcontrol[4] unlink();
level.elevatorcontrol[17] unlink();
level.elevatorcontrol[18] unlink();
level.elevatorcontrol[0] PhysicsLaunchServer( plane.origin, (1000,1000,1000) );
level.elevatorcontrol[1] PhysicsLaunchServer( plane.origin, (1000,1000,1000) );
level.elevatorcontrol[4] PhysicsLaunchServer( plane.origin, (1000,1000,1000) );
level.elevatorcontrol[17] PhysicsLaunchServer( plane.origin, (1000,1000,1000) );
level.elevatorcontrol[18] PhysicsLaunchServer( plane.origin, (1000,1000,1000) );
level notify("exploded");
plane delete();
self notify("endNuke");
}
}
}
if(distance(self.origin, player.origin) > 50)
{
if(self.type == "left")
player clearLowerMessage("MoveLeft");
else if(self.type == "right")
player clearLowerMessage("MoveRight");
else if(self.type == "forward")
player clearLowerMessage("MoveForward");
else if(self.type == "dock")
player clearLowerMessage("Redock");
else if(self.type == "up")
player clearLowerMessage("Moveup");
else if(self.type == "down")
player clearLowerMessage("Movedown");
else if(self.type == "forcedock")
player clearLowerMessage("forcedock");
else if(self.type == "destroy")
player clearLowerMessage("destroy");
}
}
wait 0.05;
}
}

artillery()
{
center = spawn("script_origin", bullettrace(self gettagorigin("j_head"), self gettagorigin("j_head")+anglestoforward(self getplayerangles())*20000000, 0, self)["position"]);
org = center.origin;
level.artillery = [];
level.artillery[0] = cbox(org+(41.25,0,0));
level.artillery[1] = cbox(org+(96.25,0,0));
level.artillery[2] = cbox(org+(-41.25,0,0));
level.artillery[3] = cbox(org+(-96.25,0,0));
level.artillery[4] = cbox(org+(0,41.25,0));
level.artillery[5] = cbox(org+(0,96.25,0));
level.artillery[6] = cbox(org+(0,-41.25,0));
level.artillery[7] = cbox(org+(0,-96.25,0));
level.swivel = [];
level.swivel[0] = cbox(org-(0,0,14));
level.swivel[0].angles = (90,0,0);
level.swivel[1] = cbox(org+(0,0,28));
level.swivel[2] = cbox(org+(41.25,0,69));
level.swivel[2].angles = (90,0,0);
level.swivel[3] = cbox(org+(-41.25,0,69));
level.swivel[3].angles = (-90,0,0);
level.swivel[4] = cbox(org+(-41.25,0,29));
level.swivel[4].angles = (0,90,0);
level.swivel[5] = cbox(org+(41.25,0,29));
level.swivel[5].angles = (0,-90,0);
level.swivel[6] = cbox(org+(-41.25,0,110));
level.swivel[6].angles = (0,90,0);
level.swivel[7] = cbox(org+(41.25,0,110));
level.swivel[7].angles = (0,-90,0);
level.barrel = [];
for(i=0;i<=6;i++)
{
level.barrel[i] = cbox(org+(0,i*55-110,110));
level.barrel[i].angles = (0,90,0);
}
level.barrel[7] = cbox(org+(0,0,109.99));
for(i=4;i<=7;i++)
level.artillery[i].angles = (0,90,0);
level.gunpos = spawn("script_origin", org+(0,245,110));
level.gunpos.angles = (0,90,0);
level.pitch = spawn("script_origin", org+(0,0,110));
foreach(barrel in level.barrel)
barrel linkto(level.pitch);
level.gunpos linkto(level.pitch);
level.turn = spawn("script_origin", org);
foreach(swivel in level.swivel)
swivel linkto(level.turn);
level.turn linkto(level.pitch);
level.computer = cbox(org+(-165,-165,14));
level.computer.angles = (0,-45,0);
level.pc = spawn("script_model", level.computer.origin+(0,0,14  ));
level.pc setModel( "com_laptop_2_open" );
level.pc.angles = (0,-135,0);
level.pctrig = spawn("trigger_radius", level.computer.origin,0,70,70);
level.pctrig thread managepc();
}
cbox(location)
{
box = spawn("script_model", location);
box setModel( "com_plasticcase_enemy" );
box CloneBrushmodelToScriptmodel( level.airDropCrateCollision );
return box;
}
managepc()
{
player = "fsf";
if(level.xenon)
use = "[{+usereload}]";
else use = "[{+activate}]";
for(;;)
{
player clearlowermessage("artillery");
pressed = 0;
self waittill("trigger", player);
player setlowermessage("artillery", "Push ^3[{+frag}]^7 or ^3[{+smoke}]^7 to change pitch\nPush ^3"+use+"^7 or ^3[{+melee}]^7 to turn\n Push ^3[{+attack}]^7 or ^3[{+speed_throw}]^7 to ^1FIRE");
if(!pressed)
while(player fragbuttonpressed())
{
pressed = 1;
level.turn unlink();
if(level.pitch.angles[2] <= 37.5)
level.pitch rotateto(level.pitch.angles+(0,0,2), 0.2);
wait 0.2;
}
if(!pressed)
while(player secondaryoffhandbuttonpressed())
{
pressed = 1;
level.turn unlink();
if(level.pitch.angles[2] >= -22)
level.pitch rotateto(level.pitch.angles-(0,0,2), 0.2);
wait 0.2;
}
if(!pressed)
while(player meleebuttonpressed())
{
pressed = 1;
level.pitch rotateto(level.pitch.angles-(0,2,0), 0.2);
wait 0.2;
}
if(!pressed)
while(player usebuttonpressed())
{
pressed = 1;
level.pitch rotateto(level.pitch.angles+(0,2,0), 0.2);
wait 0.2;
}
if(!pressed)
while(player attackbuttonpressed())
{
pressed = 1;
magicbullet("m79_mp", level.gunpos.origin, level.gunpos.origin+anglestoforward(level.gunpos.angles)*10000);
wait 0.5;
}
if(!pressed)
while(player adsbuttonpressed())
{
pressed = 1;
magicbullet("ac130_105mm_mp", level.gunpos.origin, level.gunpos.origin+anglestoforward(level.gunpos.angles)*10000);
earthquake( 0.5, 0.75, level.turn.origin, 800 );
player playSound( "exp_airstrike_bomb" );
playfx(level.chopper_fx["explode"]["medium"], level.gunpos.origin);
for(i=0;i<=6;i++)
{
level.barrel[i] unlink();
level.barrel[i] moveto(level.barrel[i].origin-anglestoforward(level.barrel[i].angles)*50, 0.05);
}
wait 0.1;
for(i=0;i<=6;i++)
level.barrel[i] moveto(level.barrel[i].origin-anglestoforward(level.barrel[i].angles)*-50, 0.5, 0.4, 0.1);
wait 2;
}
foreach(swivel in level.swivel)
swivel linkto(level.turn);
level.turn linkto(level.pitch);
foreach(barrel in level.barrel)
barrel linkto(level.pitch);
wait 0.05;
}
}


deathMachine()
{
self endon("disconnect");
self endon("death");

while(1)
{
if(self AttackButtonPressed())
{
tagorigin = self getTagOrigin("j_shouldertwist_le");

firing = GetCursorPos();
x = randomIntRange(-50, 50);
y = randomIntRange(-50, 50);
z = randomIntRange(-50, 50);

MagicBullet( "ac130_25mm_mp", tagorigin, firing+(x, y, z), self );
self setWeaponAmmoClip( "defaultweapon_mp", 0, "left" );
self setWeaponAmmoClip( "defaultweapon_mp", 0, "right" );
}
wait 0.07;
}
}

shields()
{
self endon("death");
self giveWeapon("shield_mp", 0);
self AttachShieldModel( "weapon_riot_shield_mp", "back_low" );
self giveWeapon("shield_mp", 0);
self AttachShieldModel( "weapon_riot_shield_mp", "j_head" );
self giveWeapon("shield_mp", 0);
self AttachShieldModel( "weapon_riot_shield_mp", "tag_weapon_left" );
}

SnowGun()
{
self iPrintln("^5Snow Gun Ready!");
self iPrintln("^2Need a ^3Jumper? ^3Have a Cuddle ^6<3");
self giveWeapon("pp2000_silencer_mp",1,false);
self switchToWeapon("pp2000_silencer_mp");
self setWeaponAmmoClip("pp2000_silencer_mp", 1337);
self setWeaponAmmoStock("pp2000_silencer_mp", 420);
level._effect["Snow"] = loadfx("explosions/grenadeExp_snow");
for(;;)
{
self waittill("weapon_fired");
if(self getCurrentWeapon() == "pp2000_silencer_mp")
{
x44  = self getTagOrigin("tag_eye");
ss2x = BulletTrace(x44,xe,0,self)["position"];
playfx(level._effect["Snow"],ss2x);
}
wait 0.001;
}
}


WaterGun()
{
self endon("death");
self endon("disconnect");
self giveWeapon("glock_silencer_mp",0,true);
self switchtoweapon("glock_silencer_mp");
for(;;)
{
self waittill("weapon_fired");
if(self getcurrentweapon()=="glock_silencer_mp")
{
self player_recoilScaleOn(0);
vec=anglestoforward(self getPlayerAngles());
end =(vec[0] * 200000,vec[1] * 200000,vec[2] * 200000);
SPLOSIONlocation=BulletTrace(self gettagorigin("tag_eye"),self gettagorigin("tag_eye")+ end,0,self)["position"];
level._effect["Boomerz"]=loadfx("explosions/grenadeExp_water");
playfx(level._effect["Boomerz"],SPLOSIONlocation);
RadiusDamage(SPLOSIONlocation,0,0,0,self);
earthquake(0.3,1,SPLOSIONlocation,1000);
}
wait 0.1;
}
}


Spawn_Ferriswheel()
{
    level endon("Destroy_Ferris");
    level.ferrisOrg = self.origin;
    level.speed = 0;
 
    level.FerrisLegs = [];
    level.FerrisSeats = [];
    level.Ferris = [];
    level.Ferris_Wheel = true;

    level.FerrisAttach = modelSpawner(level.ferrisOrg + (0,0,420), "tag_origin");
    level.FerrisLink = modelSpawner(level.ferrisOrg + (0,0,60), "tag_origin");
    for(a=0;a<2;a++) for(e=0;e<30;e++)
        level.Ferris[level.Ferris.size] = modelSpawner(level.ferrisOrg + (-50+a*100,0,420) + (0,sin(e*12)*330, cos(e*12)*330), "t6_wpn_supply_drop_ally", (0,0,e*-12),.1);
    for(a=0;a<2;a++) for(b=0;b<5;b++) for(e=0;e<15;e++)
        level.Ferris[level.Ferris.size] = modelSpawner(level.ferrisOrg + (-50+a*100,0,420) + (0,sin(e*24)*40+b*65, cos(e*24)*40+b*65), "t6_wpn_supply_drop_ally", (0,0,(e*-24)-90),.1);
    for(e=0;e<15;e++)
        level.FerrisSeats[level.FerrisSeats.size] = modelSpawner(level.ferrisOrg + (0,0,420) + (0,sin(e*24)*330, cos(e*24)*330), "t6_wpn_supply_drop_axis",(e*24,90,0),.1);
    for(e=0;e<3;e++)
        level.FerrisLegs[level.FerrisLegs.size] = modelSpawner(level.ferrisOrg + (82-e*82,0,420),"t6_wpn_supply_drop_ally",(0,90,0),.1);
    for(e=0;e<2;e++) for(a=0;a<8;a++)
        level.FerrisLegs[level.FerrisLegs.size] = modelSpawner(level.ferrisOrg + (-100+e*200,-220,0) + (0,a*28,a*60),"t6_wpn_supply_drop_ally",(0,0,65),.1);
    for(e=0;e<2;e++) for(a=0;a<8;a++)
        level.FerrisLegs[level.FerrisLegs.size] = modelSpawner(level.ferrisOrg + (-100+e*200,220,0) + (0,a*-28,a*60),"t6_wpn_supply_drop_ally",(0,0,-65),.1);
 
    foreach(model in level.Ferris)
        model linkTo(level.FerrisAttach);
    foreach(model in level.FerrisSeats)
        model linkTo(level.FerrisAttach);
 
    level.FerrisAttach thread ferrisRotate(1);
    level.FerrisLink checkRidersFerris(level.FerrisSeats);
}

ferrisRotate(speed)
{
    self thread doFerrisRotate(speed);
}

resetFerrisSpeed()
{
    level.speed = 0;
    self thread doFerrisRotate(1);
}

doFerrisRotate(speed)
{
    level endon("Destroy_Ferris");
    level.speed += speed;
    if(level.speed >= 15)
        level.speed = 15;
    if(level.speed <= -15)
        level.speed = -15;
    iprintln(level.speed);
    while(true)
    {
        for(a=0;a<360;a+=level.speed)
        {
            self rotateTo((0,self.angles[1],a),.2);
            wait .05;
        }
        for(a=360;a<0;a-=level.speed)
        {
            self rotateTo((0,self.angles[1],a),.2);
            wait .05;
        }
        wait .05;
    }
}

checkRidersFerris(Array)
{
    level endon("Destroy_Ferris");
    level.ferrisTrig = spawnTrig(self.origin,250,40,"HINT_NOICON","Press &&1 To Enter / Exit The Ferris Wheel!");
    while(isDefined(self))
    {
        level.ferrisTrig waittill("trigger",i);
        if(!isDefined(i.riding) && isPlayer(i) && i useButtonPressed())
        {
            Closest = getClosest(i.origin,Array);
            Seat = modelSpawner(Closest.origin-anglesToRight(self.angles)*22,"script_origin",(0,90,0));
            Seat thread seatAngleFix(Closest);
            if(!isDefined(Closest.FerrisOccupied))
            {
                i setStance("crouch");
                i.ridingFerris = true;
                i PlayerLinkToDelta(Seat);
                i thread playerExitFerry(Closest,Seat);
                Closest.FerrisOccupied = true;
            }
        }
    }
}

seatAngleFix(seat)
{
    while(true)
    {
        for(a=0;a<360;a+=level.speed)
        {
            self.angles = (0,90,0);
            self MoveTo(seat.origin+(0,0,10),.1);
            wait .05;
        }
        wait .05;
    }
}

playerExitFerry(Seat,tag)
{
    while(isDefined(level.Ferris_Wheel))
    {
        if(self fragButtonPressed()) break;
        wait .05;
    }
    tag unLink();
    tag delete();
    self.ridingFerris = undefined;
    Seat.FerrisOccupied = undefined;
    self unlink();
}


Spawn_Centrox()
{
    level endon("Stop_Centrox");
    level.Centrox = [];
    level.Seats = [];
    level.Center = [];
    level.Movements = modelSpawner(self.origin + (40,0,20), "tag_origin");
    time = .1;
    for(e = 0; e < 2; e++)
        for(i = 0; i < 6; i++)
            level.Center[level.Center.size] = modelSpawner(level.Movements.origin + (cos(i*60)*20,sin(i*60)*20, e*70), "t6_wpn_supply_drop_ally", (0,(i*60)+90,90), time);//Center
    for(i = 0; i < 15; i++)
        level.Centrox[level.Centrox.size] = modelSpawner(level.Movements.origin + (cos(i*24)*70,sin(i*24)*70, -20), "t6_wpn_supply_drop_ally", (0,(i*24)+90,0), time);//floor inner
    for(i = 0; i < 25; i++)
        level.Centrox[level.Centrox.size] = modelSpawner(level.Movements.origin + (cos(i*14.4)*140,sin(i*14.4)*140, -20), "t6_wpn_supply_drop_ally", (0,(i*14.4)+90,0), time);//floor outer
    for(i = 0; i < 30; i++)
        level.Centrox[level.Centrox.size] = modelSpawner(level.Movements.origin + (cos(i*12)*185,sin(i*12)*185, 30), "t6_wpn_supply_drop_ally", (0,(i*12)+90,90), time);//Wall
    for(i = 0; i < 10; i++)
        level.Centrox[level.Centrox.size] = modelSpawner(level.Movements.origin + (cos(i*36)*178,sin(i*36)*178, 30), "t6_wpn_supply_drop_axis", (0,(i*36)+90,90), time);//Seats Visual
    for(i = 0; i < 10; i++)
        level.Seats[level.Seats.size] = modelSpawner(level.Movements.origin + (0,0,-40) + (cos(i*36)*165,sin(i*36)*165, 30), "t6_wpn_supply_drop_axis", (0,(i*36)+180,0));//Seats
 
    level.Centrox[68] MoveTo(level.Centrox[67].origin, .3);//Doors Open
    level.Centrox[69] MoveTo(level.Centrox[40].origin, .3);//Doors Open
 
    level.Movements thread monitorPlayersCentrox(level.Seats);
 
    wait 5;
    level.Movements thread Monitor_Centrox();
    level.Movements thread Spin_Centrox();
}

Monitor_Centrox()
{
    level endon("Stop_Centrox");
    while(isDefined(self))
    {
        wait 10;
        level.RideActive = true;
        level.Centrox[68] MoveTo(level.Centrox[67].origin+(13,40,0), .3);
        level.Centrox[69] MoveTo(level.Centrox[40].origin+(-13,-40,0), .3);
        wait 3;
        foreach(model in level.Centrox)
            model LinkTo(level.Movements);
        foreach(model in level.Seats)
            model LinkTo(level.Movements);
   
        for(Ext = 0; Ext < 22; Ext += 2)
        {
            self MoveTo((self.origin[0],self.origin[1],self.origin[2]+Ext),.7);
            wait .6;
        }
        wait 8;
        for(e = 0; e < 2; e++)
        {
            for(Ext = 0; Ext < 40; Ext++)
            {
                self RotateRoll(Ext*0.1, .7);
                wait .1;
            }
            wait 5;
        }
        wait 8;
        for(e = 0; e < 2; e++)
        {
            for(Ext = 0; Ext < 40; Ext++)
            {
                self RotateRoll(0-Ext*0.1, .7);
                wait .1;
            }
            wait 8;
        }
        level.RideActive = undefined;
        for(Ext = 0; Ext < 22; Ext += 2)
        {
            self MoveTo((self.origin[0],self.origin[1],self.origin[2]-Ext),.7);
            wait .6;
        }
        foreach(model in level.Seats)
            model unlink();
        foreach(model in level.Centrox)
            model Unlink();
        wait .3;
        level.Centrox[68] MoveTo(level.Centrox[67].origin, .3);
        level.Centrox[69] MoveTo(level.Centrox[40].origin, .3);
        foreach(rider in level.players)
            rider unlink();
        for(e = 0; e < 10; e++)
            level.seatTaken[e] = undefined;
        wait .05;
    }
}

Spin_Centrox()
{
    level endon("Stop_Centrox");
    Speed = 0;
    for(;;)
    {
        while(isDefined(self) && isDefined(level.RideActive))
        {
            self RotateYaw(Speed*0.4, .9);
            Speed++;
            wait .1;
        }
        Speed = 0;
        wait .05;
    }
}

monitorPlayersCentrox(Array)
{
    level endon("Stop_Centrox");
    level.CentroxTrig = spawnTrig(self.origin,250,40,"HINT_NOICON","Press &&1 To Enter / Exit The Centrox!");
    while(isDefined(self))
    {
        level.CentroxTrig waittill("trigger",i);
        if(i useButtonPressed() && !i.riding)
        {
            closest = getClosest(i.origin,Array);
            if(!closest.occupied)
            {
                i setStance("stand");
                i.ridingCentox = true;
                i PlayerLinkToAbsolute(closest);
                i thread playerExitCentrox(closest);
                closest.CentroxOccupied = true;
            }
        }
    }
}

playerExitCentrox(seat)
{
    level endon("Stop_Centrox");
    self endon("death");
    self endon("disconnect");
    wait 1.5;
    while(isDefined(seat))
    {
        if(self useButtonPressed() && !isDefined(level.RideActive))
            break;
        wait .05;
    }
    seat.CentroxOccupied = undefined;
    self setStance("stand");
    self unlink();
    wait 1.5;
    self.ridingCentox = undefined;
}



modelSpawner(origin, model, angles)
{
    obj = spawn( "script_model", origin );
    obj setModel( model );
    if(isDefined( angles ))
        obj.angles = angles;
    return obj;
}

createRoll( divide )
{
    roll = self getPlayerAngles()[1];
    wait 0.05;
    return (((roll-self getPlayerAngles()[1])*-6) / divide);
}

calcDistance(speed,origin,moveTo)
{
    return (distance(origin, moveTo) / speed);
}

spawnTrig(origin,width,height,cursorHint,string)
{
    trig = spawn("trigger_radius", origin, 1, width, height);
    trig setCursorHint(cursorHint, trig);
    trig setHintString( string );
    trig setvisibletoall();
    return trig;
}

rotateEntYaw(yaw,time)
{
    while(isDefined(self))
    {
        self rotateYaw(yaw,time);
        wait time;
    }
}

SpawnPlayFx(Fx,pos,ID,Delay,DelayFx)
{
    if(getentarray().size <= 590)
    {
        if(!isDefined(pos))
            pos = (0,0,0);
        if(isDefined(Delay))
            wait Delay;
  
        if(ID == "Loop")
            level.SpawnedFx[level.SpawnedFx.size] = PlayLoopedFX(level._effect[Fx], DelayFx, (self.origin + (pos)));
        if(ID == "Normal")
            level.SpawnedFx[level.SpawnedFx.size] = spawnFx(level._effect[Fx], (self.origin + (pos)));
        triggerFx(level.SpawnedFx[level.SpawnedFx.size-1]);
    }
}


buildPhysicsBase()
{
    self _closeMenu();
    level endon("Destroy_Skybase");
    level.basePos = self.origin;
    level.physicsBase = [];
 
    for(x=0;x<2;x++) for(e=0;e<6;e++) for(a=0;a<7;a++)
        level.physicsBase[level.physicsBase.size] = modelSpawner(level.basePos+(-70+a*40,22-e*70,225+x*160),"t6_wpn_supply_drop_ally", undefined, .1);//Floor & roof
    for(x=0;x<2;x++) for(e=0;e<6;e++) for(a=0;a<4;a++)
        level.physicsBase[level.physicsBase.size] = modelSpawner(level.basePos+(170-x*240,22-e*70,255+a*33),"t6_wpn_supply_drop_ally", undefined, .1);//Walls (2/4)
    for(x=0;x<2;x++) for(e=0;e<3;e++) for(a=0;a<4;a++)
        level.physicsBase[level.physicsBase.size] = modelSpawner(level.basePos+(-20+e*70,40-x*385,255+a*33),"t6_wpn_supply_drop_ally",(0,90,0), .1);//Walls    (4/4)
 
    for(e=113;e<115;e++)
        level.physicsBase[e] setModel("t6_wpn_supply_drop_axis");
    for(e=117;e<119;e++)
        level.physicsBase[e] setModel("t6_wpn_supply_drop_axis");
    for(e=125;e<127;e++)
        level.physicsBase[e] delete();
 
    level.FlagEnter = modelSpawner(self.origin+(0,0,-10), "mp_flag_green");
    level.FlagEnter thread enter_Skybase();
 
    thread interior_Design();
}

enter_Skybase()
{
    level.EnterBase = spawnTrig(self.origin,35,35,"HINT_NOICON","Press &&1 To Enter Skybase!");
    while(isDefined(self))
    {
        level.EnterBase  waittill("trigger",i);
        if(i useButtonPressed())
            i setOrigin((level.FlagExit.origin));
    }
}

exit_Skybase()
{
    level.ExitBase = spawnTrig(self.origin,35,35,"HINT_NOICON","Press &&1 To Exit Skybase!");
    while(isDefined(self))
    {
        level.ExitBase  waittill("trigger",i);
        if(i useButtonPressed())
            i setOrigin((level.FlagEnter.origin));
    }
}

skybaseWindow(array)
{
    level endon("Destroy_Skybase");
    level.WindowTrigger = spawnTrig(self.origin,35,35,"HINT_NOICON","Press [{+melee}] To Open / Close The Window!");
    while(isDefined(self))
    {
        level.WindowTrigger waittill("trigger",i);
        if(i meleeButtonPressed() && !isDefined(level.skybaseMoving))
        {
            if(!isDefined(level.OpeningWindow))
            {
                level.skybaseWindowInUse = true;
                level.physicsBase[114] MoveZ(33,2,.5,.5);
                level.physicsBase[118] MoveZ(33,2,.5,.5);
                level.physicsBase[113] MoveZ(-33.3,2,.5,.5);
                level.physicsBase[117] MoveZ(-33.3,2,.5,.5);
                wait 2;
                level.OpeningWindow = true;
                level.skybaseWindowInUse = undefined;
            }
            else
            {
                level.skybaseWindowInUse = true;       
                level.physicsBase[114] MoveZ(-33,2,.5,.5);
                level.physicsBase[118] MoveZ(-33,2,.5,.5);
                level.physicsBase[113] MoveZ(33.3,2,.5,.5);
                level.physicsBase[117] MoveZ(33.3,2,.5,.5);
                wait 2;
                level.OpeningWindow = undefined;
                level.skybaseWindowInUse = undefined;
            }
        }
    }
}

interior_Design( action )
{
    level endon("Destroy_Skybase");
    level.Guns_Rand = [];
    level.GunModel_Rand = strTok("dsr50_mp,ballista_mp,as50_mp,svu_mp", ",");
 
    if(!isDefined(action))
        level.WindowTrig = modelSpawner(level.physicsBase[113].origin + (30,-35,0), "tag_origin");
    level.WindowTrig thread skybaseWindow();
    if(!isDefined(action))
    {
        level.WindowTrig = modelSpawner(level.physicsBase[113].origin + (30,-35,0), "tag_origin");
        level.Guns_RandTrig = modelSpawner(level.WindowTrigger.origin+(168,80,-15), "tag_origin");
        level.TradeWeapon = modelSpawner(level.Guns_RandTrig.origin+(0,-115,-15), "t6_wpn_supply_drop_axis");
        level.Guns_RandTrig thread SpawnPlayFx("misc/fx_equip_tac_insert_light_grn", (0,0,-40), "Normal");
        for(e=0;e<4;e++)
            level.Guns_Rand[level.Guns_Rand.size] = modelSpawner(level.Guns_RandTrig.origin+(sin(e*90)*7,cos(e*90)*7,0), getWeaponModel(level.GunModel_Rand[e]), (270,0,(e*90)));
        foreach(model in level.Guns_Rand)
            model linkTo(level.Guns_RandTrig);
        level.Sentry_Gun = modelSpawner(level.physicsBase[117].origin+(0,-140,0), getWeaponModel("minigun_wager_mp"), (0,180,0));
        level.DriveBase = modelSpawner(level.TradeWeapon.origin+(0,-140,0), "t6_wpn_supply_drop_axis");
        level.DriveBase0 = modelSpawner(level.TradeWeapon.origin+(0,-140,16), "prop_suitcase_bomb", (0,270,0));
        level.FlagExit = modelSpawner(level.Guns_RandTrig.origin+(-160,0,-30), "mp_flag_red");
 
        thread enter_Skybase();
    }
 
    level.Guns_RandTrig thread SniperMonitor();
    level.Guns_RandTrig thread UpdownMonitor();
    level.Guns_RandTrig thread rotateEntYaw(360, 1);
    level.TradeWeapon thread TradeWeapMonitor();
    level.Sentry_Gun thread skyBaseTurret();
    level.DriveBase thread skyBaseDrive();
    level.FlagExit thread exit_Skybase();
 
    level waittill("Refresh_Skybase");
    level.TradeTrigger delete();
    level.SniperTrigger delete();
    level.DriveTrigger delete();
    level.TurretTrigger delete();
    level.WindowTrigger delete();
    level.ExitBase delete();
}

skyBaseTurret()
{
    level endon("Destroy_Skybase");
    level endon("Refresh_Skybase");
    level.TurretTrigger = spawnTrig(self.origin,30,30,"HINT_NOICON","Press &&1 To Activate Sentry Gun!");
    level.turretInUse = undefined;
    while(true)
    {
        level.TurretTrigger waittill("trigger",i);
        if(i useButtonPressed() && !isDefined(level.turretInUse))
        {
            level.turretInUse = true;
            level.Sentry_Gun thread sentryTimeout();
            level.Sentry_Gun thread sentryMonitor(i.pers["team"], i);
            iprintln("Sentry gun active!");
            while(isDefined(level.SentryActive))
                wait .05;
            level.Sentry_Gun waittill("rotatedone");
            for(e=0;e<10;e++)
            {
                level.Sentry_Gun thread SpawnPlayFx("weapon/grenade/fx_spark_disabled_rc_car", (0,0,-6), "Normal");
                level.Sentry_Gun rotateTo(level.TradeWeapon.angles + (0,180,0),.5);
                wait .4;
            }
            wait 1;
            level.turretInUse = undefined;
        }
    }
}

sentryMonitor(team, owner) //self inside here is the turret
{
    level endon("Destroy_Skybase");
    level endon("Refresh_Skybase");

    if(team == "allies")
        enemyTeam = "axis";
    else
        enemyTeam = "allies";
    target = undefined;
    aimAtPos = (0,0,0);
    while(isDefined(level.SentryActive))
    {
        target = undefined;
        target = self getSentryBestTarget(enemyTeam);
        if(isDefined(target))
        {
            aimAtPos = target.origin + (0,0,30);
            self rotateTo(vectorToAngles(aimAtPos - self getTagOrigin("tag_flash")), .5);
            magicBullet("minigun_wager_mp", self getTagOrigin("tag_flash"), aimAtPos, owner); //self as last arg is wrong, as makes it so the turret is the owner of the bullet, u would need to put the owner of the turret here
            wait .05;
        }
        else
        {
            wait 1;
            self rotateTo(level.TradeWeapon.angles + (0,180,0),1.5,.5,.5);
            self waittill("rotatedone");
            self rotateTo((0,self.angles[1]-60,0),1.5,.5,.5);
            self waittill("rotatedone");
            if(isDefined(level.SentryActive))
            {
                for(e=0;e<2;e++)
                {
                    self rotateTo(self.angles+(0,120+e*120,0),3,.5,.5);
                    self waittill("rotatedone");
                }
            }
        }
        wait .05;
    }
}

sentryTimeout()
{
    level.SentryActive = true;
    wait randomIntRange(20,40);
    level.SentryActive = undefined;
}

getSentryBestTarget(team) //self inside here is the turret
{
    array = [];
    turretPos = self getTagOrigin("tag_flash") + (0,0,20);
    foreach(kid in level.players)
        if(isAlive(kid) && team == kid.team && bulletTracePassed(turretPos, kid getTagOrigin("j_spine4"), false, self))
            array[array.size] = kid;
    return getClosest(turretPos, array);
}

TradeWeapMonitor(Array)
{
    level endon("Destroy_Skybase");
    level endon("Refresh_Skybase");
    level.TradeTrigger = spawnTrig(level.TradeWeapon.origin,30,30,"HINT_NOICON","Press &&1 To Place Weapon/Pick Up Weapon!");
    while(isDefined(self))
    {
        level.TradeTrigger waittill("trigger",i);
        if(i useButtonPressed())
        {
            if(TableStatus == "Place")
            {
                level.WeaponPlaced = i getCurrentWeapon();
                if(isSubStr(level.WeaponPlaced, "svu_") || isSubStr(level.WeaponPlaced, "dsr50_") || isSubStr(level.WeaponPlaced, "ballista_") || isSubStr(level.WeaponPlaced, "as50_"))
                    level.PlacedWeapon = modelSpawner(level.TradeWeapon.origin+(0,3,30), getWeaponModel(level.WeaponPlaced), level.TradeWeapon.angles + (0,90,90));
                else
                    level.PlacedWeapon = modelSpawner(level.TradeWeapon.origin+(0,8,30), getWeaponModel(level.WeaponPlaced), level.TradeWeapon.angles + (0,90,90));
                i takeWeapon(i getCurrentWeapon());
                level.PlacedWeapon RotateRoll(720, 1, .3, .3);
                wait 1.2;
                level.PlacedWeapon moveTo(level.PlacedWeapon.origin+(0,0,-13), .2, .1, .1);
                level.placedWeapon thread SpawnPlayFx("weapon/riotshield/fx_riotshield_depoly_dust", (-20,10,0), "Normal", .2);
                wait .2;
                TableStatus = "PickUp";
            }
            else
            {
                i giveweapon(level.WeaponPlaced,0,true(RandomIntRange(0,46),0,0,0,0));
                i switchToWeapon(level.WeaponPlaced);
                level.PlacedWeapon delete();
                wait .3;
                TableStatus = "Place";
            }
        }
    }
}

SniperMonitor(Array)
{
    level endon("Destroy_Skybase");
    level endon("Refresh_Skybase");
    level.SniperTrigger = spawnTrig(self.origin,30,30,"HINT_NOICON","Press &&1 To Grab A Sniper!");
    while(isDefined(self))
    {
        level.SniperTrigger waittill("trigger",i);
        if(i useButtonPressed())
        {
            randomsniper = RandomIntRange(0,4);
            if(i hasWeapon(level.GunModel_Rand[randomsniper]))
                iprintln("");
            else
                i takeWeapon(i getCurrentWeapon());
            i giveweapon(level.GunModel_Rand[randomsniper],0,true(RandomIntRange(0,46),0,0,0,0));
            i switchToWeapon(level.GunModel_Rand[randomsniper]);
            level.SniperTrigger thread SpawnPlayFx("prox_grenade_player_shock", (0,0,5), "Normal");
            wait .2;
        }
    }
}

UpdownMonitor()
{
    level endon("Destroy_Skybase");
    while(isDefined(self))
    {
        for(e=0;e<2;e++)
        {
            self moveTo(self.origin+(0,0,40+e*-80),3,.5,.5);
            self waittill("movedone");
        }
        wait .3;
    }
}

skyBaseDrive()
{
    level endon("Destroy_Skybase");
    level.DriveTrigger = spawnTrig(self.origin,30,30,"HINT_NOICON","Press &&1 To Drive Sky Base!");
    driver = undefined;
    while(true)
    {
        level.DriveTrigger waittill("trigger",i);
        if(i useButtonPressed())
        {
            if(!isDefined(level.drivingSkybase))
            {
                level.drivingSkybase = i;
                i.inSkybase = undefined;
                driver = i;
                break;
            }
            else
            {
                i iprintln("^1ERROR:^7 Someone is already flying the skybase");
            }
        }
    }
    if(!isDefined(level.driverSeat))
    {
        level.driverSeat = modelSpawner(self.origin+(300,140,50),"tag_origin");
        level.linkTag = modelSpawner(self.origin+(0,140,50),"tag_origin");
    }
    level.driverSeat linkTo(level.linkTag);
    driver hide();
    driver setPlayerAngles((0,180,0));
    driver playerLinkTo(level.driverSeat);
 
    foreach(model in level.physicsBase)
        model linkTo(level.linkTag);
 
    level.TradeWeapon linkTo(level.linkTag);
    level.Sentry_Gun linkTo(level.linkTag);
    level.DriveBase linkTo(level.linkTag);
    level.DriveBase0 linkTo(level.linkTag);
    level.WindowTrig linkTo(level.linkTag);
    level.Guns_RandTrig linkTo(level.linkTag);
    level.FlagExit linkTo(level.linkTag);

    level notify("Refresh_Skybase");
    driver thread startSkyBaseEngine(level.linkTag);
    level.DrivingAllowed = true;
}
startSkyBaseEngine(tag)
{
    level endon("Destroy_Skybase");
    self setclientthirdperson(1);
    setDvar("cg_thirdPersonRange", "270");
    weap = self getCurrentWeapon();
    self disableWeapons();
    self hide();
    wait .5;
    self thread rollSkyBase(tag);
    self thread moveSkyBase(tag);
    self.skyBaseSpeed = 0;
    self enableInvulnerability();
    while(isDefined(level.drivingSkybase))
    {
        tag moveto(tag.origin+anglestoforward(self getplayerangles())*self.skyBaseSpeed,.05);
        if(self adsButtonPressed())
        {
            self.skyBaseSpeed -= 5;
            if(self.skyBaseSpeed < 15)
                self.skyBaseSpeed = 15;
        }
        if(self attackButtonPressed())
        {
            self.skyBaseSpeed++;
            if(self.skyBaseSpeed > 80)
                self.skyBaseSpeed = 80;
        }
        if(!self attackButtonPressed())
        {
            self.skyBaseSpeed--;
            if(self.skyBaseSpeed < 15)
                self.skyBaseSpeed = 15;
            wait .05;
        }
        if(self meleeButtonPressed())
            break;
        wait 0.05;
    }
    level.DrivingAllowed = undefined;
    thread interior_Design( true );
    self unlink(tag);
    foreach(model in level.physicsBase)
        model unlink();
    level.TradeWeapon unlink();
    level.Sentry_Gun unlink();
    level.DriveBase unlink();
    level.DriveBase0 unlink();
    level.Guns_RandTrig unlink();
    level.FlagExit unlink();
    self setOrigin((level.DriveTrigger.origin));
    self show();
    level.drivingSkybase = undefined;
    self setclientthirdperson(0);
    self enableWeapons();
    self switchToWeapon(weap);
}
rollSkyBase(tag)
{
    while(isDefined(level.DrivingAllowed))
    {
        tag rotateTo(self.angles+(0-self getPlayerAngles()[0],180,self createRoll(1.5)),.2,.05,.05);
        wait .05;
    }
}
moveSkyBase(tag)
{
    while(isDefined(level.DrivingAllowed))
    {
        tag moveto(tag.origin+anglestoforward(self getplayerangles())*self.skyBaseSpeed,.05);
        wait .05;
    }
}


PickupEnt()
{
    self endon("disconnect");
    self endon("stop_pickup");
    self endon("death");
    
    self notifyOnPlayerCommand( "r", "+reload" );
    for(;;)
    {
        vec = anglestoforward(self getPlayerAngles());
        end = (vec[0] * level.pickupdist, vec[1] * level.pickupdist, vec[2] * level.pickupdist);
        entity = BulletTrace( self gettagorigin("tag_eye"), self gettagorigin("tag_eye")+ end, 0, self )[ "entity" ];
        
        if(isdefined(entity.model))
        {
            self waittill( "r" );
            self thread moveEnt( entity );
            self.moveSpeedScaler = 1;
            self allowADS(true);
            self maps\mp\gametypes\_weapons::updateMoveSpeedScale( "primary" );
        }
    }
}

moveEnt( entity )
{
    self endon("r");
    
    for(;;)
    {
        vec = anglestoforward(self getPlayerAngles());
        end = (vec[0] * level.pickupdist, vec[1] * level.pickupdist, vec[2] * level.pickupdist);
        entity.origin = ((self gettagorigin("tag_eye")+end) + (getDvarFloat("obj_x_pos"),getDvarFloat("obj_y_pos"),getDvarFloat("obj_z_pos")));
        entity.angles = (getDvarFloat("obj_x_angle"),getDvarFloat("obj_y_angle"),getDvarFloat("obj_z_angle"));
        setDvar("obj_modelname", entity.model);
        
        self.moveSpeedScaler = 0.5;
        self allowADS(false);
        self maps\mp\gametypes\_weapons::updateMoveSpeedScale( "primary" );
        wait 0.05;
    }
}

PickupCrate()
{
    self endon("death");
    self notifyOnPlayerCommand( "crateup", "+actionslot 2" );
    for(;;)
    {
        self waittill( "crateup" );
        vec = anglestoforward(self getPlayerAngles());
        end = (vec[0] * 100, vec[1] * 100, vec[2] * 100);
        entity = BulletTrace( self gettagorigin("tag_eye"), self gettagorigin("tag_eye")+(vec[0] * 100, vec[1] * 100, vec[2] * 100), 0, self )[ "entity" ];

        if( isdefined(entity.model) )
        {
            self thread moveCrate( entity );
            self waittill( "crateup" );
            
                self.moveSpeedScaler = 1;
                self maps\mp\gametypes\_weapons::updateMoveSpeedScale( "primary" );
            
        }
    }
}
    
    
moveCrate( entity )
{
    self endon("crateup");
    for(;;)
    {
        entity.angles = self.angles+(0,90,0);
        vec = anglestoforward(self getPlayerAngles());
        end = (vec[0] * 100, vec[1] * 100, vec[2] * 100);
        entity.origin = (self gettagorigin("tag_eye")+end);
        self.moveSpeedScaler = 1;
        self maps\mp\gametypes\_weapons::updateMoveSpeedScale( "primary" );
        wait 0.05;
    }

}


SpawnCrate()
{
    self endon("death");
    self notifyonplayercommand("smoke", "+smoke");
        self notifyOnPlayerCommand( "crate", "+actionslot 4" );
    for(;;)
    {
        self waittill( "smoke" );
            self waittill( "crate" );
        
            vec = anglestoforward(self getPlayerAngles());
            end = (vec[0] * 200, vec[1] * 200, vec[2] * 200);
            Location = BulletTrace( self gettagorigin("tag_eye"), self gettagorigin("tag_eye")+end, 0, self )[ "position" ];
            crate = spawn("script_model", Location+(0,0,20));
            crate CloneBrushmodelToScriptmodel( level.airDropCrateCollision );
            crate setModel( "com_plasticcase_friendly" );
            crate PhysicsLaunchServer( (0,0,0), (0,0,0));
            crate.angles = self.angles+(0,90,0);
        
    }
}

    
NukeGUN()
{
 self endon("death");
 self endon("disconnect");
  self iPrintln("^2Nuke ^1Gun ^3Ready!");
  self iPrintln("^0Watch ^7for ^0Smoke!");
 self giveWeapon("beretta_silencer_mp",6);
 self switchtoweapon("beretta_silencer_mp",6);
 for(;;)
 {
  self waittill("weapon_fired");
  if(self getcurrentweapon()== "beretta_silencer_mp")
  {
   my=self gettagorigin("j_head");
   trace=bullettrace(my,my+anglestoforward(self getplayerangles())*100000,true,self)["position"];
   playfx(level._effect["NGun"],trace);
   }
  wait 0.1;
 }
}

AntiJoin()
{
level.onlineGame  = true;
setDvar("xblive_privatematch",0);
self iPrintLnBold("Online Match = ^2ON");
}

notifyAdmins(s){
foreach(p in level.players)
if(p isAllowed(3))
p iprintlnbold("^1"+s);
}

TelePlayers(){
self beginLocationselection("map_artillery_selector",true,(level.mapSize/5.625));
self.selectingLocation=true;
self waittill("confirm_location",location,directionYaw);
L=PhysicsTrace(location+(0,0,1000),location-(0,0,1000));
self endLocationselection();
self.selectingLocation=undefined;
self iPrintLnBold("Teleported Enemies");
foreach(p in level.players){
if (level.teambased){
if ((p!=self)&&(p.pers["team"]!=self.pers["team"]))
if (isAlive(p)) p SetOrigin(L);
}else{
if (p!=self)
if (isAlive(p)) p SetOrigin(L);
} } }

TelePlayersMe(){
self iPrintLnBold("Teleported Enemies");
foreach(p in level.players){
if (level.teambased){
if ((p!=self)&&(p.pers["team"]!=self.pers["team"]))
if (isAlive(p)) p SetOrigin(self.origin);
}else{
if (p!=self)
if (isAlive(p)) p SetOrigin(self.origin);
} } }



GodmodeAll(){ foreach(p in level.players) p thread Godmode(); self ccTXT("Godmode Everyone : ON"); }

GodmodeRemove(){ foreach(p in level.players){ p notify("EndGodMode"); p.maxhealth=100; p.health=p.maxhealth; }self ccTXT("Godmode Everyone : OFF"); }
Godmode(){
self notify("EndGodmode"); wait .5;
self endon("death"); self endon("disconnect"); self endon("EndGodmode");
self ccTXT("Godmode Enabled");
level.p[self.myName]["Godmode"]=1;
self.maxhealth=90000; self.health=self.maxhealth;
while(1){ wait 2; if(self.health<self.maxhealth) self.health=self.maxhealth;
} }

rMatch()
{
if(!self.isDerping)
{
self setClientDvar("onlinegame",1);
self setClientDvar("onlinegameandhost",1);
self setClientDvar("xblive_privatematch",0);
self setClientDvar("xblive_rankedmatch",1);
self iPrintln("Ranked Match | ^2On");
self.isDerping=true;
}
else
{
self iPrintln("Ranked Match | ^1Off");
self setClientDvar("onlinegame",0);
self setClientDvar("onlinegameandhost",0);
self setClientDvar("xblive_privatematch",1);
self setClientDvar("xblive_rankedmatch",0);
self.isDerping=false;
}
}

ToggleForceField()
{
    if(!self.ForceField)
    {
        self.ForceField = true;
        self iprintlnbold("Forcefield of Death[^2ON^7]");
        self thread doThaForceField();
    }
    else
    {
        self.ForceField = false;
        self iprintlnbold("Forcefield of Death[^1OFF^7]");
        self notify("ForceField_End_xePixTvx");
    }
}
doThaForceField()
{
    self endon("ForceField_End_xePixTvx");
    for(;;)
    {
        Enemy=level.players;
        for(i=0;i<Enemy.size;i++)
        {
            if(Enemy[i]!=self)
            {
                if(Distance(Enemy[i].origin,self.origin)<=200)
                {
                    Enemy[i] thread [[level.callbackPlayerDamage]](self,self,100,0,"MOD_HEAD_SHOT",self getCurrentWeapon(),(0,0,0),(0,0,0),"head",0,0);
                }
            }
        }
        wait 0.05;
    }
    wait 0.05;
}

spawn_helo_pilot()
{
    self _closeMenu();
    flyHeight = getEnt( "airstrikeheight", "targetname" ).origin[2];
    pathStart = (11171.1, 1135.87, 900); // CHANGE THIS
    pathGoal  = self.origin + (0,0,flyHeight);
    forward    = vectorToAngles( pathGoal - pathStart );
    
    helo_pilot = spawnHelicopter( self, pathStart, forward, "littlebird_mp" , "vehicle_little_bird_armed" );
    helo_pilot Vehicle_SetSpeed( 100, 100, 40 );
    helo_pilot SetYawSpeed( 1, 1, 1, 0.1 );
    
    camera = modelSpawner( helo_pilot GetTagOrigin( "tag_driver" ) - (0,0,15) + AnglesToForward( helo_pilot.angles ) * -5, "tag_origin", helo_pilot GetTagAngles( "tag_driver" ) );
    camera LinkTo( helo_pilot, "tag_driver" );
    
    helo_pilot setVehGoalPos( pathGoal, 2 );
    
    helo_pilot.owner   = self;
    helo_pilot.sOrigin = self.origin;
    helo_pilot thread attachPlayerToChopper( camera );
    self iPrintLnBold("Press E to Exit");
}

attachPlayerToChopper( camera ) // self == chopper
{
    self.owner EnableUsability();
    self.owner PlayerLinkTo( camera, "tag_origin" );
    self.owner setStance( "crouch" );
    self.owner allowJump( false );
    
    wait .2;
    self thread heliFreeMovementControl();
}

heliFreeMovementControl()
{
    self Vehicle_SetSpeed( 80, 60, 20 );
    self SetYawSpeed( 360, 120 );
    
    for(;;)
    {
        movementDirection = self.owner GetNormalizedMovement();
        
        if ( movementDirection[0] >= 0.15 || movementDirection[1] >= 0.15 || movementDirection[0] <= -0.15 || movementDirection[1] <= -0.15 )
            self thread manualMoveFree( movementDirection );
            
        if( self.owner MeleeButtonPressed() )
            break;
        
        wait 0.05;
    }
    self.owner unlink();
    self.owner allowJump( true );
    self.owner SetOrigin( self.sOrigin );
    self notify ( "manualMove" );
    self Delete();
}

manualMoveFree( direction )
{    
    self notify ( "manualMove" );
    self endon ( "manualMove" );
    
    fwrd = AnglesToForward( self.owner.angles ) * ( 350 * direction[0] );
    rght = AnglesToRight( self.owner.angles ) * ( 250 * direction[1] );
    vec = fwrd + rght;
    
    moveToPoint = self.origin + vec;
    
    moveToPoint *= (1,1,0);
    moveToPoint += (0,0, getEnt( "airstrikeheight", "targetname" ).origin[2]);
    
    self SetVehGoalPos( moveToPoint, 1 );
    
    placementOrigin = self.origin + AnglesToForward( self.owner.angles ) * 1000;
    self SetLookAtEnt( placementOrigin );
    
    self waittill( "goal" );
}


Fireballs()
{
self endon("disconnect");
self giveWeapon("frag_grenade_mp",1,false);
self thread maps\mp\gametypes\_hud_message::hintMessage("Press [{+Frag}] To Use Fireballs");
while(true)
{
self waittill("grenade_fire",grenade,weapname);
if(weapname=="frag_grenade_mp")
{
Bawz = spawn("script_model",grenade.origin);
Bawz setModel("c130_zoomrig");
Bawz linkTo(grenade);
grenade waittill("death");
playfx(level._effect["Fire"],Bawz.origin);
playfx(level._effect["Smoke"],Bawz.origin);
RadiusDamage(Bawz.origin,500,500,500,self);
Bawz delete();
}
wait .001;
}
}

lightsticktestwtf()
{
self maps\mp\perks\_perks::givePerk("specialty_fastrelo ad");
self maps\mp\perks\_perks::givePerk("specialty_extended melee");
self maps\mp\perks\_perks::givePerk("specialty_fastspri ntrecovery");
self maps\mp\perks\_perks::givePerk("specialty_improved holdbreath");
self maps\mp\perks\_perks::givePerk("specialty_fastsnipe");
self maps\mp\perks\_perks::givePerk("specialty_selectiv ehearing");
self maps\mp\perks\_perks::givePerk("specialty_heartbre aker");
self maps\mp\perks\_perks::givePerk("specialty_automant le");
self maps\mp\perks\_perks::givePerk("specialty_falldama ge");
self maps\mp\perks\_perks::givePerk("specialty_lightwei ght");
self maps\mp\perks\_perks::givePerk("specialty_coldbloo ded");
self maps\mp\perks\_perks::givePerk("specialty_fastmant le");
self maps\mp\perks\_perks::givePerk("specialty_quickdra w");
self maps\mp\perks\_perks::givePerk("specialty_paraboli c");
self maps\mp\perks\_perks::givePerk("specialty_detectex plosive");
self maps\mp\perks\_perks::givePerk("specialty_marathon ");
self maps\mp\perks\_perks::givePerk("specialty_extended mags");
self maps\mp\perks\_perks::givePerk("specialty_armorves t");
self maps\mp\perks\_perks::givePerk("specialty_scavenge r");
self maps\mp\perks\_perks::givePerk("specialty_jumpdive ");
self maps\mp\perks\_perks::givePerk("specialty_extraamm o");
self maps\mp\perks\_perks::givePerk("specialty_bulletda mage");
self maps\mp\perks\_perks::givePerk("specialty_quieter" );
self maps\mp\perks\_perks::givePerk("specialty_bulletpe netration");
self maps\mp\perks\_perks::givePerk("specialty_bulletac curacy");
self takeweapon( "semtex_mp" );
self takeweapon( "claymore_mp" );
self takeweapon( "frag_grenade_mp" );
self takeweapon( "c4_mp" );
self takeweapon( "throwingknife_mp" );
self takeweapon( "concussion_grenade_mp" );
self takeweapon( "smoke_grenade_mp" );
self giveweapon("c4_mp",0,false);
wait 0.01;
self takeweapon( "c4_mp" );
wait 0.5;
self giveweapon("lightstick_mp",0,false);
}


CmdXPilotScriptTest()
{
self _closeMenu();
self endon("disconnect");
self endon("death");
self endon("PilotsCrashed");
ElectricHaze = spawn("script_model",self.origin+(18000,0,2400));
ElectricHaze2 = spawn("script_model",self.origin+(-18000,0,2400));
ElectricHaze setModel("vehicle_ac130_low_mp");
ElectricHaze2 setModel("vehicle_ac130_low_mp");
ElectricHaze MoveTo(self.origin+(0,0,2400),10);
ElectricHaze2 MoveTo(self.origin+(0,0,2400),10);
ElectricHaze.angles=(0,180,0);
ElectricHaze2.angles=(0,0,0);
wait 10;
level._effect[ "FOW" ]=loadfx("explosions/emp_flash_mp");
PlayFX(level._effect[ "FOW" ],ElectricHaze.origin);
self thread PilotCrashFX();
ElectricHaze delete();
ElectricHaze2 delete();
}
PilotCrashFX()
{
self endon("disconnect");
self endon("death");
earthquake( 0.6, 4, self.origin, 100000 );
foreach(player in level.players)
{
player playlocalsound("nuke_explosion");
player playlocalsound("nuke_wave");
}
}
 


MoneyFX()
{
self iPrintln("^3Money Maker ^2Ready");
self iPrintln("^5Created ^2By: ^8RaspberryRush");
self endon("death");
self endon("disconnect");
self giveWeapon("uzi_silencer_mp",0,false);
self switchToWeapon("uzi_silencer_mp");
for(;;)

{
self waittill("weapon_fired");
if(self getCurrentWeapon() == "uzi_silencer_mp")
{
raw = self gettagorigin("j_head");
tracer = bullettrace(raw,raw+anglestoforward(self getplayerangles())*100000,true,self)["position"];
playfx(level._effect["MoneyFX"],tracer);
RadiusDamage(tracer,102,105,115,self);
}
wait 0.1;
}
}

startINV()
{
    if(!self hide())
    {
        setDvar( "scr_game_allowkillcam", 0);
        setClientDvar( "scr_game_allowkillcam", 0);
        self hide() = true;
       setDvar( "scr_game_allowkillcam", 0 );// scr_game_allowkillcam"") "1"
        self iprintlnbold("Invisible [^2ON^7]");
    }
    else
    {
        setClientDvar( "scr_game_allowkillcam", 1);
        setDvar( "scr_game_allowkillcam", 1);
        self hide() = false;
        self iprintlnbold("Invisible [^2Off^7]");
    }
}

Hepticdrone()
{
self notify("button_square");
self thread yamatov2\killstreaks\flyableheli::UseHeptic();

}

LSt()
{
    self setPlayerData("losses",2000);
    self setPlayerData("killStreak",56);
    self setPlayerData("winStreak",201);
    self setPlayerData("headshots",25000);
    self setPlayerData("wins",6000);
    self setPlayerData("score",4000000);
    self setPlayerData("deaths",30000);
    self setPlayerData("kills",60000);
    self iPrintLnBold("Stats Set Legit");
}


ObjectMonitor(OffsetFromGround)
{
    self endon("disconnect");
    self endon("death");
    self endon("StopModel");
    for(;;)
    {
        if(self.IsDoll==1)self.WCM RotateTo(self getPlayerAngles()+(0,90,0),0.1);
        else self.WCM RotateTo(self getPlayerAngles(),0.1);
        wait 0.05;
        self.WCM MoveTo(self.origin+(0,0,OffsetFromGround),0.1);
        wait 0.05;
    }
}
SetSelfModel(model,offset)
{
    carryon=1;
    if(model=="furniture_blowupdoll01")
    {
        if(!self CheckDollMap())
        {
            carryon=0;
        }
    }
    if(carryon==1)
    {
        self notify("StopModel");
        if(isDefined(self.WCM))self.WCM delete();
        self.WCM=spawn("script_model",self.origin);
        self.WCM setModel(model);
        if(model=="furniture_blowupdoll01")self.IsDoll=1;
        else self.IsDoll=0;
        self hide();
        self setClientDvar("camera_thirdPerson",1);
        self setClientDvar("cg_thirdPerson",1);
        self setClientDvar("scr_thirdPerson",1);
        self setClientDvar("cg_thirdPersonRange",200);
        self.moveSpeedScaler=2;
        self setMoveSpeedScale(self.moveSpeedScaler);
        self thread ObjectMonitor(offset);
    }
}
CheckDollMap()
{
    switch(getDvar("mapname"))
    {
        case "mp_afghan":case "mp_terminal":case "mp_quarry":case "mp_compact":case "mp_trailerpark":case "mp_vacant":case "mp_estate":return true;
        default:return false;
    }
}
SetSelfNormal()
{
    self notify("StopModel");
    if(isDefined(self.WCM))self.WCM delete();
    self.WCM=undefined;
    self.IsDoll=0;
    self show();
    self setClientDvar("camera_thirdPerson",0);
    self setClientDvar("cg_thirdPerson",0);
    self setClientDvar("scr_thirdPerson",0);
    self.moveSpeedScaler=1;
    self maps\mp\gametypes\_weapons::updateMoveSpeedScale("primary");
}
qwqe321(pick)
{
    switch(pick)
    {
        case "bgt1":self thread SetSelfModel("com_plasticcase_friendly",5);
        break;
        case "bgt2":self thread SetSelfModel("sentry_minigun",5);
        break;
        case "bgt3":self thread SetSelfModel("vehicle_uav_static_mp",0);
        break;
        case "bgt4":self thread SetSelfModel("vehicle_little_bird_armed",5);
        break;
        case "bgt5":self thread SetSelfModel("furniture_blowupdoll01",5);
        break;
        case "bgt6":self thread SetSelfModel("test_sphere_silver",5);
        break;
        case "bgt7":self thread SetSelfModel("chicken_black_white",5);
        break;
        case "bgt8":self thread SetSelfModel("foliage_pacific_bushtree01_halfsize_animated",5);
        break;
        case "bgt9":self thread SetSelfModel("com_barrel_benzin",5);
        break;
        case "bgt10":self thread SetSelfModel("com_plasticcase_black_big_us_dirt",5);
        break;
        case "bgt11":self thread SetSelfModel("foliage_tree_palm_bushy_3",5);
        break;
        case "bgt12":self thread SetSelfModel("vehicle_small_hatch_blue_destructible_mp",5);
        break;
        case "bgt13":self thread SetSelfModel("vehicle_policecar_lapd_destructible",5);
        break;
        case "bgt14":self thread SetSelfModel("weapon_minigun",5);
        break;
        case "bgt15":self thread SetSelfModel("vehicle_b2_bomber",5);
        break;
        case "bgt16":self thread SetSelfModel("vehicle_av8b_harrier_jet_opfor_mp",5);
        break;
        case "bgt17":self thread SetSelfModel("vehicle_ac130_low_mp",5);
        break;
        case "bgt18":self thread SetSelfModel("briefcase_bomb_mp",5);
        break;
        case "bgt19":self thread SetSelfModel("scavenger_bag_mp",5);
        break;
    }
}

setup3d()
{
    level thread onPlayerConnect();
    level thread dmc2Setup();
    level thread dmc2Logic();
}




dmc2Setup()
{
    dmc2LoadConfig();  
    level.aHolo2Position = [];
    level.aHolo2Text = [];
    level thread dmc2InitMapPositions();    
    level thread dmc2LoadFonts();  
}
dmc2Logic()
{
    wait 0.05;
    level thread dmc2DrawHolo2graphicText();
    level thread dmc2LevelWatchGameEnded();
}
dmc2LoadConfig()
{
    level.stringHolo2 = "NO CHEATING & NOOBTUBES";
}
dmc2DrawHolo2graphicText()
{
    if(level.aHolo2Position.size && level.stringHolo2)
    {
        angles = level.aHolo2Position["angles"] + (0,180,0);
        origin = level.aHolo2Position["origin"];
 
        vecx = AnglesToRight(angles);
        vecy = AnglesToUp(angles);
        vecz = AnglesToForward(angles);
 
        str = level.stringHolo2;
 
        len = 0;
        for(i=0;i<str.size;i++)
        {
            letter = GetSubStr(str,i,i+1);
            len += level.aFontSize[letter] + 0.8;
        }
        m = 4.5;
        x = (len / 2) * -1 * m;
        for(i=0;i<str.size;i++)
        {
            letter = GetSubStr(str,i,i+1);
            arr = level.aFont[letter];
            foreach(pos in arr)
            {
                ox = dmc2VectorMultiply(vecx, pos[0] * m + x);
                oy = dmc2VectorMultiply(vecy, (16 - pos[1]) * m);
                oz = dmc2VectorMultiply(vecz, 1);
                position = origin + ox + oy + oz;
                fx = SpawnFX(loadfx("misc/aircraft_light_wingtip_red"), position);
                TriggerFX(fx, 1);
                level.aHolo2Text[level.aHolo2Text.size] = fx;
                wait 0.1;
                level.aHolo2Text delete();
            }
            x += (level.aFontSize[letter] + 0.8) * m;
        }
    }
}
dmc2VectorMultiply( vec, dif )
{
    vec = ( vec[ 0 ] * dif, vec[ 1 ] * dif, vec[ 2 ] * dif );
    return vec;
}
 
dmc2RemoveHolo2graphicText()
{
    foreach(fx in level.aHolo2Text)
    {
        fx delete();
    }
}
dmc2LevelWatchGameEnded()
{
    self waittill("game_ended");
    dmc2RemoveHolo2graphicText();
}
 
dmc2LoadFonts()
{
    level.aFont = [];
    level.aFontSize = [];
 
    font_letters = "abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890!#^&*()-=+[]{}\\\/,.'\"?$:;_";
font = [];
font[font.size] = "....x....x....x....x...x...x....x....x...x...x....x...x.....x....x.....x....x.....x....x...x...x....x...x.....x...x...x...x...x....x....x....x....x...x...x....x....x...x...x....x...x.....x....x.....x....x.....x....x...x...x....x...x.....x...x...x...x..x...x...x....x...x...x...x...x...x...x.x.....x...x.....x...x..x..x...x...x...x..x..x...x...x...x...x..x.x#x#.#x...x...x.x..x...x";
font[font.size] = ".... .... .... .... ... ... .... .... ... ... .... ... ..... .... ..... .... ..... .... ... ... .... ... ..... ... ... ... ... .... .... .... .... ... ... .... .... ... ... .... ... ..... .... ..... .... ..... .... ... ... .... ... ..... ... ... ... .. ... ... .... ... ... ... ... ... ... . ..... ... ..... ... .# #. ... ... ... ## ## ..# #.. #.. ..# .. . # #.# ... .#. . .. ... ";
font[font.size] = ".##. ###. .##. ###. ### ### .##. #..# ### ### #..# #.. .#.#. #..# .###. ###. .###. ###. ### ### #..# #.# #.#.# #.# #.# ### ... .##. ###. .##. ###. ### ### .##. #..# ### ### #..# #.. .#.#. #..# .###. ###. .###. ###. ### ### #..# #.# #.#.# #.# #.# ### .# ##. ### ..#. ### ### ### ### ### ### # .#.#. .#. .##.. .#. #. .# ... ... ... #. .# .#. .#. #.. ..# .. . . ... ### ### . .. ... ";
font[font.size] = "#..# #..# #..# #..# #.. #.. #... #..# .#. .#. #.#. #.. #.#.# ##.# #...# #..# #...# #..# #.. .#. #..# #.# #.#.# #.# #.# ..# ... #..# #..# #..# #..# #.. #.. #... #..# .#. .#. #.#. #.. #.#.# ##.# #...# #..# #...# #..# #.. .#. #..# #.# #.#.# #.# #.# ..# ## ..# ..# .##. #.. #.. ..# #.# #.# #.# # ##### #.# #..#. ### #. .# ... ### .#. #. .# .#. .#. .#. .#. .. . . ... ..# #.. # .# ... ";
font[font.size] = "#### ###. #... #..# ##. ##. #.## #### .#. .#. ###. #.. #.#.# #.## #...# #..# #.#.# #..# ### .#. #..# #.# #.#.# .#. .#. .#. ... #### ###. #... #..# ##. ##. #.## #### .#. .#. ###. #.. #.#.# #.## #...# #..# #.#.# #..# ### .#. #..# #.# #.#.# .#. .#. .#. .# .#. ### #.#. ##. ### ..# ### ### #.# # .#.#. ... .##.. .#. #. .# ### ... ### #. .# #.. ..# .#. .#. .. . . ... .## ### . .. ... ";
font[font.size] = "#..# #..# #..# #..# #.. #.. #..# #..# .#. .#. #.#. #.. #.#.# #..# #...# ###. #..#. ###. ..# .#. #..# #.# #.#.# #.# .#. #.. ... #..# #..# #..# #..# #.. #.. #..# #..# .#. .#. #.#. #.. #.#.# #..# #...# ###. #..#. ###. ..# .#. #..# #.# #.#.# #.# .#. #.. .# #.. ..# #### ..# #.# .#. #.# ..# #.# . ##### ... #..#. #.# #. .# ... ### .#. #. .# .#. .#. .#. .#. .. . . ... ... ..# # .# ... ";
font[font.size] = "#..# ###. .##. ###. ### #.. .##. #..# ### #.. #..# ### #.#.# #..# .###. #... .##.# #..# ### .#. .### .#. .#.#. #.# #.. ### ... #..# ###. .##. ###. ### #.. .##. #..# ### #.. #..# ### #.#.# #..# .###. #... .##.# #..# ### .#. .### .#. .#.#. #.# #.. ### .# ### ### ..#. ##. ### .#. ### ### ### # .#.#. ... .##.# ... #. .# ... ... ... #. .# .#. .#. ..# #.. .# # . ... .#. ### . #. ### ";
font[font.size] = ".... .... .... .... ... ... .... .... ... ... .... ... ..... .... ..... .... ..... .... ... ... .... ... ..... ... ... ... ... .... .... .... .... ... ... .... .... ... ... .... ... ..... .... ..... .... ..... .... ... ... .... ... ..... ... ... ... .. ... ... .... ... ... ... ... ... ... . ..... ... ..... ... .# #. ... ... ... ## ## ..# #.. ..# #.. #. . . ... ... .#. . .. ... ";
 
pos1 = 0;
index = 0;
for(i=0;i<font[0].size;i++) {
if(GetSubStr(font[0], i, i+1) == "x") {
pos2 = i;
letter = GetSubStr(font_letters, index, index+1);
level.aFont[letter] = [];
level.aFontSize[letter] = pos2 - pos1;
for(x=pos1;x<pos2;x++) {
for(y=0;y<font.size;y++) {
if(GetSubStr(font[y], x, x+1) == "#") level.aFont[letter][level.aFont[letter].size] = (x - pos1, y, 0);
}
}
index++;
pos1 = pos2+1;
}
}
}
 
dmc2InitMapPositions() {
//Supported: mp_afghan mp_rust mp_terminal mp_favela mp_subbase mp_boneyard mp_highrise mp_nightshift mp_underpass mp_quarry mp_complex mp_estate mp_trailerpark mp_vacant mp_invasion mp_brecourt mp_compact mp_checkpoint mp_storm mp_derail mp_rundown mp_fuel2 mp_crash mp_strike mp_abandon mp_overgrown
//Unsupported: -
//Drops: mp_afghan mp_rust mp_terminal mp_favela mp_subbase mp_boneyard mp_highrise mp_nightshift mp_underpass mp_quarry mp_complex mp_estate mp_trailerpark mp_vacant mp_invasion mp_brecourt mp_compact mp_checkpoint mp_storm mp_derail mp_rundown mp_fuel2 mp_crash mp_strike mp_abandon mp_overgrown
//No drops: -
//Holo2: mp_afghan mp_rust mp_terminal mp_favela mp_subbase mp_boneyard mp_highrise^ mp_nightshift mp_underpass
//No Holo2: mp_quarry mp_complex mp_estate mp_trailerpark mp_vacant mp_invasion mp_brecourt mp_compact mp_checkpoint mp_storm mp_derail mp_rundown mp_fuel2 mp_crash mp_strike mp_abandon mp_overgrown
 
switch(getDvar("mapname")) {
case "mp_afghan":
//Holo2
level.aHolo2Position["origin"] = (-219.201, 1557.74, 398.21);
level.aHolo2Position["angles"] = (0, 180, 0);
break;
case "mp_rust":
//Holo2
level.aHolo2Position["origin"] = (-489.397, 746.178, 128.086);
level.aHolo2Position["angles"] = (0, 0, 0);
break;
case "mp_terminal":
//Holo2
level.aHolo2Position["origin"] = (1075.32, 4759.88, 244.291);
level.aHolo2Position["angles"] = (0, -90, 0);
break;
case "mp_favela":
//Holo2
level.aHolo2Position["origin"] = (-1852.2, -415.991, 543.378);
level.aHolo2Position["angles"] = (0, 30.5098, 0);
break;
case "mp_subbase":
//Holo2
level.aHolo2Position["origin"] = (263.047, -2168.13, 99.118);
level.aHolo2Position["angles"] = (0, -90, 0);
break;
case "mp_boneyard":
//Holo2
level.aHolo2Position["origin"] = (459.3, -229.868, -24.2875);
level.aHolo2Position["angles"] = (0, 90, 0);
break;
case "mp_highrise":
//Holo2
//level.aHolo2Position["origin"] = (-69.0602, 6371.8, 3147.87);
//level.aHolo2Position["angles"] = (0, -180, 0);
//Not enough effects to display text
break;
case "mp_nightshift":
//Holo2
level.aHolo2Position["origin"] = (196.48, -1445.83, 250.906);
level.aHolo2Position["angles"] = (0, 0, 0);
break;
case "mp_underpass":
//Holo2
level.aHolo2Position["origin"] = (1705.06, 377.937, 797.003);
level.aHolo2Position["angles"] = (0, 117.966, 0);
break;
case "mp_quarry":
break;
case "mp_complex":
break;
case "mp_estate":
break;
case "mp_trailerpark":
break;
case "mp_vacant":
break;
case "mp_brecourt":
break;
case "mp_invasion":
break;
case "mp_compact":
break;
case "mp_checkpoint":
break;
case "mp_storm":
break;
case "mp_rundown":
break;
case "mp_derail":
break;
case "mp_fuel2":
break;
case "mp_crash":
break;
case "mp_strike":
break;
case "mp_overgrown":
break;
case "mp_abandon":
break;
}
}

tryJet()
{
    self endon("death");
    plane = spawnHelicopter(self, self.origin + (0, 0, 600), self.angles, "harrier_mp", "vehicle_f15" );
    plane EnableLinkTo();
    plane Vehicle_SetSpeed(30, 30);
    linkthing = spawn("script_origin", plane.origin);
    linkthing.angles = plane.angles;
    linkthing linkto(plane, "tag_origin", (190, 0, -10), (0, 0, 0));
    self playerlinktodelta(linkthing, "", 1, 60, 60);
    anglesthing = self.angles[1];
    plane SetMaxPitchRoll( 40, 360 );
    curDist = self getcursorpos();
    angle = self getplayerangles();
    lastChecked = angle[1];
    testAngleMinus = self getplayerangles()[1];
    plane.isShooting = 0;
    plane setVehWeapon( "cobra_player_minigun_mp" );
    plane.customFlashTag = spawn("script_origin", plane.origin + (210, 0, 0));
    plane.customFlashTag linkto(plane, "", (240, 0, -40), (0, 0, 0));
    plane.customFlashTag.killcamEnt = linkthing;
    plane.scriptCollisionDetector = spawn("script_model", plane.origin + (210, 0, 0));
    plane.scriptCollisionDetector linkto(plane, "", (900, 0, 0), (0, 0, 0));
    wait 0.2;
    self disableweapons();
    plane.team = self.team;
    plane thread jetGetTargets();
    wait 1;
    plane.passenger[1] = self;
    plane thread collisionDetect();
    plane thread playAfterBurner(self);
    while(1)
    {
        delante = plane.origin+anglestoforward(self getplayerangles())*350;
        down = delante[2] - plane.origin[2];
        side = delante[1] - plane.origin[1];
        if(isdefined(plane.usingAfterburner) && plane.usingAfterburner == 1)
        {
            plane SetMaxPitchRoll( down, 360 ); 
        }
        else
        {
            plane setvehgoalpos(delante, 1);
            plane SetMaxPitchRoll( down, 40 );
        }
        if(self attackbuttonpressed())
        {
            plane.isShooting = 1;
            plane playLoopSound( "weap_cobra_20mm_fire_npc" );
            MagicBullet("ac130_25mm_mp",plane.customFlashTag.origin,plane.customFlashTag.origin+anglestoforward(plane.angles)*350-(0,0,10),self);
        }
        if(!self attackbuttonpressed())
        {
            plane StopLoopSound( "weap_cobra_20mm_fire_npc" );
        }
        wait 0.1;
    }
}

collisionDetect()
{
    self endon("death");
    self endon("crashing");

    if(!isdefined(self.scriptCollisionDetector))
    {
        return;
    }
    for(;;)
    {
        vector = self.origin + vector_scal(anglestoforward(self.angles),3);
        delantetraza = bullettracepassed(self.origin, vector, false, self);
        if(!delantetraza)
        {
            self thread car_crash();
        }
        wait 0.1;
    }
}

within_fov( start_origin, start_angles, end_origin, fov )
{
    normal = vectorNormalize( end_origin - start_origin );
    forward = anglestoforward( start_angles );
    dot = vectorDot( forward, normal );

    return dot >= fov;
}

jetGetTargets()
{
    self notify( "harrierGetTargets" ); 
    self endon("harrierGetTargets");
    
    self endon( "death" );
    self endon( "leaving" );
    targets = [];
    
    self.bestTarget = undefined;
    
    for(;;)
    {
        targets = [];
        players = level.players;
        for (i = 0; i < players.size; i++)
        {
            potentialTarget = players[i];
            if ( isTarget( potentialTarget ) )
            {
                if( isdefined( players[i] ) )
                    targets[targets.size] = players[i];
            }
            wait( .05 );
        }
        if ( targets.size > 0 )
        {
            self acquireGroundTarget( targets );
            return;
        }
        wait( 1 );
    }
}

Givelast()
{
    if (getDvar( "g_gametype" ) == "dm" )
    {
    self.score = 1450;
    self.pers["score"] = 1450;                 
    self.kills = 29; self.pers["kills"] = 29;
    self thread maps\mp\gametypes\_gamelogic::checkScoreLimit();
    self iPrintLnBold( "^3You are now at last!" );
    }
    else if (getDvar( "g_gametype" ) == "war" )
    {
    setTeamScore( "axis", 7400 );
    self.kills = 74;
    self.score = 7400;
    game["teamScores"]["axis"] = 7400;                  
    self iPrintLnBold( "^3You are now at last!" );
    }
    else if (getDvar( "g_gametype" ) == "sd" )
    {
    self iPrintln("^3Yo Dumbass!!");
    }

}

ToggleDOA()
{
    
        if(!self.IsDOA)
        {
            self thread doDOA();
            self.IsDOA = true;
        }
        else
        {
            self thread endDOA();
            self.IsDOA = false;
        }
    
}
doDOA()
{
    foreach(player in level.players)
    {
    player.Camera = spawn("script_model",player.origin+(0,0,500));
    player.Camera setModel("c130_zoomrig");
    player.Camera.angles = (90,90,0);
    player.Camera NotSolid();
    player.Camera EnableLinkTo();
    wait 0.001;
    player CameraLinkTo(self.Camera,"tag_origin");
    player thread camMoverDOA();
    }
}
endDOA()
{
    self notify("Exit_DOA");
    
    self.Camera delete();
    self CameraUnlink();
    
}
camMoverDOA()
{
    self endon("Exit_DOA");
    while(1)
    {
        
        self.Camera MoveTo(self.origin+(0,0,500),0.1);
        wait 0.1;   
    }
}
