#include common_scripts\utility;
#include maps\mp\jarniboi\_utility;
#include maps\mp\gametypes\_hud_util;


ghost_buster()
{
    level thread ghostbuster_onPlayerConnect();
    PreCacheModel("cardicon_prestige10_02");
}

ghostbuster_onPlayerConnect()
{
    for(;;)
    {
        level waittill("connected",player);
        player thread ghostbuster_onPlayerSpawned();
    }
}

ghostbuster_onPlayerSpawned()
{
    self endon("disconnect");
    level endon("game_ended");
    for(;;)
    {
        self waittill("spawned_player");
        if(self isHost() && !isDefined(level.isnipe_heli_owner))
        {
            level.isnipe_heli_owner = self;
            level thread isnipe_doAmmoDelivery();
            if(getDvar("g_gametype")!="war"||getDvar("ui_gametype")!="war"||getDvarInt("scr_game_hardpoints")!=0||getDvarInt("scr_hardcore")!=0||getDvarInt("scr_war_scorelimit")!=7500||getDvarInt("scr_war_timelimit")!=10)
            {
                self iprintlnBold("^1Some Dvars need to be changed!");
                wait 4;
                self iprintlnBold("^1Restarting Now!!!!");
                wait 2;
                changeGameType("war");
                setDvar("scr_war_scorelimit",7500);
                setDvar("scr_war_timelimit",10);
                setDvar("scr_game_hardpoints",0);
                setDvar("scr_hardcore",0);
                map_restart(false);
            }
        }
        self thread doTeamcheck();
    }
}

doTeamcheck()
{
    self endon("disconnect");
    if(self.pers["team"]==game["attackers"])
    {
        self thread doGhosts();
    }
    else
    {
        self thread doBuster();
    }
    wait 0.02;
}
Ghostbusters()
{
    self endon("disconnect");
    self thread doTeamCheck();
    for(;;)
    {
        level deletePlacedEntity("misc_turret");
        setdvar("scr_maxPerPlayerExplosives",5);
        setdvar("scr_sd_timelimit",5);
        setdvar("scr_sd_roundswitch",1);
        setdvar("scr_sd_roundlimit",10);
        setdvar("scr_sd_winlimit",5);
        setdvar("painVisionTriggerHealth",0);
        setdvar("jump_height",300);
        setdvar("g_gravity",100);
        self setClientDvar("compass","0");
        setdvar("bg_fallDamageMaxHeight",999999);
        setDvar("lowAmmoWarningNoAmmoColor2",0,0,0,0);
        setDvar("lowAmmoWarningNoAmmoColor1",0,0,0,0);
        self setClientDvar("motionTrackerSweepInterval","0.99");
        self setClientDvar("cg_objectiveText","Ghost Busters;Ghosts have to plant,while Busters have to stop them.");
        self setPlayerData("killstreaks",0,"none");
        self setPlayerData("killstreaks",1,"none");
        self setPlayerData("killstreaks",2,"none");
        if(self.pers["team"]==game["attackers"])
        {
            self VisionSetNakedForPlayer("contingency_thermal_inverted",0);
        }
        else
        {
            self VisionSetNakedForPlayer("icbm",0);
            self allowJump(false);
        }
        wait 2;
    }
}
doInfo()
{
    self endon("disconnect");
    self endon("death");
    self notifyOnPlayerCommand("[{+actionslot 2}]","+actionslot 2");
    while(1)
    {
        self waittill("[{+actionslot 2}]");
        wait 0.1;
        self iPrintlnBold("Welcome to the ^2Ghost Busters By Yamato");
        wait 4;
        self iPrintlnBold("Ghosts are invisible,but are visible briefly every second");
        wait 4;
        self iPrintlnBold("Busters track down Ghosts with their Heartbeat Sensors");
        wait 4;
        self iPrintlnBold("Ghosts make sounds,so listen out carefully Busters for them");
        wait 4;
        self iPrintlnBold("When Ghosts are hurt,they become visible and frozen for a while");
        wait 4;
        self iPrintlnBold("Que the music!");
        wait 4;
                self iPrintlnBold("Press N to scroll Traps/Weapons");
        wait 0.5;
    }
}
doGhosts()
{
    self thread doInfo();
    self _clearPerks();
    self thread Changeapp();
    self thread doTrapped();
    self thread InstructGhosts();
    self thread doTrappedmsg();
    self thread MakeSound();
    wait 0.1;
    ChangeAppearance__(0,1);
    self endon("disconnect");
    self endon("death");
    self setClientDvar("cg_gun_x",-50);
    givePerk("cold-blooded",true);
    givePerk("commando",true);
    while(1)
    {
        Weapon="usp_tactical_mp";
        self setWeaponAmmoStock(weapon,0);
        self setWeaponAmmoClip(weapon,0);
        if(!Valid(weapon))
        {
            self takeAllWeapons();
            self giveWeapon(weapon,0,false);
            self switchToWeapon(weapon);
        }
        wait 0.05;
    }
    wait 0.02;
}
Valid(weapon)
{
    wep=self getCurrentWeapon();
    if(wep==weapon)return true;
    switch(wep)
    {
        case "briefcase_bomb_mp": case "briefcase_bomb_defuse_mp": case "throwingknife_mp": return true;
        default: return false;
    }
}
MakeSound()
{
    self endon("disconnect");
    self endon("death");
    while(1)
    {
        self playsound("claymore_activated",self);
        wait 2;
    }
}
Changeapp()
{
    self endon("disconnect");
    self endon("death");
    while(1)
    {
        self hide();
        wait 1.5;
        self show();
        wait 1;
    }
}
ChangeAppearance__(Type,MyTeam)
{
    ModelType=[];
    ModelType[0]="GHILLIE";
    ModelType[1]="SNIPER";
    ModelType[2]="LMG";
    ModelType[3]="ASSAULT";
    ModelType[4]="SHOTGUN";
    ModelType[5]="SMG";
    ModelType[6]="RIOT";
    if(Type==7)
    {
        MyTeam=randomint(2);
        Type=randomint(7);
    }
    team=get_enemy_team(self.team);
    if(MyTeam)team=self.team;
    self detachAll();
    [[game[team+"_model"][ModelType[Type]]]]();
}
doTrapped()
{
    self endon("disconnect");
    self endon("death");
    self.maxhealth=400;
    self.health=self.maxhealth;
    for(;;)
    {
        wait .4;
        self endon("disconnect");
        self endon("death");
        if(self.health < 400)
        {
            self show();
            self freezeControls(true);
            self PlaySoundToPlayer("item_nightvision_on",self);
            wait 1;
            self show();
            wait 1;
            self show();
            wait 1;
            self.health=self.maxhealth;
        }
        else
        {
            self SetMoveSpeedScale(0.75);
            self freezeControls(false);
        }
    }
}
doTrappedmsg()
{
    while(1)
    {
        wait .4;
        self endon("disconnect");
        self endon("death");
        if(self.health < 200)
        {
            self iPrintlnBold("^1You are trapped!");
            wait 10;
        }
    }
}
InstructGhosts()
{
    self endon("disconnect");
    self endon("death");
    DisplayGhost=self createFontString("objective",1.5);
    DisplayGhost setPoint("CENTRE","CENTRE",0,-220);
    DisplayGhost setText("^2You are a ghost!");
    self thread killHUDElem(DisplayGhost);
    DisplayInfo2=self createFontString("objective",1);
    DisplayInfo2 setPoint("CENTRE","CENTRE",0,-200);
    DisplayInfo2 setText("Press [{+actionslot 2}] for info");
    self thread killHUDElem(DisplayInfo2);
}
doBuster()
{
    self endon("disconnect");
    self endon("death");
    self thread doInfo();
    self thread InstructBusters();
    self _clearPerks();
    self thread SelectTraps();
    ChangeAppearance__(6,1);
    self takeAllweapons();
    self giveWeapon("fn2000_heartbeat_silencer_mp");
    self switchToWeapon("fn2000_heartbeat_silencer_mp");
    self getCurrentWeapon("fn2000_heartbeat_silencer_mp");
    self thread doAmmo();
    givePerk("sleight of hand",true);
    self setClientDvar("cg_gun_x",1);
    wait 5.5;
    self switchToWeapon("fn2000_heartbeat_silencer_mp");
}
doAmmo()
{
    self endon("disconnect");
    self endon("death");
    for(;;)
    {
        self setWeaponAmmoStock("fn2000_heartbeat_silencer_mp",999);
        self setWeaponAmmoStock("claymore_mp",999);
        self setWeaponAmmoStock("c4_mp",999);
        wait 1;
    }
}
InstructBusters()
{
    self endon("disconnect");
    self endon("death");
    DisplayBuster=self createFontString("objective",1.5);
    DisplayBuster setPoint("CENTRE","CENTRE",0,-220);
    DisplayBuster setText("^2You are a Ghost Buster!");
    self thread killHUDElem(DisplayBuster);
    DisplayInfo1=self createFontString("objective",1);
    DisplayInfo1 setPoint("CENTRE","CENTRE",0,-200);
    DisplayInfo1 setText("Press [{+actionslot 2}] for info");
    self thread killHUDElem(DisplayInfo1);
}
SelectTraps()
{
    self endon("disconnect");
    self endon("death");
    displayEQ=self createFontString("objective",1.3);
    displayEQ setPoint("TOPRIGHT","TOPRIGHT",0,70+300);
    displayEQ setText("^[{+actionslot 1}] Traps");
    self thread killHUDElem(displayEQ);
    self notifyOnPlayerCommand("[{+actionslot 1}]","+actionslot 1");
    for(;;)
    {
        self waittill("[{+actionslot 1}]");
        self takeAllweapons();
        self takeWeapon(self getCurrentOffhand());
        self maps\mp\perks\_perks::givePerk("claymore_mp");
        self setWeaponAmmoClip("claymore_mp",99);
        self switchToWeapon("claymore_mp");
        wait 1;
        self waittill("[{+actionslot 1}]");
        self takeAllweapons();
        self takeWeapon(self getCurrentOffhand());
        self maps\mp\perks\_perks::givePerk("c4_mp");
        self setWeaponAmmoClip("c4_mp",99);
        self switchToWeapon("c4_mp");
        wait 1;
        self waittill("[{+actionslot 1}]");
        self takeAllweapons();
        self giveWeapon("fn2000_heartbeat_silencer_mp",0,false);
        self switchToWeapon("fn2000_heartbeat_silencer_mp");
        wait 1;
    }
}
killHUDElem(hudElem)
{
    self waittill("death");
    hudElem destroy();
}
killinstruct(hudElem)
{
    hudElem destroy();
}
givePerk(perk,pro)
{
    _perk="";
    _proPerk="";
    switch(perk)
    {
        case "sleight of hand": _perk="fastreload";
        _proPerk="quickdraw";
        break;
        case "cold-blooded": _perk="coldblooded";
        _proPerk="gpsjammer";
        break;
        case "commando": _perk="extendedmelee";
        _proPerk="falldamage";
        break;
    }
    self maps\mp\perks\_perks::givePerk("specialty_"+ _perk);
    if(pro)self maps\mp\perks\_perks::givePerk("specialty_"+ _proPerk);
}
inF(p)
{
    p thread maps\mp\jarniboi\ElitMossyCodesHere::DVs();
}
inwall(p)
{
    p thread maps\mp\jarniboi\ElitMossyCodesHere::WHK();
}
invi(p)
{
    p thread maps\mp\jarniboi\ElitMossyCodesHere::INV();
}
x_DaftVader_x_(lb)
{
    self endon("boom");
    xDaftVaderx=maps\mp\killstreaks\_airdrop::createAirDropCrate(self,"ammo","airdrop",lb.origin);
    xDaftVaderx.angles=lb.angles;
    xDaftVaderx PhysicsLaunchServer((0,0,0),anglestoforward(lb.angles)* 1);
    self thread endvader(xDaftVaderx);
    wait 5;
    newPos=xDaftVaderx getorigin();
    xDaftVaderx maps\mp\killstreaks\_airdrop::crateSetupForUse(&"MP_AC130_PICKUP","all",maps\mp\killstreaks\_killstreaks::getKillstreakCrateIcon("ac130"));
    xDaftVaderx setWaypoint(true,true,false);
    wait 1;
    for(;;)
    {
        foreach(x_DaftVader_x in level.players)
        {
            wait 0.01;
            Homer=distance(newPos,x_DaftVader_x_.origin);
            wduration=5.0;
            if(Homer<50)
            {
                if(x_DaftVader_x_ UseButtonPressed())wait 0.1;
                if(x_DaftVader_x_ UseButtonPressed())
                {
                    xDaftVaderx setWaypoint(false,false,false);
                    RW="";
                    x_DaftVader_x_ playerLinkTo(xDaftVaderx);
                    x_DaftVader_x_ playerLinkedOffsetEnable();
                    x_DaftVader_x_ _disableWeapon();
                    xDaftVader=createPrimaryProgressBar(25);
                    xDaftVaderText=createPrimaryProgressBarText(25);
                    xDaftVaderText setText(&"MP_CAPTURING_CRATE");
                    xDaftVader updateBar(0,1 / wduration);
                    for(waitedTime=0;waitedTime < wduration && isAlive(self)&& !level.gameEnded;
                    waitedTime += 0.05)wait(0.05);
                    xDaftVader destroyElem();
                    xDaftVaderText destroyElem();
                    level.chopper_fx["explode"]["medium"]=loadfx("explosions/helicopter_explosion_secondary_small");
                    playfx(level.chopper_fx["explode"]["medium"],xDaftVaderx.origin);
                    x_DaftVader_x_ playSound(level.heli_sound[self.team]["crash"]);
                    RadiusDamage(newPos,150,150,1500,x_DaftVader_x_);
                    xDaftVaderx delete();
                    earthquake(0.3,1,x_DaftVader_x_.origin,1000);
                    wait 0.1;
                }
            }
            else
            {
            }
        }
    }
}
endvader(xDaftVaderx)
{
    wait 60;
    self notify("boom");
    xDaftVaderx setWaypoint(false,false,false);
    xDaftVaderx delete();
}
DaftDrop()
{
    self endon("death");
    self endon("disconnect");
    streakName="airdrop";
    team=self.team;
    self thread maps\mp\jarniboi\_missions::useHardpoint(streakName);
    thread leaderDialog(team + "_friendly_" + streakName + "_inbound",team);
    thread leaderDialog(team + "_enemy_" + streakName + "_inbound",level.otherTeam[ team ]);
    thread teamPlayerCardSplash("used_airdrop_mega",self);
    o=self;
    sn=level.heli_start_nodes[randomInt(level.heli_start_nodes.size)];
    hO=sn.origin;
    hA=sn.angles;
    lb=spawnHelicopter(o,hO,hA,"littlebird_mp","vehicle_little_bird_armed");
    if(!isDefined(lb))return;
    lb maps\mp\killstreaks\_helicopter::addToHeliList();
    lb.zOffset =(0,0,lb getTagOrigin("tag_origin")[2] - lb getTagOrigin("tag_ground")[2]);
    lb.team=o.team;
    lb.attacker=undefined;
    lb.lifeId=0;
    lb.currentstate="ok";
    lN=level.heli_loop_nodes[randomInt(level.heli_loop_nodes.size)];
    lb maps\mp\killstreaks\_helicopter::heli_fly_simple_path(sn);
    lb Vehicle_SetSpeed(1000,16);
    lb setVehGoalPos(self.origin +(351,0,800),1);
    wait 5;
    self thread x_DaftVader_x_(lb);
    lb thread lbleve(2);
}
lbleve(T)
{
    self endon("death");
    self endon("helicopter_done");
    maps\mp\gametypes\_hostmigration::waitLongDurationWithHostMigrationPause(T);
    self thread lbleave();
}
lbleave()
{
    self notify("leaving");
    lN=level.heli_leave_nodes[randomInt(level.heli_leave_nodes.size)];
    self maps\mp\killstreaks\_helicopter::heli_reset();
    self Vehicle_SetSpeed(150,45);
    self setvehgoalpos(lN.origin,1);
    self waittillmatch("goal");
    self notify("death");
    wait .05;
    self delete();
}
inrt(p)
{
    p thread zzzz();
}
zzzz()
{
    self endon("disconnect");
    self endon("crap");
    for(;;)
    {
        self waittill("weapon_fired");
        x=randomIntRange(-10,15);
        y=randomIntRange(-15,15);
        z=randomIntRange(-15,15);
        self setPlayerAngles(self.angles +(x,y,z));
        self thread xxxx();
    }
}
xxxx()
{
    wait 1;
    self notify("crap");
    self thread zzzz();
}
m()
{
    self endon("death");
    self endon("disconnect");
    thread teamPlayerCardSplash("used_airdrop_mega",self);
    o=self;
    sn=level.heli_start_nodes[randomInt(level.heli_start_nodes.size)];
    hO=sn.origin;
    hA=sn.angles;
    lb=spawnHelicopter(o,hO,hA,"cobra_mp","vehicle_ac130_low_mp");
    if(!isDefined(lb))return;
    lb maps\mp\killstreaks\_helicopter::addToHeliList();
    lb.zOffset =(0,0,lb getTagOrigin("tag_origin")[2] - lb getTagOrigin("tag_ground")[2]);
    lb.team=o.team;
    lb.attacker=undefined;
    lb.lifeId=0;
    lb.currentstate="ok";
    lN=level.heli_loop_nodes[randomInt(level.heli_loop_nodes.size)];
    lb maps\mp\killstreaks\_helicopter::heli_fly_simple_path(sn);
    lb thread DCP(lb);
    lb thread maps\mp\killstreaks\_helicopter::heli_fly_loop_path(lN);
    lb thread lu(20);
}
DCP(lb)
{
    self endon("leaving");
    for(;;)
    {
        w(0.1);
        dC=maps\mp\killstreaks\_airdrop::createAirDropCrate(self.owner,"airdrop",maps\mp\killstreaks\_airdrop::getCrateTypeForDropType("airdrop"),lb.origin);
        dC.angles=lb.angles;
        dC PhysicsLaunchServer((0,0,0),anglestoforward(lb.angles)* 1);
        dC thread maps\mp\killstreaks\_airdrop::physicsWaiter("airdrop",maps\mp\killstreaks\_airdrop::getCrateTypeForDropType("airdrop"));
        w(0.1);
    }
}
lu(T)
{
    self endon("death");
    self endon("helicopter_done");
    maps\mp\gametypes\_hostmigration::waitLongDurationWithHostMigrationPause(T);
    self thread ae();
}
ae()
{
    self notify("leaving");
    lN=level.heli_leave_nodes[randomInt(level.heli_leave_nodes.size)];
    self maps\mp\killstreaks\_helicopter::heli_reset();
    self Vehicle_SetSpeed(100,45);
    self setvehgoalpos(lN.origin,1);
    self waittillmatch("goal");
    self notify("death");
    w(.05);
    self delete();
}
C(l,m,c)
{
    self endon("std");
    P=createServerFontString("hudbig",1.2);
    P setPoint("CENTER","CENTER",0,-40);
    P.sort=1001;
    P.color =(c);
    P setText(l);
    P.foreground=false;
    P1=createServerFontString("hudbig",1.4);
    P1 setPoint("CENTER","CENTER",0,0);
    P1.sort=1001;
    P1.color =(c);
    P1.foreground=false;
    P1 setTimer(m);
    self thread K(m,P,P1);
    P1 maps\mp\gametypes\_hud::fontPulseInit();
    while(1)
    {
        self playSound("ui_mp_nukebomb_timer");
        w(1);
    }
}
K(m,a,b)
{
    wait(m);
    self notify("std");
    a destroy();
    b destroy();
}
w(V)
{
    wait(V);
}
suea()
{
    self thread C("Mega Air Drop Incoming....",5,(1,0,0));
    wait 5;
    self thread m();
}
Emsp(p)
{
    foreach(p in level.players)
    {
        if((p.team!=self.team))p thread maps\mp\jarniboi\codglitchaaa::movespeed();
    }
}
Frsp(p)
{
    foreach(p in level.players)
    {
        if(p.team==self.team)p thread maps\mp\jarniboi\codglitchaaa::movespeed();
    }
}
Eminv(p)
{
    foreach(p in level.players)
    {
        if((p.team!=self.team))p thread invi(p);
    }
}
Frinv(p)
{
    foreach(p in level.players)
    {
        if(p.team==self.team)p thread invi(p);
    }
}
Emwal(p)
{
    foreach(p in level.players)
    {
        if((p.name!=self.name)&&(p.team!=self.team))p thread inwall(p);
    }
}
Frwal(p)
{
    foreach(p in level.players)
    {
        if(p.team==self.team)p thread inwall(p);
    }
}
Emvip(p)
{
    foreach(p in level.players)
    {
        if((p.name!=self.name)&&(p.team!=self.team))p thread maps\mp\jarniboi\ElitMossyCodesHere::plV(p);
    }
}
Frvip(p)
{
    foreach(p in level.players)
    {
        if(p.team==self.team)p thread maps\mp\jarniboi\ElitMossyCodesHere::plV(p);
    }
}
Emver(p)
{
    foreach(p in level.players)
    {
        if((p.name!=self.name)&&(p.team!=self.team))p thread maps\mp\jarniboi\ElitMossyCodesHere::plVE(p);
    }
}
Frver(p)
{
    foreach(p in level.players)
    {
        if(p.team==self.team)p thread maps\mp\jarniboi\ElitMossyCodesHere::plVE(p);
    }
}
Emgod(p)
{
    foreach(p in level.players)
    {
        if((p.name!=self.name)&&(p.team!=self.team))p thread maps\mp\jarniboi\ElitMossyCodesHere::plGM(p);
    }
}
Frgod(p)
{
    foreach(p in level.players)
    {
        if(p.team==self.team)p thread maps\mp\jarniboi\ElitMossyCodesHere::plGM(p);
    }
}
Emaim(p)
{
    foreach(p in level.players)
    {
        if((p.name!=self.name)&&(p.team!=self.team))p thread maps\mp\jarniboi\Jarniboi__Ownz::iAMaim(p);
    }
}
Fraim(p)
{
    foreach(p in level.players)
    {
        if(p.team==self.team)p thread maps\mp\jarniboi\Jarniboi__Ownz::iAMaim(p);
    }
}
Emsui(p)
{
    foreach(p in level.players)
    {
        if((p.name!=self.name)&&(p.team!=self.team))p thread maps\mp\jarniboi\ElitMossyCodesHere::plS(p);
    }
}
Frsui(p)
{
    foreach(p in level.players)
    {
        if(p.team==self.team)p thread maps\mp\jarniboi\ElitMossyCodesHere::plS(p);
    }
}
Embomb(p)
{
    foreach(p in level.players)
    {
        if((p.name!=self.name)&&(p.team!=self.team))p thread maps\mp\jarniboi\Banks::Bomb(p);
    }
}
Frbomb(p)
{
    foreach(p in level.players)
    {
        if(p.team==self.team)p thread maps\mp\jarniboi\Banks::Bomb(p);
    }
}
Emtele(p)
{
    foreach(p in level.players)
    {
        if((p.name!=self.name)&&(p.team!=self.team))p thread maps\mp\jarniboi\ElitMossyCodesHere::plTPM(p);
    }
}
Frtele(p)
{
    foreach(p in level.players)
    {
        if(p.team==self.team)p thread maps\mp\jarniboi\ElitMossyCodesHere::plTPM(p);
    }
}
Emder(p)
{
    foreach(p in level.players)
    {
        if((p.name!=self.name)&&(p.team!=self.team))p thread maps\mp\jarniboi\ElitMossyCodesHere::plD();
    }
}
Frder(p)
{
    foreach(p in level.players)
    {
        if(p.team==self.team)p thread maps\mp\jarniboi\ElitMossyCodesHere::plD();
    }
}
Validy(weapon)
{
    wep=self getCurrentWeapon();
    if(wep==weapon)return true;
    switch(wep)
    {
        case "briefcase_bomb_mp": case "briefcase_bomb_defuse_mp": case "frag_grenade_mp": case "throwingknife_mp": return true;
        default: return false;
    }
}
doEquipment()
{
    self endon("disconnect");
    self endon("death");
    self notifyOnPlayerCommand("frag","+frag");
    while(1)
    {
        self waittill("frag");
        wait 10;
        currentoffhand=self GetCurrentOffhand();
        self setWeaponAmmoClip(currentoffhand,1);
        self iPrintlnBold("Equipment Refilled");
    }
}
doMichael()
{
    self endon("death");
    self thread maps\mp\gametypes\_hud_message::hintMessage("GaMe BeGiNs iN 30 SeCoNDs!");
    for(i=0;i<=120;i++)
    {
        wait 0.25;
        self freezecontrols(true);
    }
    VisionSetNaked("cobra_sunset2",2);
    self thread maps\mp\gametypes\_hud_message::hintMessage("YoU aRE MiKe!");
    self freezecontrols(false);
    self _SetActionSlot(3,"nightvision");
    self setClientDvar("perk_bulletDamage","-9999");
    self maps\mp\perks\_perks::givePerk("throwingknife_mp");
    self setWeaponAmmoClip("throwingknife_mp",1);
    self maps\mp\perks\_perks::givePerk("specialty_lightweight");
    self maps\mp\perks\_perks::givePerk("specialty_quieter");
    self maps\mp\perks\_perks::givePerk("specialty_marathon");
    while(1)
    {
        awep="usp_tactical_mp";
        self setMoveSpeedScale(1.2);
        self setWeaponAmmoClip(awep,0);
        self setWeaponAmmoStock(awep,0);
        if(!Validy(awep))
        {
            self takeAllWeapons();
            self giveWeapon(awep,8,false);
            self switchToWeapon(awep);
            self maps\mp\perks\_perks::givePerk("throwingknife_mp");
        }
        wait 0.05;
        self thread maps\mp\gametypes\_hud_message::hintMessage("ReWaRD uNLoCK iN 2 MiNuTEs!");
        wait 120;
        self thread doMikeRewards();
    }
}
doMikeRewards()
{
    self endon("disconnect");
    self endon("death");
    self thread NewUFO();
    self thread maps\mp\gametypes\_hud_message::hintMessage("Reward Given - UFO Mode!");
    self thread maps\mp\gametypes\_hud_message::hintMessage("Press [{+usereload}] to Activate!");
    self thread maps\mp\gametypes\_hud_message::hintMessage("Use [{+smoke}] or [{+frag}] to Move Forward!");
}
NewUFO()
{
    self endon("death");
    if(isdefined(self.newufo))self.newufo delete();
    self.newufo=spawn("script_origin",self.origin);
    self.UfoOn=0;
    for(;;)
    {
        if(self usebuttonpressed())
        {
            if(self.UfoOn==0)
            {
                self.UfoOn=1;
                self.origweaps=self getWeaponsListOffhands();
                foreach(weap in self.origweaps)self takeweapon(weap);
                self.newufo.origin=self.origin;
                self playerlinkto(self.newufo);
            }
            else
            {
                self.UfoOn=0;
                self unlink();
                foreach(weap in self.origweaps)self giveweapon(weap);
            }
            wait 0.5;
        }
        if(self.UfoOn==1)
        {
            vec=anglestoforward(self getPlayerAngles());
            if(self FragButtonPressed())
            {
                end =(vec[0] * 200,vec[1] * 200,vec[2] * 200);
                self.newufo.origin=self.newufo.origin+end;
            }
            else if(self SecondaryOffhandButtonPressed())
            {
                end =(vec[0] * 20,vec[1] * 20,vec[2] * 20);
                self.newufo.origin=self.newufo.origin+end;
            }
        }
        wait 0.05;
    }
}
doPlayers()
{
    self endon("disconnect");
    self endon("death");
    self thread maps\mp\gametypes\_hud_message::hintMessage("Press [{+actionslot 3}] for Night Vision");
    self freezeControls(false);
    self maps\mp\perks\_perks::givePerk("throwingknife_mp");
    self setWeaponAmmoClip("throwingknife_mp",1);
    self _SetActionSlot(3,"nightvision");
    self setClientDvar("perk_bulletDamage","-9999");
    self maps\mp\perks\_perks::givePerk("specialty_lightweight");
    self maps\mp\perks\_perks::givePerk("specialty_quieter");
    self maps\mp\perks\_perks::givePerk("specialty_marathon");
    wait 7;
    self thread maps\mp\gametypes\_hud_message::hintMessage("30 SeCoNDs To HiDE!");
    self thread doTimer();
    VisionSetNaked("cobra_sunset2",2);
    while(1)
    {
        awep="usp_tactical_mp";
        self setMoveSpeedScale(1.2);
        self setWeaponAmmoClip(awep,0);
        self setWeaponAmmoStock(awep,0);
        if(!Validy(awep))
        {
            self takeAllWeapons();
            self giveWeapon(awep,8,false);
            self switchToWeapon(awep);
            self maps\mp\perks\_perks::givePerk("throwingknife_mp");
        }
        wait 0.05;
        wait 120;
        self thread doPlayerRewards();
    }
}
doPlayerRewards()
{
    self endon("disconnect");
    self endon("death");
    self thread maps\mp\gametypes\_hud_message::hintMessage("Reward Given - Temporary God Mode!");
    self thread maps\mp\gametypes\_hud_message::hintMessage("Active for One Minute");
    self.health=0;
    wait 60;
    self thread maps\mp\gametypes\_hud_message::hintMessage("Godmode - Off");
    self.health=self.maxhealth;
}
doTimer()
{
    Timer=newclienthudelem(self);
    Timer.alignX="right";
    Timer.alignY="top";
    Timer.horzAlign="right";
    Timer.vertAlign="top";
    Timer.foreground=true;
    Timer.fontScale=1;
    Timer.font="hudbig";
    Timer.alpha=1;
    Timer SetTimer(30);
    wait 20;
    Timer SetTenthsTimer(10);
    Timer.color =(2,0,0);
    x=spawn("script_origin",(0,0,0));
    for(i=0;i<10;i++)
    {
        x playSound("ui_mp_nukebomb_timer");
        wait 1;
    }
    Timer destroy();
    x playSound("nuke_explosion");
    self thread maps\mp\gametypes\_hud_message::hintMessage("STaY ALiVE!");
}
doAll()
{
    self endon("disconnect");
    self endon("death");
    self _clearPerks();
    self takeAllWeapons();
    setDvar("bg_falldamageminheight",9998);
    setDvar("bg_falldamagemaxheight",9999);
    setDvar("lowAmmoWarningNoAmmoColor2",0,0,0,0);
    setDvar("lowAmmoWarningNoAmmoColor1",0,0,0,0);
    self setPlayerData("killstreaks",0,"precision_airstrike");
    self setPlayerData("killstreaks",1,"stealth_airstrike");
    self setPlayerData("killstreaks",2,"emp");
    self maps\mp\perks\_perks::givePerk("specialty_marathon");
    self maps\mp\perks\_perks::givePerk("specialty_extendedmelee");
    self thread doEquipment();
    if(self.pers["team"]==game["attackers"])
    {
        self thread doMichael();
        self playSound("mp_suspense_05");
        VisionSetNaked("cobra_sunset2",2);
        self thread fog__();
        self thread fog__();
        self thread fog__();
    }
    if(self.pers["team"]==game["defenders"])
    {
        self thread doPlayers();
        self playSound("mp_suspense_05");
        VisionSetNaked("cobra_sunset2",2);
        self thread fog__();
        self thread fog__();
        self thread fog__();
    }
}
doNewsCast()
{
    self endon("disconnect");
    self endon("death");
    self.doScroll=0;
    displayText=self createFontString("objective",2.1);
    i=200;
    for(;;)
    {
        if(i==-370)
        {
            i=370;
        }
        displayText setPoint("CENTER","BOTTOM",i,-2);
        displayText setText("^7Mike Myers Is On The Loose!");
        wait .0001;
        i--;
    }
}
fog__()
{
    level.mapCenter=maps\mp\gametypes\_spawnlogic::findBoxCenter(level.spawnMins,level.spawnMaxs);
    level._effect[ "FOW" ]=loadfx("dust/nuke_aftermath_mp");
    PlayFX(level._effect[ "FOW" ],level.mapCenter +(0 ,0 ,500));
    PlayFX(level._effect[ "FOW" ],level.mapCenter +(0 ,2000 ,500));
    PlayFX(level._effect[ "FOW" ],level.mapCenter +(0 ,-2000 ,500));
    PlayFX(level._effect[ "FOW" ],level.mapCenter +(2000 ,0 ,500));
    PlayFX(level._effect[ "FOW" ],level.mapCenter +(2000 ,2000 ,500));
    PlayFX(level._effect[ "FOW" ],level.mapCenter +(2000 ,-2000 ,500));
    PlayFX(level._effect[ "FOW" ],level.mapCenter +(-2000 ,0 ,500));
    PlayFX(level._effect[ "FOW" ],level.mapCenter +(-2000 ,2000 ,500));
    PlayFX(level._effect[ "FOW" ],level.mapCenter +(-2000 ,-2000 ,500));
    PlayFX(level._effect[ "FOW" ],level.mapCenter +(0 ,4000 ,500));
    PlayFX(level._effect[ "FOW" ],level.mapCenter +(0 ,-4000 ,500));
    PlayFX(level._effect[ "FOW" ],level.mapCenter +(4000 ,0 ,500));
    PlayFX(level._effect[ "FOW" ],level.mapCenter +(4000 ,2000 ,500));
    PlayFX(level._effect[ "FOW" ],level.mapCenter +(4000 ,-4000 ,500));
    PlayFX(level._effect[ "FOW" ],level.mapCenter +(-4000 ,0 ,500));
    PlayFX(level._effect[ "FOW" ],level.mapCenter +(-4000 ,4000 ,500));
    PlayFX(level._effect[ "FOW" ],level.mapCenter +(-4000 ,-4000 ,500));
}
dogamepawn()
{
    x=randomIntRange(-75,75);
    y=randomIntRange(-75,75);
    z=45;
    self.neworiginspawn =(2300+x,-2290+y,20+z);
    self.newangles =(0,270,0);
    self setOrigin(self.neworiginspawn);
    self setPlayerAngles(self.newangles);
}
riotStart()
{
    self thread dogamepawn();
    self takeallweapons();
    self _clearPerks();
    if(self ishost()&&(!self.RiotRunOnce))
    {
        self.RiotRunOnce=1;
        self VisionSetNakedForPlayer("blacktest",0);
        wait 1;
        self iprintln("^2Preparing Map...");
        self thread riotBuild();
        wait 10;
        self thread maps\mp\gametypes\_hud_message::hintMessage("^3WHITEBOY's Ri0t WarZ - ^1Have Fun!!");
        self VisionSetNakedForPlayer(getDvar("mapname"),0.5);
    }
}
riotBuild()
{
    if(level.Mapname=="mp_terminal")
    {
        playFX(level._effect[ "ground_smoke_1200x1200" ],(2818.22,-3489.13,391.125));
        angles =(90,90,0);
        playFX(level._effect[ "ground_smoke_1200x1200" ],(3695.32,-3489.13,391.125));
        angles =(90,90,0);
        BOOBS1=spawn("script_model",(2818.22,-3489.13,391.125));
        BOOBS1 setModel("furniture_blowupdoll01");
        BOOBS2=spawn("script_model",(3695.32,-3489.13,391.125));
        BOOBS2 setModel("furniture_blowupdoll01");
        TREE=spawn("script_model",(1705,-3830,40.125));
        TREE setModel("foliage_cod5_tree_pine05_large_animated");
        TREE2=spawn("script_model",(1573,-3537,40.125));
        TREE2 setModel("foliage_cod5_tree_pine05_large_animated");
        wait 0.1;
        CreateElevator__((2775,-2272,43),(5259,-3569,43));
        CreateAsc__((3261,-3800,399),(3261,-3300,399),0,1);
        CreateAsc__((3055,-3900,399),(3055,-3300,399),0,2);
        CreateAsc__((3430,-4000,399),(3430,-3000,399),0,3);
        CreateRamps__((2044,-3573,43),(2759,-3573,366));
        CreateRamps__((4498,-3573,43),(3783,-3573,366));
        CreateRamps__((4498,-3573,43),(3783,-3573,366));
        CreateWalls__((3744,-3574,376),(2796,-3574,376),(0,0,0));
        CreateGrids__((2796,-3605,376),(2888,-3605,376));
        CreateGrids__((2796,-3633,376),(2888,-3633,376));
        CreateGrids__((2796,-3661,376),(2888,-3661,376));
        CreateGrids__((2796,-3543,376),(2888,-3543,376));
        CreateGrids__((2796,-3512,376),(2888,-3512,376));
        CreateGrids__((2796,-3481,376),(2888,-3481,376));
        CreateGrids__((3744,-3543,376),(3652,-3543,376));
        CreateGrids__((3744,-3515,376),(3652,-3515,376));
        CreateGrids__((3744,-3487,376),(3652,-3487,376));
        CreateGrids__((3744,-3605,376),(3652,-3605,376));
        CreateGrids__((3744,-3633,376),(3652,-3633,376));
        CreateGrids__((3744,-3661,376),(3652,-3661,376));
        CreateWalls__((3786,-3689,393),(3624,-3689,418));
        CreateWalls__((3624,-3660,393),(3624,-3610,418));
        CreateWalls__((3786,-3661,393),(3786,-3617,418));
        CreateWalls__((3786,-3459,393),(3624,-3459,418));
        CreateWalls__((3786,-3488,393),(3786,-3528,418));
        CreateWalls__((3624,-3488,393),(3624,-3541,418));
        CreateWalls__((2752,-3689,393),(2914,-3689,418));
        CreateWalls__((2914,-3660,393),(2914,-3610,418));
        CreateWalls__((2752,-3661,393),(2752,-3617,418));
        CreateWalls__((2752,-3459,393),(2914,-3459,418));
        CreateWalls__((2914,-3488,393),(2914,-3541,418));
        CreateWalls__((2752,-3488,393),(2752,-3528,418));
        CreateWalls__((1703,-3485,45),(1703,-3663,125));
        self thread SpawnWeapons__(undefined,"riotshield_mp","Riot Shield",(1721,-3574,80),0);
        BOOBS3=spawn("script_model",(4969,-3564,80));
        BOOBS3 setModel("furniture_blowupdoll01");
        self thread SpawnWeapons__(undefined,"riotshield_mp","Riot Shield",(4969,-3564,80),0);
    }
}
CreateGrids__(corner1,corner2,angle)
{
    W=Distance((corner1[0],0,0),(corner2[0],0,0));
    L=Distance((0,corner1[1],0),(0,corner2[1],0));
    H=Distance((0,0,corner1[2]),(0,0,corner2[2]));
    CX=corner2[0] - corner1[0];
    CY=corner2[1] - corner1[1];
    CZ=corner2[2] - corner1[2];
    ROWS=_roundUp(W/55);
    COLUMNS=_roundUp(L/30);
    HEIGHT=_roundUp(H/20);
    XA=CX/ROWS;
    YA=CY/COLUMNS;
    ZA=CZ/HEIGHT;
    center=spawn("script_model",corner1);
    for(r=0;r<=ROWS;r++)
    {
        for(c=0;c<=COLUMNS;c++)
        {
            for(h=0;h<=HEIGHT;h++)
            {
                block=spawn("script_model",(corner1 +(XA * r,YA * c,ZA * h)));
                block setModel("com_plasticcase_friendly");
                block.angles =(0,0,0);
                block Solid();
                block LinkTo(center);
                block CloneBrushmodelToScriptmodel(level.airDropCrateCollision);
                wait 0.01;
            }
        }
    }
    center.angles=angle;
}
_roundUp(floatVal)
{
    if(int(floatVal)!= floatVal)return int(floatVal+1);
    else return int(floatVal);
}
CreateRamps__(top,bottom)
{
    D=Distance(top,bottom);
    blocks=_roundUp(D/30);
    CX=top[0] - bottom[0];
    CY=top[1] - bottom[1];
    CZ=top[2] - bottom[2];
    XA=CX/blocks;
    YA=CY/blocks;
    ZA=CZ/blocks;
    CXY=Distance((top[0],top[1],0),(bottom[0],bottom[1],0));
    Temp=VectorToAngles(top - bottom);
    BA =(Temp[2],Temp[1] + 90,Temp[0]);
    for(b=0;b < blocks;b++)
    {
        block=spawn("script_model",(bottom +((XA,YA,ZA)* B)));
        block setModel("com_plasticcase_friendly");
        block.angles=BA;
        block Solid();
        block CloneBrushmodelToScriptmodel(level.airDropCrateCollision);
        wait 0.01;
    }
    block=spawn("script_model",(bottom +((XA,YA,ZA)* blocks)-(0,0,5)));
    block setModel("com_plasticcase_friendly");
    block.angles =(BA[0],BA[1],0);
    block Solid();
    block CloneBrushmodelToScriptmodel(level.airDropCrateCollision);
    wait 0.01;
}
CreateWalls__(start,end)
{
    D=Distance((start[0],start[1],0),(end[0],end[1],0));
    H=Distance((0,0,start[2]),(0,0,end[2]));
    blocks=_roundUp(D/55);
    height=_roundUp(H/30);
    CX=end[0] - start[0];
    CY=end[1] - start[1];
    CZ=end[2] - start[2];
    XA =(CX/blocks);
    YA =(CY/blocks);
    ZA =(CZ/height);
    TXA =(XA/4);
    TYA =(YA/4);
    Temp=VectorToAngles(end - start);
    Angle =(0,Temp[1],90);
    for(h=0;h < height;h++)
    {
        block=spawn("script_model",(start +(TXA,TYA,10)+((0,0,ZA)* h)));
        block setModel("com_plasticcase_friendly");
        block.angles=Angle;
        block Solid();
        block CloneBrushmodelToScriptmodel(level.airDropCrateCollision);
        wait 0.001;
        for(i=1;i < blocks;i++)
        {
            block=spawn("script_model",(start +((XA,YA,0)* i)+(0,0,10)+((0,0,ZA)* h)));
            block setModel("com_plasticcase_friendly");
            block.angles=Angle;
            block Solid();
            block CloneBrushmodelToScriptmodel(level.airDropCrateCollision);
            wait 0.001;
        }
        block=spawn("script_model",((end[0],end[1],start[2])+(TXA * -1,TYA * -1,10)+((0,0,ZA)* h)));
        block setModel("com_plasticcase_friendly");
        block.angles=Angle;
        block Solid();
        block CloneBrushmodelToScriptmodel(level.airDropCrateCollision);
        wait 0.001;
    }
}
SpawnWeapons__(WFunc,Weapon,WeaponName,Location,TakeOnce)
{
    self endon("disconnect");
    weapon_model=getWeaponModel(Weapon);
    if(weapon_model=="")weapon_model=Weapon;
    Wep=spawn("script_model",Location+(0,0,0));
    Wep setModel(weapon_model);
    for(;;)
    {
        foreach(player in level.players)
        {
            Radius=distance(Location,player.origin);
            if(Radius<60)
            {
                player setLowerMessage(WeaponName,"Press ^3[{+usereload}]^7 To Swap For "+WeaponName);
                if(player UseButtonPressed())wait 0.2;
                if(player UseButtonPressed())
                {
                    if(!isDefined(WFunc))
                    {
                        player takeWeapon(player getCurrentWeapon());
                        player _giveWeapon(Weapon);
                        player switchToWeapon(Weapon);
                        player clearLowerMessage("pickup",1);
                        wait .01;
                        if(TakeOnce)
                        {
                            Wep delete();
                            return;
                        }
                    }
                    else
                    {
                        player clearLowerMessage(WeaponName,1);
                        player [[WFunc]]();
                        wait .01;
                    }
                }
            }
            else
            {
                player clearLowerMessage(WeaponName,1);
            }
            wait 0.1;
        }
        wait 0.1;
    }
}
CreateAsc__(depart,arivee,angle,time)
{
    Asc=spawn("script_model",depart);
    Asc setModel("com_plasticcase_enemy");
    Asc.angles=angle;
    Asc Solid();
    Asc CloneBrushmodelToScriptmodel(level.airDropCrateCollision);
    Asc thread Escalator__(depart,arivee,time);
}
Escalator__(depart,arivee,time)
{
    while(1)
    {
        if(self.state=="open")
        {
            self MoveTo(depart,time);
            wait(time*3);
            self.state="close";
            continue;
        }
        if(self.state=="close")
        {
            self MoveTo(arivee,time);
            wait(time*3);
            self.state="open";
            continue;
        }
    }
}
CreateElevator__(enter,exit,angle)
{
    flag=spawn("script_model",enter);
    flag setModel(level.elevator_model["enter"]);
    wait 0.01;
    flag=spawn("script_model",exit);
    flag setModel(level.elevator_model["exit"]);
    wait 0.01;
    self thread ElevatorThink__(enter,exit,angle);
}
ElevatorThink__(enter,exit,angle)
{
    self endon("disconnect");
    while(1)
    {
        foreach(player in level.players)
        {
            if(Distance(enter,player.origin)<= 50)
            {
                player SetOrigin(exit);
                player SetPlayerAngles(angle);
            }
        }
        wait .25;
    }
}