init_iSnipe()
{
    level.isnipe_Ammo_drop_pos = getEnt("sd_bomb_pickup_trig","targetname").origin;
    level thread isnipe_watermark();
    level thread iSnipe_onPlayerConnect();
    PreCacheModel("cardicon_prestige10_02");
}

iSnipe_onPlayerConnect()
{
    for(;;)
    {
        level waittill("connected",player);
        player thread iSnipe_onPlayerSpawned();
    }
}

iSnipe_onPlayerSpawned()
{
    self endon("disconnect");
    level endon("game_ended");
    for(;;)
    {
        self waittill("spawned_player");
        if(self isHost() && !isDefined(level.isnipe_heli_owner))
        {
            level.isnipe_heli_owner = self;
            level thread isnipe_doAmmoDelivery();
            if(getDvar("g_gametype")!="war"||getDvar("ui_gametype")!="war"||getDvarInt("scr_game_hardpoints")!=0||getDvarInt("scr_hardcore")!=0||getDvarInt("scr_war_scorelimit")!=7500||getDvarInt("scr_war_timelimit")!=10)
            {
                self iprintlnBold("^1Some Dvars need to be changed!");
                wait 4;
                self iprintlnBold("^1Restarting Now!!!!");
                wait 2;
                changeGameType("war");
                setDvar("scr_war_scorelimit",7500);
                setDvar("scr_war_timelimit",10);
                setDvar("scr_game_hardpoints",0);
                setDvar("scr_hardcore",0);
                map_restart(false);
            }
        }
        self thread isnipe_welcomeMSG();
        self isnipe_givePlayerLoadout();
        self thread isnipe_antiHardScope();
        self thread isnipe_antiCamp();
    }
}

isnipe_watermark()
{
    level.isnipe_title           = createServerText("objective",1.5,"","",0,0,(1,1,1),1,(0,0,0),0,"");
    level.isnipe_title.horzAlign = "right";
    level.isnipe_title.vertAlign = "top";
    level.isnipe_title setText("iSnipe");
    level.isnipe_title elemSetSort(666);
    level.isnipe_title thread elemColorEffect();
}

isnipe_givePlayerLoadout()
{
    self freezeControls(false);
    
    //Remove All Perks
    self clearPerks();
    
    //Remove All Weapons
    self takeAllWeapons();
    wait 0.05;
    
    //Give Perks
    self maps\mp\perks\_perks::givePerk("specialty_fastreload");
    self maps\mp\perks\_perks::givePerk("specialty_quickdraw");
    self maps\mp\perks\_perks::givePerk("specialty_bulletdamage");
    self maps\mp\perks\_perks::givePerk("specialty_armorpiercing");
    self maps\mp\perks\_perks::givePerk("specialty_bulletaccuracy");
    self maps\mp\perks\_perks::givePerk("specialty_holdbreath");
    self maps\mp\perks\_perks::givePerk("specialty_falldamage");
    
    //Give + switch to Intervention
    self giveWeapon("cheytac_fmj_mp",6,false);
    self switchToWeapon("cheytac_fmj_mp");
    
    //Give Pistol with Tactical Knife(No Ammo) + Throwing Knife
    self giveWeapon("deserteagle_tactical_mp",0,false);
    wait 0.05;
    self setWeaponAmmoClip("deserteagle_tactical_mp",0);
    self setWeaponAmmoStock("deserteagle_tactical_mp",0);
    self maps\mp\perks\_perks::givePerk("throwingknife_mp");
    
    //Double check
    self setClientDvar("g_hardcore",0);
    self setClientDvar("cg_crosshairAlpha",1);
    
    //ISnipe Dvars
    setDvar("cg_fov",85);
    setDvar("perk_weapSpreadMultiplier",0.45);
    setDvar("perk_fastSnipeScale",3);
    setDvar("cg_drawBreathHint",0);
}

isnipe_antiHardScope()
{
    self endon("disconnect");
    self endon("death");
    self.ADS_TIME = 0;
    for(;;)
    {
        if(self AdsButtonPressed())
        {
            if(self playerAds())
            {
                self.ADS_TIME ++;
                if(self.ADS_TIME >= 20)
                {
                    self allowAds(false);
                    wait .4;
                }
            }
        }
        else
        {
            self.ADS_TIME = 0;
            self allowAds(true);
        }
        
        //make sure secondary doesnt have ammo
        if(self getWeaponAmmoClip("deserteagle_tactical_mp")>0||self getWeaponAmmoStock("deserteagle_tactical_mp")>0)
        {
            self setWeaponAmmoClip("deserteagle_tactical_mp",0);
            self setWeaponAmmoStock("deserteagle_tactical_mp",0);
        }
        wait 0.05;
    }
}

isnipe_antiCamp()
{
    self endon("disconnect");
    self endon("death");
    self.CAMP_TIME = 0;
    for(;;)
    {
        pos = self getOrigin();
        wait .2;
        if(distance(pos,self getOrigin())<10)
        {
            self.CAMP_TIME ++;
            if(self.CAMP_TIME>5 && self.CAMP_TIME<=8)
            {
                self iprintlnBold("^1STOP CAMPING!");
                count = 3;
            }
            else if(self.CAMP_TIME>8 && self.CAMP_TIME<=11)
            {
                self iprintlnBold("^1"+count);
                count --;
            }
            else if(self.CAMP_TIME>11)
            {
                self suicide();
            }
            wait 1;
        }
        else
        {
            self.CAMP_TIME = 0;
        }
        wait 0.05;
    }
}

isnipe_welcomeMSG()
{
    if(!self.isnipe_welcomeDone||!isDefined(self.isnipe_welcomeDone))
    {
        notifyData             = spawnstruct();
        notifyData.iconName    = "cardicon_prestige10_02";
        notifyData.titleText   = "^5Welcome "+self.name+"!";
        notifyData.notifyText  = "^5to";
        notifyData.notifyText2 = "^5OMA Yamato's iSnipe Mod'";
        notifyData.glowAlpha   = 1;
        notifyData.glowColor   = (0,0,1);
        notifyData.duration    = 9;
        self thread maps\mp\gametypes\_hud_message::notifyMessage(notifyData);
        self.isnipe_welcomeDone = true;
    }
}

isnipe_doAmmoDelivery()
{
    level endon("game_ended");
    level.isnipe_ammo_time = randomIntRange(60,180);
    for(;;)
    {
        wait level.isnipe_ammo_time;
        level.isnipe_heli_owner thread isnipe_deliverAmmo();
        wait .6;
        level.isnipe_ammo_time = randomIntRange(60,180);
        wait 0.05;
    }
}

isnipe_deliverAmmo()
{
    heli       = spawnHelicopter(self,level.isnipe_Ammo_drop_pos+(9000,9000,3000),self.angles,"pavelow_mp","vehicle_pavelow_opfor");
    heli.owner = self;
    heli.team  = self.team;
    wait 0.05;
    heli Vehicle_SetSpeed(1000,16);
    heli setVehGoalPos(level.isnipe_Ammo_drop_pos+(0,0,1000),1);
    heli waittill("goal");
    wait 0.05;
    care        = maps\mp\killstreaks\_airdrop::createAirDropCrate(self,"airdrop","ammo",heli.origin);
    care.angles = heli.angles;
    care PhysicsLaunchServer((0,0,0),anglestoforward(heli.angles)*1);
    care thread maps\mp\killstreaks\_airdrop::physicsWaiter("airdrop","ammo");
    wait 0.05;
    heli setVehGoalPos(level.isnipe_Ammo_drop_pos+(9000,9000,3000),1);
    heli waittill("goal");
    heli delete();
}