setMenuVar(var_name,var_input)
{
    if(!isDefined(self.PIX["Menu_Var"]))
    {
        self.PIX["Menu_Var"] = [];
    }
    self.PIX["Menu_Var"][var_name] = var_input;
}
getMenuVar(var_name)
{
    if(!isDefined(self.PIX["Menu_Var"][var_name]))
    {
        return undefined;
    }
    return self.PIX["Menu_Var"][var_name];
}
toggleMenuVar(var_name)
{
    if(!self getMenuVar(var_name))
    {
        self setMenuVar(var_name,true);
    }
    else
    {
        self setMenuVar(var_name,false);
        if(var_name=="menu_freeze")
        {
            wait 0.05;
            self freezeControls(false);
        }
    }
}

setCurrentMenu(menu)
{
    newMenu = "";
    if(!isDefined(menu))
    {
        newMenu = "main";
    }
    else 
    {
        newMenu = menu;
    }
    self.PIX["CurrentMenu"] = newMenu;
}
getCurrentMenu()
{
    if(!isDefined(self.PIX["CurrentMenu"]))
    {
        self setCurrentMenu("main");
    }
    return self.PIX["CurrentMenu"];
}
getCurrentMenuType()
{
    if(!isDefined(self.Menu[self getCurrentMenu()].type))
    {
        self.Menu[self getCurrentMenu()].type = "default";
    }
    return self.Menu[self getCurrentMenu()].type;
}

setMenuScroller(value)
{
    if(value<0)
    {
        value = self getMenuSize()-1;
    }
    if(value>self getMenuSize()-1)
    {
        value = 0;
    }
    self.Scroller[self getCurrentMenu()] = value;
}
getMenuScroller()
{
    if(!isDefined(self.Scroller[self getCurrentMenu()]))
    {
        self setMenuScroller(0);
    }
    return self.Scroller[self getCurrentMenu()];
}

getMenuSize()
{
    if(self.Menu[self getCurrentMenu()].text.size<=0)
    {
        return 0;
    }
    return self.Menu[self getCurrentMenu()].text.size;
}
getMenuTextIndexByString(string)
{
    index = 0;
    for(i=0;i<self getMenuSize();i++)
    {
        if(self.Menu[self getCurrentMenu()].text[i]==string)
        {
            index = i;
            break;
        }
    }
    return index;
}
hasMinVerifycationLevel(index,error_msg = false)
{
    if(isDefined(self.Menu[self getCurrentMenu()].min_verifycation_level[index]))
    {
        min_vlevel = self.Menu[self getCurrentMenu()].min_verifycation_level[index];
    }
    else
    {
        min_vlevel = 1;
    }
    if(self getVerifycationLevel()>=min_vlevel)
    {
        return true;
    }
    else
    {
        if(error_msg)
        {
            self iprintlnBold("Verifycation Level " + getVerifycationLevel_Color(min_vlevel) + getVerifycationLevel_String(min_vlevel) + " ^7or Higher Needed!");
        }
        return false;
    }
}
sortPlayerListByVerifycationLevel()
{
    list             = [];
    players_to_check = level.players.size;
    check_vlevel     = 0;
    while((players_to_check > 0) && (check_vlevel <= level.VerifycationLevels.size))
    {
        for(i=0;i<level.players.size;i++)
        {
            if(level.players[i] getVerifycationLevel() == check_vlevel)
            {
                list[list.size] = level.players[i];
                players_to_check --;
            }
        }
        check_vlevel ++;
    }
    return list;
}


//Weapon Selector
weaponSelectorConfirmSelection_Weapon(weaponId)
{
    self setMenuVar("weapon_selector_confirmed_weapon",weaponId);
    self setMenuVar("weapon_selector_destroy_hud_on_menu_load",false);
    self _loadMenu("weapon_selector_attachments");
}
weaponSelectorConfirmSelection_Attachment(attachmentId)
{
    self setMenuVar("weapon_selector_confirmed_attachment",attachmentId);
    weapon = self getMenuVar("weapon_selector_confirmed_weapon");
    if(getWeaponClass(weapon+"_mp") == "weapon_smg"||getWeaponClass(weapon+"_mp") == "weapon_assault"||getWeaponClass(weapon+"_mp") == "weapon_sniper"||getWeaponClass(weapon+"_mp") == "weapon_lmg")
    {
        self setMenuVar("weapon_selector_destroy_hud_on_menu_load",false);
        self _loadMenu("weapon_selector_camos");
    }
    else
    {
        self weaponSelector_giveWeapon(self getMenuVar("weapon_selector_confirmed_weapon"),self getMenuVar("weapon_selector_confirmed_attachment"),self getMenuVar("weapon_selector_confirmed_camo"));
    }
}
weaponSelectorConfirmSelection_Camo(camoId)
{
    self setMenuVar("weapon_selector_confirmed_camo",camoId);
    self weaponSelector_giveWeapon(self getMenuVar("weapon_selector_confirmed_weapon"),self getMenuVar("weapon_selector_confirmed_attachment"),self getMenuVar("weapon_selector_confirmed_camo"));
}
weaponSelector_giveWeapon(weaponId = "none",attachmentId = "none",camoId = "none")
{
    if(weaponId!="none")
    {
        if(attachmentId=="none")
        {
            weapon = weaponId + "_mp";
        }
        else
        {
            weapon = weaponId + "_" + attachmentId + "_mp";
        }
        if(attachmentId=="akimbo")
        {
            self _giveWeapon(weapon,int(getCamoNumber(camoId)),true);
        }
        else
        {
            self _giveWeapon(weapon,int(getCamoNumber(camoId)));
        }
        self freezeControls(false);
        self switchToWeapon(weapon);
        self _loadMenu("weapon_selector_menu");
    }
}


//AYS - Are You Sure
startAYS(info,func = undefined,in1 = undefined,in2 = undefined,in3 = undefined)
{
    if(isDefined(info))
    {
        info_text = strTok(info,";");
        bg_height = 70 + (info_text.size*20);
    }
    else
    {
        info_text = undefined;
        bg_height = 70;
    }
    self setMenuVar("ays_selected_func",func);
    self setMenuVar("ays_selected_input1",in1);
    self setMenuVar("ays_selected_input2",in2);
    self setMenuVar("ays_selected_input3",in3);
    self changeMenuHudForEditorOrWhatever();
    wait .4;
    self setMenuVar("menu_controls","ays");
    self setMenuVar("ays_selected","Yes");//Yes or No
    if(self getMenuVar("menu_bg_style")=="none")
    {
        alpha = (1/1.75);
    }
    else
    {
        alpha = 0.25;
    }
    self.Hud["AYS_BG"] = createRectangle("CENTER","CENTER",700,0,300,bg_height,(0,0,0),alpha,"white");
    self.Hud["AYS_BG"] elemSetSort(3);
    
    self.Hud["AYS_Title"] = createText("hudBig",1.0,"CENTER","CENTER",700,0,(1,1,1),1,(0,0,0),0,"Are You Sure?");
    self.Hud["AYS_Title"].y = (5+(self.Hud["AYS_Title"].height/2))-(self.Hud["AYS_BG"].height/2);
    self.Hud["AYS_Title"] elemSetSort(4);
    
    self.Hud["AYS_No_Button_Text"] = createText("hudBig",1.0,"CENTER","CENTER",700,0,(1,1,1),1,(0,0,0),0,"NO");
    self.Hud["AYS_No_Button_Text"].y = -5+(self.Hud["AYS_BG"].height/2)-(self.Hud["AYS_No_Button_Text"].height/2);
    self.Hud["AYS_No_Button_Text"] elemSetSort(5);
    
    self.Hud["AYS_Yes_Button_Text"] = createText("hudBig",1.0,"CENTER","CENTER",700,0,(1,1,1),1,(0,0,0),0,"YES");
    self.Hud["AYS_Yes_Button_Text"].y = self.Hud["AYS_No_Button_Text"].y - 25;
    self.Hud["AYS_Yes_Button_Text"] elemSetSort(5);
    
    self.Hud["AYS_Scrollbar"] = createRectangle("CENTER","CENTER",700,self.Hud["AYS_Yes_Button_Text"].y-1,300,20,(0,0,0),1,"white");
    self.Hud["AYS_Scrollbar"] elemSetSort(4);

    self.Hud["AYS_Info_Text"] = [];
    for(i=0;i<info_text.size;i++)
    {
        self.Hud["AYS_Info_Text"][i] = createText("default",1.5,"CENTER","CENTER",700,(self.Hud["AYS_Title"].y+(20))+(18*i),(1,1,1),1,(0,0,0),0,info_text[i]);
        self.Hud["AYS_Info_Text"][i] elemSetSort(4);
    }
    self.Hud["AYS_BG"] elemMoveOverTimeX(.4,0);
    self.Hud["AYS_Title"] elemMoveOverTimeX(.4,0);
    self.Hud["AYS_No_Button_Text"] elemMoveOverTimeX(.4,0);
    self.Hud["AYS_Yes_Button_Text"] elemMoveOverTimeX(.4,0);
    self.Hud["AYS_Scrollbar"] elemMoveOverTimeX(.4,0);
    foreach(text in self.Hud["AYS_Info_Text"])
    {
        text elemMoveOverTimeX(.4,0);
    }
    wait .5;
    self scrollAYS();
}
endAYS()
{
    self.Hud["AYS_BG"] elemMoveOverTimeX(.4,700);
    self.Hud["AYS_Title"] elemMoveOverTimeX(.4,700);
    self.Hud["AYS_No_Button_Text"] elemMoveOverTimeX(.4,700);
    self.Hud["AYS_Yes_Button_Text"] elemMoveOverTimeX(.4,700);
    self.Hud["AYS_Scrollbar"] elemMoveOverTimeX(.4,700);
    foreach(text in self.Hud["AYS_Info_Text"])
    {
        text elemMoveOverTimeX(.4,700);
    }
    wait .5;
    self.Hud["AYS_BG"] destroy();
    self.Hud["AYS_Title"] destroy();
    self.Hud["AYS_No_Button_Text"] destroy();
    self.Hud["AYS_Yes_Button_Text"] destroy();
    self.Hud["AYS_Scrollbar"] destroy();
    foreach(text in self.Hud["AYS_Info_Text"])
    {
        text destroy();
    }
    
    self changeMenuHudForEditorOrWhatever(false);
    self setMenuVar("menu_controls","menu");
}
scrollAYS()
{
    if(self getMenuVar("ays_selected")=="Yes")
    {
        self.Hud["AYS_Scrollbar"] elemMoveOverTimeY(0.170,self.Hud["AYS_Yes_Button_Text"].y-1);
        self.Hud["AYS_Yes_Button_Text"] thread elemBlink();
        self.Hud["AYS_No_Button_Text"] notify("Update_Blink");
        self.Hud["AYS_No_Button_Text"].alpha = 1;
    }
    else
    {
        self.Hud["AYS_Scrollbar"] elemMoveOverTimeY(0.170,self.Hud["AYS_No_Button_Text"].y+1);
        self.Hud["AYS_No_Button_Text"] thread elemBlink();
        self.Hud["AYS_Yes_Button_Text"] notify("Update_Blink");
        self.Hud["AYS_Yes_Button_Text"].alpha = 1;
    }
}



//Random Stuff
setMenuHudDvars(menu_opened)
{
    if(menu_opened)
    {
        self setClientDvar("g_hardcore",1);
        //self setClientDvar("hud_drawHud",0);
        self setClientDvar("cg_crosshairAlpha",0);
        if(self getMenuVar("menu_bg_style")=="ingame")
        {
            self setBlurForPlayer(7,.2);
        }
    }
    else
    {
        self setClientDvar("g_hardcore",0);
        //self setClientDvar("hud_drawHud",1);
        self setClientDvar("cg_crosshairAlpha",1);
        if(self getMenuVar("menu_bg_style")=="ingame")
        {
            self setBlurForPlayer(0,.2);
        }
    }
}

changeBackgroundStyle(style)
{
    if(self getMenuVar("menu_bg_style")==style)
    {
        return;
    }
    self _closeMenu();
    wait 0.05;
    self setMenuVar("menu_bg_style",style);
    wait .2;
    self _openMenu();
}

changeMenuHudForEditorOrWhatever(remove = true)
{
    if(remove)
    {
        self destroyMenuElems();
        self.Hud["Side_BG"] elemMoveOverTimeX(.2,-700);
        self.Hud["Title_Text"] elemMoveOverTimeX(.2,-700);
        wait .3;
        self.Hud["Side_BG"] destroy();
        self.Hud["Title_Text"] destroy();
    }
    else
    {
        self.Hud["Side_BG"] = createRectangle("CENTER","CENTER",-447,0,600,1000,(0,0,0),0,"gradient_fadein_fadebottom");
        self.Hud["Side_BG"] elemSetSort(3);
        if(self getMenuVar("menu_bg_style")=="none")
        {
            self.Hud["Side_BG"].fadeToAlpha = (1/1.75);
        }
        else
        {
            self.Hud["Side_BG"].fadeToAlpha = 0.25;
        }
        self.Hud["Title_Text"] = createText("hudBig",1.0,"RIGHT","TOP",self.Hud["Side_BG"].x+298,12,(1,1,1),0,(1,0,0),0,self.Menu[self getCurrentMenu()].title);
        self.Hud["Title_Text"] elemSetSort(5);
        self.Hud["Title_Text"].fadeToAlpha = 1;
        self fadeMenuElem(self.Hud["Side_BG"],.2);
        self fadeMenuElem(self.Hud["Title_Text"],.2);
        wait .3;
        self createMenuElems();
        self _scrollMenu();
    }
}


toggleMenuWaterMark()
{
    if(!level.reflex_watermark_active)
    {
        level.reflex_watermark_active    = true;
        level.reflex_watermark           = createServerText("objective",1.5,"","",-15,0,(1,1,1),1,(0,0,0),0,"");
        level.reflex_watermark.horzAlign = "right";
        level.reflex_watermark.vertAlign = "top";
        level.reflex_watermark _setText("R3FLEX V3["+level.MOD_VERSION_STRING+"]");
        level.reflex_watermark elemSetSort(666);
        level.reflex_watermark thread elemColorEffect();
    }
    else
    {
        level.reflex_watermark_active = false;
        level.reflex_watermark notify("end_smooth_flash");
        level.reflex_watermark destroy();
    }
}


//TableLookUp Stuff
getRankString(rank_num)
{
    return tableLookupIString("mp/rankTable.csv",0,rank_num,5);
}
getRankShader(rank_num)
{
    return tableLookup("mp/rankTable.csv",0,rank_num,6);
}
getPrestigeShader(pres_num)
{
    return tableLookup("mp/rankIconTable.csv",0,0,1+pres_num);
}
getWeaponShader(base_weapon)
{
    tableRow  = tableLookup("mp/statstable.csv",4,base_weapon,0);
    weaponPic = tableLookup("mp/statsTable.csv",0,tableRow,6);
    return weaponPic;
}
getWeaponNameString(base_weapon)
{
    tableRow         = tableLookup("mp/statstable.csv",4,base_weapon,0);
    weaponNameString = tableLookupIString("mp/statstable.csv",0,tableRow,3);
    return weaponNameString;
}
getAttachmentShader(attachmentId)
{
    tableRow      = tableLookup("mp/attachmentTable.csv",4,attachmentId,0);
    attachmentPic = tableLookup("mp/attachmentTable.csv",0,tableRow,6);
    return attachmentPic;
}
getAttachmentNameString(attachmentId)
{
    tableRow             = tableLookup("mp/attachmentTable.csv",4,attachmentId,0);
    attachmentNameString = tableLookupIString("mp/attachmentTable.csv",0,tableRow,3);
    return attachmentNameString;
}
getAttachmentList(base_weapon)
{
    list     = [];
    tableRow = tableLookup("mp/statstable.csv",4,base_weapon,0);
    for(i=0;i<10;i++)
    {
        attachment = tableLookup("mp/statsTable.csv",0,tableRow,11+i);
        for(l=0;l<level.pix_attachmentList.size;l++)
        {
            if((attachment!="") && (attachment==level.pix_attachmentList[l].id))
            {
                size = list.size;
                list[size] = attachment;
            }
        }
    }
    return list;
}
getCamoNumber(camoId)
{
    camoNumber = tableLookup("mp/camoTable.csv",1,camoId,0);
    return camoNumber;
}
getCamoShader(camoId)
{
    camoPic = tableLookup("mp/camoTable.csv",1,camoId,4);
    return camoPic;
}
getCamoNameString(camoId)
{
    camoNameString = tableLookupIString("mp/camoTable.csv",1,camoId,2);
    return camoNameString;
}