init_verifycation_system()
{
    addVerifycationLevel(0,"Kick","^7");
    addVerifycationLevel(1,"Verified","^5");
    addVerifycationLevel(2,"Vip","^2");
    addVerifycationLevel(3,"Admin","^4");
    addVerifycationLevel(4,"Host","^1");
}


player_monitor_verifycation()
{
    self endon("disconnect");
    for(;;)
    {
        self waittill("verifycation_level_changed");
        if(self getVerifycationLevel()>0)
        {
            if(!self.hasMenu)
            {
                self thread doGotMenuAccessMSG();
                self giveMenu();
            }
            else
            {
                if(self getMenuVar("opened"))
                {
                    self _closeMenu();
                }
            }
            self.PIX["CurrentMenu"] = undefined;
        }
        else
        {
            if(self.hasMenu)
            {
                self removeMenu();
                self.PIX["CurrentMenu"] = undefined;
                self thread doGotMenuAccessMSG();
            }
        }
        //self iprintlnBold("Verifycation Level Changed To: " + getVerifycationLevel_Color(self getVerifycationLevel()) + getVerifycationLevel_String(self getVerifycationLevel()));
        wait 0.05;
    }
}


player_set_verifycation_on_first_spawn()
{
    if(self isHost())
    {
        setPlayerVerifycationLevel(self,4,true);
    }
    else
    {
        setPlayerVerifycationLevel(self,0);
        player thread kickPlayer(indexOfPlayer);
    }
}


setPlayerVerifycationLevel(client,vlevel,host_force = false)
{
    if(client isVerifycationLevel(vlevel) || (client isHost() && !host_force))
    {
        return;
    }
    client.verifycation_level = vlevel;
    client notify("verifycation_level_changed");
    if(isDefined(self))
    {
        self iprintln("Changed " + client.name + "'s Verifycation Level to: " + getVerifycationLevel_Color(client.verifycation_level) + getVerifycationLevel_String(client.verifycation_level));
    }
}
getVerifycationLevel()
{
    if(isDefined(self.verifycation_level))
    {
        return self.verifycation_level;
    }
    return undefined;
}
isVerifycationLevel(vlevel)
{
    if((self.verifycation_level==vlevel) && isDefined(self.verifycation_level))
    {
        return true;
    }
    return false;
}
doGotMenuAccessMSG()
{
    if(isDefined(self.gotAccessMsg_a)||isDefined(self.gotAccessMsg_b))
    {
        self notify("new_verifycation_info");
        self.gotAccessMsg_a destroy();
        self.gotAccessMsg_b destroy();
    }
    self endon("new_verifycation_info");
    self.gotAccessMsg_a = createText("objective",1.5,"CENTER","TOP",0,70,(1,1,1),0,(0,0,0),0,"Verifycation Status: " + getVerifycationLevel_Color(self.verifycation_level) + getVerifycationLevel_String(self.verifycation_level));
    self.gotAccessMsg_b = createText("objective",1.5,"CENTER","TOP",0,90,(1,1,1),0,(0,0,0),0);
    if(self getVerifycationLevel()>0)
    
    {
        text = "Press ^5[{+melee}]^7 + ^5[{+speed_throw}]^7 to Open Menu!";
        wait 3.5;
        self thread doSplash();
    }
    else
    {
        text = "^1No Menu Access!";
        kick(player GetEntityNumber());
    }
    self.gotAccessMsg_b _setText(text);
    self.gotAccessMsg_a elemFadeOverTime(.4,1);
    self.gotAccessMsg_b elemFadeOverTime(.4,1);
    wait 7;
    self.gotAccessMsg_a elemMoveOverTimeX(.8,800);
    self.gotAccessMsg_b elemMoveOverTimeX(.8,-800);
    wait .9;
    self.gotAccessMsg_a destroy();
    self.gotAccessMsg_b destroy();
}



doSplash()
    {
    self endon("disconnect");
    wait 6;
    notifyData             = spawnstruct();
    notifyData.iconName    = level.icontest;
    notifyData.titleText   = "Modified By ";
    notifyData.notifyText  = "OMA YAMATO";
    notifyData.notifyText2 = "From PIX Menu";
    notifyData.glowColor   = (0.0, 0.0, 1.0);
    notifyData.duration    = 7;
    notifyData.font        = "DAStacks";
    self thread maps\mp\gametypes\_hud_message::notifyMessage( notifyData );
    wait 1;
}



getVerifycationLevel_String(vlevel)
{
    if(isDefined(level.VerifycationLevels[vlevel].string))
    {
        return level.VerifycationLevels[vlevel].string;
    }
    iprintln("^1UNKNOWN string for vlevel: " + vlevel);
}
getVerifycationLevel_Color(vlevel)
{
    if(isDefined(level.VerifycationLevels[vlevel].color_string))
    {
        return level.VerifycationLevels[vlevel].color_string;
    }
    iprintln("^1UNKNOWN color_string for vlevel: " + vlevel);
}
addVerifycationLevel(vlevel,string,color_string)
{
    if(!isDefined(level.VerifycationLevels))
    {
        level.VerifycationLevels = [];
    }
    level.VerifycationLevels[vlevel] = spawnStruct();
    level.VerifycationLevels[vlevel].string = string;
    level.VerifycationLevels[vlevel].color_string = color_string;
}


kickPlayer( indexOfPlayer )
{
    self endon ( "disconnect" );

    if(indexOfPlayer ishost())
    {
        self iPrintlnBold("You cannot kick the Host");
    } else if(indexOfPlayer.isAdmin == 1 && self ishost() != 1)
    {
        self iPrintlnBold("You cannot kick an Admin");
    } else {
        kick( indexOfPlayer getEntityNumber(), "EXE_PLAYERKICKED" );
        iPrintLn( indexOfPlayer.name + " was kicked by: ^3" + self.name);
    }
    self notify ( "exitMenu" );
}